Package: ClustAll
Type: Package
Title: ClustAll: Data driven strategy to robustly identify
        stratification of patients within complex diseases
Version: 1.9.0
Authors@R: c(person("Asier", "Ortega-Legarreta", role = c("aut","cre"),  
           email = "aortegal@navarra.es", 
           comment = c(ORCID = "0009-0000-3563-5362")),
           person("Sara", "Palomino-Echeverria", role = c("aut"),  
           email = "spalomie@navarra.es"))
Imports: FactoMineR, bigstatsr, clValid, doSNOW, parallel, foreach,
        dplyr, fpc, mice, modeest, flock, networkD3, methods,
        ComplexHeatmap, cluster, RColorBrewer, circlize, grDevices,
        ggplot2, grid, stats, utils, pbapply
Suggests: RUnit, knitr, BiocGenerics, rmarkdown, BiocStyle, roxygen2
Description: Data driven strategy to find hidden groups of patients with complex
        diseases using clinical data. ClustAll facilitates the unsupervised 
        identification of multiple robust stratifications. ClustAll, is able to 
        overcome the most common limitations found when dealing with clinical 
        data (missing values, correlated data, mixed data types). 
Depends: R (>= 4.2.0)
License: GPL-2
Encoding: UTF-8
biocViews: Software, StatisticalMethod, Clustering, DimensionReduction,
        PrincipalComponent
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Packaged: 2026-04-28 21:56:36 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/ClustAll
git_branch: devel
git_last_commit: 4df6113
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Author: Asier Ortega-Legarreta [aut, cre] (ORCID:
    <https://orcid.org/0009-0000-3563-5362>),
  Sara Palomino-Echeverria [aut]
Maintainer: Asier Ortega-Legarreta <aortegal@navarra.es>

# createClustAll_internal functions definition ---------------------------------
# These functions are not meant to be invoked directly by the user.
# See the createClusteAll function instead.


# This functions checks if the data frame introduced contains character vectors.
# In that case, it transforms them into numerical values assuming they are categorical values.
checkDataIntroduced <- function(data) {
  if (any(sapply(data, is.character))) {
    message("The dataset contains character values.")
    message("They will be transformed into categorical (more than one class) or binary (one class).")
    data_new <- data
    must_convert_variables <- which(sapply(data, is.character))

    if (length(must_convert_variables) == 1) {
      if (isBinary(data[,must_convert_variables])) {
        variables_binary <- must_convert_variables
        variables_categorical <- NULL
      } else {
        variables_binary <- NULL
        variables_categorical <- must_convert_variables
      }
    } else {
      variables_binary <- names(which(sapply(data[,must_convert_variables], isBinary)))
      variables_categorical <- names(which(!sapply(data[,must_convert_variables], isBinary)))
    }

    if (length(variables_binary) == 1) {
      data_new[, variables_binary] <- as.numeric(as.factor(data_new[, variables_binary]))
    } else if (length(variables_binary) > 1) {
      data_new[, variables_binary] <- sapply(data_new[, variables_binary], function(x) as.numeric(as.factor(x)))
    }

    if (length(variables_categorical) > 0) {
      message("Categorical variables detected! Applying One-hot encoding...")

      if (length(variables_categorical) == 1) {
        onehot_variables <- base::names(table(data[, variables_categorical]))

        result <- sapply(onehot_variables, function(new_onehot_variable) {
          temp <- rep(0, nrow(data_new))
          temp[which(data_new[, variables_categorical] == new_onehot_variable)] <- 1
          temp[which(is.na(data_new[, variables_categorical]))] <- NA
          return(temp)
        })

        colnames(result) <- paste0(variables_categorical, "_", colnames(result))
        data_new <- cbind(data_new, result)

        data_new <- subset(data_new,
                           select = -which(colnames(data_new) == variables_categorical))

      } else {

        onehot_columns <- sapply(variables_categorical, function(variable_name) {
          onehot_variables <- unique(data[, variable_name])
          sapply(onehot_variables, function(new_onehot_variable) {
            as.numeric(data[, variable_name] == new_onehot_variable)
          })
        })

        combined_onehot <- do.call(cbind, Map(function(df, name) {
          colnames(df) <- paste(name, colnames(df), sep = "_")
          return(df)
        }, onehot_columns, names(onehot_columns)))

        data_new <- cbind(data_new, combined_onehot)
        data_new <- subset(data_new,
                           select = -which(colnames(data_new) %in% names(onehot_columns)))
      }
    }
  } else {
    data_new <- data
  }

  message("Before continuing, check that the transformation has been processed correctly.\n")
  return(data_new)
}


# Check if data is binary
isBinary <- function(vector) {
    if (length(table(vector)) == 2) {
        return(TRUE)
    } else {
        return(FALSE)
    }
}


# This functions checks if the vector introduced contains character vectors.
# In that case, it transforms them into numerical values assuming they are
# categorical values.
checkVectorIntroduced <- function(data) {
    if (any(sapply(data, is.character))) {
        message("The dataset contains character values.")
        message("They will be converted to categorical (more than one class) or binary (one class).")
        message("Before continuing, check that the transformation has been processed correctly.\n")

        data_new <- data
        data_new <- as.numeric(as.factor(data_new))

    } else {
        data_new <- data
    }

    return(data_new)
}


# This function checks the number of imputations is valid
validnImputation <- function(nImputation, imputedNull) {
    if (!is.numeric(nImputation) & !is.null(nImputation)) {
        if (imputedNull == FALSE) {
            message("Parameter nImputation is not valid.")
            message("Please introduce a positive number of imputations.")
            stop()
        }
    } else if (is.null(nImputation) & imputedNull == TRUE) {
      nImputation <- 0
    } else if (nImputation < 0) {
        message("Parameter nImputation is not valid.")
        message("Please introduce a positive number of imputations.")
        stop()
    } else if (nImputation %% 1 != 0) { # check it is not float value
        message("The decimal value will be rounded.")
        nImputation <- round(nImputation, digits = 0)
    }

    return(nImputation)
}


# This function checks if the original dataset contains missing values and
# the arguments introduced to createClustAll
validData <- function(data, nImputation, dataImputed) {
    if (anyNA(data) == TRUE & nImputation == 0 & is.null(dataImputed)) {
        message("The dataset contains NA values.")
        message("Specify the number of imputations (nImputation) to be computed.")
        stop()

    } else if (anyNA(data) == FALSE & nImputation > 0 & is.null(dataImputed)) {
        message("The dataset does NOT contain NA values.")
        message("The imputation process will not be applied.")
        return(TRUE)

    } else if (anyNA(data) == FALSE  & !is.null(dataImputed)) {
        message("The dataset does NOT contain NA values.")
        message("The introduced imputed data will not be used.")
        return(TRUE)

    } else {
        return(FALSE)
    }
}


# This function checks that the dataImputed manually is mids class.
# It also checks that ClustALL input data and the data used for imputation
# is the same
validDataImputed <- function(data, dataImputed, dataOriginal) {
    if (is(dataImputed, "mids")) {
        if (identical(data, dataImputed$data) | identical(dataOriginal, dataImputed$data)){
            return(TRUE)

        } else {
          message("The input data and the data used for imputation are different.")
          message("Please, make sure you are using the same.")
          stop()
        }

    } else {
        message("You must introduce mice::mice function output.")
        message("For more information visit https://cran.r-project.org/web/packages/mice/index.html.")
        stop()
    }
}


checkColumn <- function(data, colValidation) {
    if (!is(colValidation, "character")) {
        message("Please introduce the column name correctly.")
        stop()
    }
    if (!colValidation %in% colnames(data)) {
        message("The introduced column name is not present in the dataset.")
        message("Please, make sure to introduce it correctly.")
        stop()
    }
}
# END OF ClustAll_createClustAll_internal.R

# setClassUnion includes the new classes defined -------------------------------

#' @title Class Union: listOrNULL
#' @aliases listOrNULL-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a list, NULL, or a missing value. It is
#' particularly useful when a slot or function parameter might contain a
#' list of elements but could also be empty or unspecified.
#'
#' @details
#' The listOrNULL class union includes:
#' \itemize{
#'   \item list: A standard R list object
#'   \item NULL: Representing an empty or unset value
#'   \item missing: Allowing for unspecified parameters in function calls
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might return a list of results or NULL if no results are available
#'   \item A slot in an S4 object could contain a list of elements or be empty
#'   \item A function parameter could accept a list of options, but also work with default settings if nothing is provided
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
setClassUnion("listOrNULL", c("list", "NULL", "missing"))


#' @title Class Union: numericOrNA
#' @aliases numericOrNA-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a numeric value, NULL, or a missing value.
#' It is particularly useful when a slot or function parameter might contain
#' a numeric value but could also be empty, unspecified, or explicitly set to NULL.
#'
#' @details
#' The numericOrNA class union includes:
#' \itemize{
#'   \item numeric: A standard R numeric value or vector
#'   \item NULL: Representing an empty or unset value
#'   \item missing: Allowing for unspecified parameters in function calls
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might return a numeric result or NULL if no result is available
#'   \item A slot in an S4 object could contain a numeric value or be empty
#'   \item A function parameter could accept a numeric input, but also work with default settings if nothing is provided
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
setClassUnion("numericOrNA", c("numeric", "missing", "NULL"))



#' @title Class Union: characterOrNA
#' @aliases characterOrNA-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a character value, NULL, or a missing value.
#' It is particularly useful when a slot or function parameter might contain
#' a character string but could also be empty, unspecified, or explicitly set to NULL.
#'
#' @details
#' The characterOrNA class union includes:
#' \itemize{
#'   \item character: A standard R character string or vector
#'   \item NULL: Representing an empty or unset value
#'   \item missing: Allowing for unspecified parameters in function calls
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might return a character result or NULL if no result is available
#'   \item A slot in an S4 object could contain a character value or be empty
#'   \item A function parameter could accept a character input, but also work with default settings if nothing is provided
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
setClassUnion("characterOrNA", c("character", "missing", "NULL"))


#' @title Class Union: logicalOrNA
#' @aliases logicalOrNA-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a logical value, NULL, or a missing value.
#' It is particularly useful when a slot or function parameter might contain
#' a boolean flag but could also be empty, unspecified, or explicitly set to NULL.
#'
#' @details
#' The logicalOrNA class union includes:
#' \itemize{
#'   \item logical: A standard R logical value (TRUE or FALSE)
#'   \item NULL: Representing an empty or unset value
#'   \item missing: Allowing for unspecified parameters in function calls
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might return a logical result or NULL if no result is available
#'   \item A slot in an S4 object could contain a logical flag or be empty
#'   \item A function parameter could accept a logical input, but also work with default settings if nothing is provided
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
setClassUnion("logicalOrNA", c("logical", "missing", "NULL"))



#' @title Class Union: matrixOrNULL
#' @aliases matrixOrNULL-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a matrix or NULL. It is particularly useful
#' when a slot or function parameter might contain a matrix of data but could
#' also be empty or explicitly set to NULL.
#'
#' @details
#' The matrixOrNULL class union includes:
#' \itemize{
#'   \item matrix: A standard R matrix object
#'   \item NULL: Representing an empty or unset value
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might return a matrix of results or NULL if no results are available
#'   \item A slot in an S4 object could contain a matrix of data or be empty
#'   \item A function parameter could accept a matrix input, but also work with default settings if nothing is provided
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
setClassUnion("matrixOrNULL", c("matrix", "NULL"))



#' @title Class Union: numericOrCharacter
#' @aliases numericOrCharacter-class
#' @description
#' This class union allows for flexibility in method signatures and slot
#' definitions by accepting either a numeric or character value. It is particularly
#' useful when a slot or function parameter might contain either numeric data
#' or character strings representing numbers or categories.
#'
#' @details
#' The numericOrCharacter class union includes:
#' \itemize{
#'   \item numeric: A standard R numeric value or vector
#'   \item character: A standard R character string or vector
#' }
#'
#' This union is useful in scenarios where:
#' \itemize{
#'   \item A function might accept or return either numeric values or their string representations
#'   \item A slot in an S4 object could contain either numeric data or categorical labels
#'   \item A function needs to handle both numeric and character input flexibly
#' }
#'
#' @seealso \code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
numericOrCharacter <- setClassUnion("numericOrCharacter",
                                    c("numeric", "character"))

# ClustAllObject Class ---------------------------------------------------------
#' @title ClustAllObject
#' @aliases ClustAllObject-class
#' @description
#' The ClustAllObject class is the central data structure of the ClustAll
#' package, designed to store and manage data and results throughout the patient
#' stratification process. It encapsulates the original data, preprocessed data,
#' imputation results, and clustering outcomes, providing a cohesive framework
#' for the entire ClustALL workflow.
#' @slot data A data frame containing the preprocessed input data after applying
#' one-hot encoding to categorical variables and removing the validation column
#' (if present). This is the data used directly in the clustering process.
#' @slot dataOriginal A data frame containing the original, unmodified input data
#' as provided to \code{\link{createClustAll}}. This preserves the initial state
#' of the data for reference and validation purposes.
#' @slot dataImputed If imputation was applied, this slot contains a 'mids' object
#' from the mice package with the imputed datasets. If no imputation was performed,
#' this is NULL.
#' @slot dataValidation A numeric vector containing the reference labels (true labels)
#' of the original dataset, if provided. These labels are used for validation purposes
#' and are not used in the stratification process itself. NULL if no validation data
#' is available.
#' @slot nImputation An integer indicating the number of imputations to be
#' computed. It should be set to 0 if the dataset is already completed, or if it
#' the dataset has been imputed out of ClustAll framework.
#' @slot processed A logical flag. TRUE if \code{\link{runClustAll}} has been
#' executed on the object, FALSE otherwise. Indicates whether the object contains
#' stratification results.
#' @slot summary_clusters A list containing the resulting stratifications for each
#' combination of clustering methods (distance metric + clustering algorithm) and
#' embedding depth. This is populated after \code{\link{runClustAll}} has been
#' executed. NULL otherwise.
#' @slot JACCARD_DISTANCE_F A matrix of Jaccard distances between the robust
#' stratifications that passed the bootstrapping process. Used to assess similarity
#' between different stratification solutions. NULL if \code{\link{runClustAll}}
#' has not been executed.
#' @details
#' The ClustAllObject is designed to efficiently manage all aspects of the data
#' and results throughout the ClustAll pipeline:
#' \itemize{
#'   \item It preserves the original data while storing preprocessed versions for analysis.
#'   \item It handles missing data through multiple imputation, storing both original and imputed datasets.
#'   \item It maintains separation between data used for clustering and validation data.
#'   \item It stores all generated stratifications and identifies robust solutions.
#'   \item It provides a framework for comparing different stratification solutions.
#' }
#' This structure allows for a streamlined workflow from data input through
#' preprocessing, imputation (if needed), stratification, and final analysis of
#' results.
#'
#' @note
#' The ClustAllObject is typically created using the
#' \code{\link{createClustAll}} function and processed using
#' \code{\link{runClustAll}}. Direct manipulation of the object's slots is not
#' recommended as it may lead to inconsistencies in the analysis pipeline.
#'
#'
#' @return ClustAllObject class object.
#' @exportClass ClustAllObject
setClass(
  Class="ClustAllObject",
  slots=list(
    data="data.frame",
    dataOriginal="data.frame",
    dataImputed="ANY",
    dataValidation="numericOrNA",
    nImputation ="numeric",
    processed="logical",
    summary_clusters="listOrNULL",
    JACCARD_DISTANCE_F="matrixOrNULL"
  )
)


# ClustAllObject constructor
#' constuctor for \code{\link{ClustAllObject-class}}
#' @title initializeClustAllObject
#' @param .Object initializing object
#' @param data Data Frame of the input data after applying one-hot encoding to the
#' categorical variables and extracting the validation (true label) column.
#' @param dataOriginal Data Frame of the input data.
#' @param dataImputed  Mids object derived from the mice package that stores the
#' imputed data, in case imputation was applied. Otherwise NULL.
#' @param dataValidation A vector in the case there is a validation (true label)
#' column in the input data. This information can be added later with
#' \code{\link{addValidationData}}. Otherwise NULL.
#' @param nImputation Number of imputations performed.
#' @param processed A boolean. TRUE if \code{\link{runClustAll}} has been
#' executed. Otherwise FALSE.
#' @param summary_clusters List with the resulting stratifications
#' for each combination of clustering methods (distance + clustering algorithm)
#' and depth, in case \code{\link{runClustAll}} has been executed previously.
#' Otherwise NULL.
#' @param JACCARD_DISTANCE_F Matrix containing the Jaccard distances derived from
#' the robust stratifications after applying the bootstrapping if
#' \code{\link{runClustAll}} has been executed previously. Otherwise NULL.
#' @return ClustAllObject class object.
#'
setMethod(
  f="initialize",
  signature="ClustAllObject",
  function(.Object,
           data,
           dataOriginal,
           dataImputed,
           dataValidation,
           nImputation,
           processed,
           summary_clusters,
           JACCARD_DISTANCE_F) {
    .Object@data <- data
    .Object@dataOriginal <- data
    .Object@dataImputed <- dataImputed
    .Object@nImputation <- nImputation
    .Object@dataValidation <- dataValidation
    .Object@processed <- FALSE
    .Object@summary_clusters <- NULL
    .Object@JACCARD_DISTANCE_F <- NULL
    validObject(.Object)

    return(.Object)
  }
)


# ClustAllObject MEMBER ACCESS METHODS -----------------------------------------

#' @title Display Summary of ClustAllObject
#' @aliases show,ClustAllObject-method
#' @description
#' This method provides a concise summary of a ClustAllObject, displaying key
#' information about its contents and processing status. It offers a quick
#' overview of the object's characteristics without the need to inspect
#' individual slots.
#'
#' @param object A \code{\link{ClustAllObject-class}} object to be summarized.
#'
#' @return No return value, called for printing to the console.
#'
#' @details
#' The show method for ClustAllObject displays the following information:
#'
#' \enumerate{
#'   \item Object Class: Confirms that the object is of class ClustAllObject.
#'
#'   \item Data Dimensions:
#'   \itemize{
#'     \item Number of variables (columns) in the processed data.
#'     \item Number of patients (rows) in the dataset.
#'   }
#'
#'   \item Imputation Status:
#'   \itemize{
#'     \item Indicates whether the data has been imputed.
#'     \item If imputed, shows the number of imputations performed.
#'   }
#'
#'   \item Processing Status:
#'   \itemize{
#'     \item Indicates whether the ClustALL algorithm has been run on the object.
#'   }
#'
#'   \item Stratification Results:
#'   \itemize{
#'     \item If processed, displays the number of stratifications generated.
#'     \item If not processed, indicates that stratification results are not available.
#'   }
#' }
#'
#' This method is particularly useful for:
#' \itemize{
#'   \item Quick verification of object contents after creation or modification.
#'   \item Checking the processing status before running analyses.
#'   \item Confirming the number of stratifications generated after running the ClustALL algorithm.
#'   \item Easily sharing key object characteristics in reports or discussions.
#' }
#'
#' @note
#' \itemize{
#'   \item This method is automatically called when the object name is entered at the R console.
#'   \item It provides a high-level overview and does not display detailed data or results.
#'   \item For more detailed information about specific aspects of the object, use
#'     dedicated accessor methods or examine individual slots directly.
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{runClustAll}},
#' \code{\link{ClustAllObject-class}}
#'
#' @export
setMethod("show", "ClustAllObject", function(object) {

    cat(is(object)[[1]], "\n",
        "Data: Number of variables: ",ncol(object@data),
        ". Number of patients: ", nrow(object@data), "\n",
        "Imputated: ", ifelse(is.null(object@dataImputed), "NO.", "YES."),
        "\nNumber of imputations: ", object@nImputation, "\n",
        "Processed: ", object@processed, "\n",
        "Number of stratifications: ", ifelse(object@processed,
                                             nrow(object@JACCARD_DISTANCE_F),
                                             "NULL"), "\n", sep = ""
    )
  }
)

#' @title Retrieve Processed Data from ClustAllObject
#' @aliases showData,ClustAllObject-method
#' @description
#' This method extracts and returns the processed data stored in a ClustAllObject.
#' The data returned is the version used for clustering analysis, which has undergone
#' preprocessing steps such as one-hot encoding for categorical variables and
#' removal of the validation column (if present).
#'
#' @usage showData(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#'
#' @return A data frame containing the processed data used for clustering analysis.
#' This data reflects all preprocessing steps applied during object creation but
#' does not include any imputation that may have been performed.
#'
#' @details
#' The showData method provides access to the core dataset used in the ClustALL
#' analysis pipeline. Key aspects of this data include:
#'
#' \enumerate{
#'   \item Preprocessing Applied:
#'   \itemize{
#'     \item Categorical variables have been converted to numeric form via one-hot encoding.
#'     \item The validation column (if specified during object creation) has been removed.
#'   }
#'
#'   \item Data Structure:
#'   \itemize{
#'     \item All columns are numeric, suitable for use in clustering algorithms.
#'     \item Row order corresponds to the original input data.
#'   }
#'
#'   \item Missing Data:
#'   \itemize{
#'     \item The returned data may still contain missing values (NAs) if imputation
#'           was not performed.
#'     \item For imputed versions of the data, use the \code{\link{dataImputed}} method.
#'   }
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{dataOriginal}},
#' \code{\link{dataImputed}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
#' showData(obj_noNA)
#' @export
setGeneric(
  name="showData",
  def=function(Object){standardGeneric("showData")}
)

setMethod(
  f="showData",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@data}
)

#' @title Retrieve Original Unprocessed Data from ClustAllObject
#' @aliases dataOriginal,ClustAllObject-method
#' @description
#' This method extracts and returns the original, unmodified data that was used
#' to create the ClustAllObject. It provides access to the raw input data before
#' any preprocessing steps were applied, including one-hot encoding, validation
#' column removal, or imputation.
#'
#' @usage dataOriginal(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#'
#' @return A data frame containing the original, unprocessed input data exactly
#' as it was provided when creating the ClustAllObject.
#'
#' @details
#' The dataOriginal method serves as a reference point for the initial state of
#' the data in the ClustALL analysis pipeline. Key aspects of this data include:
#'
#' \enumerate{
#'   \item Data Integrity:
#'   \itemize{
#'     \item Contains all original variables, including any that may have been removed
#'           or transformed during preprocessing.
#'     \item Preserves original data types (e.g., factors for categorical variables).
#'     \item Includes the validation column if it was present in the original data.
#'   }
#'
#'   \item Missing Data:
#'   \itemize{
#'     \item Reflects the original state of missing values (NAs) in the dataset.
#'   }
#'
#'   \item Data Structure:
#'   \itemize{
#'     \item Maintains the original row and column order of the input data.
#'     \item No transformations or encodings have been applied.
#'   }
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{showData}},
#' \code{\link{dataImputed}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
#' dataOriginal(obj_noNA)
#' @export
setGeneric(
  name="dataOriginal",
  def=function(Object){standardGeneric("dataOriginal")}
)

setMethod(
  f="dataOriginal",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@dataOriginal}
)

#' @title Retrieve Imputed Data from ClustAllObject
#' @aliases dataImputed,ClustAllObject-method
#' @description
#' This method extracts and returns the imputed datasets stored in a ClustAllObject.
#' It provides access to the multiple imputed versions of the data generated to
#' handle missing values, if imputation was conducted and included in the object.
#'
#' @usage dataImputed(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#'
#' @return A 'mids' object from the mice package containing the imputed datasets.
#' If no imputation was performed, the method returns NULL.
#'
#' @details
#' The dataImputed method provides access to the imputed data used in the ClustALL
#' analysis pipeline when missing values are present. Key aspects of this data include:
#'
#' \enumerate{
#'   \item Imputation Structure:
#'   \itemize{
#'     \item Returns a 'mids' object, which contains multiple imputed datasets.
#'     \item Each imputed dataset is a complete version of the original data with
#'           missing values filled in.
#'     \item The number of imputed datasets corresponds to the 'nImputation' parameter.
#'   }
#'
#'   \item Imputation Method:
#'   \itemize{
#'     \item Imputation is performed using the mice (Multivariate Imputation by Chained
#'           Equations) package.
#'     \item The specific imputation methods used for each variable can be examined
#'           in the returned 'mids' object.
#'   }
#'
#'   \item Data Consistency:
#'   \itemize{
#'     \item The imputed datasets maintain the same structure (rows and columns) as
#'           the original data.
#'     \item Only variables with missing values are imputed; complete variables remain unchanged.
#'   }
#' }#'
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{showData}},
#' \code{\link{dataOriginal}}, \code{\link{ClustAllObject-class}},
#'
#' @examples
#' data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' obj_NA <- createClustAll(data = wdbcNA, colValidation = "Diagnosis",
#'                          dataImputed = wdbcMIDS)
#' dataImputed(obj_NA)
#' @export
setGeneric(
  name="dataImputed",
  def=function(Object){standardGeneric("dataImputed")}
)

setMethod(
  f="dataImputed",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@dataImputed}
)


#' @title Retrieve Number of Imputations from ClustAllObject
#' @aliases nImputation,ClustAllObject-method
#' @description
#' This method returns the number of imputations performed when creating or
#' processing the ClustAllObject. It provides information about how missing data
#' was handled in the ClustALL pipeline.
#'
#' @usage nImputation(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#'
#' @return An integer indicating the number of imputations performed. Returns 0
#' if no imputations were required or performed.
#'
#' @details
#' The nImputation method provides insight into the multiple imputation strategy
#' used in the ClustALL analysis pipeline:
#'
#' This method is particularly useful for:
#' \itemize{
#'   \item Verifying whether imputation was performed on the dataset.
#'   \item Understanding the extent of the imputation process.
#'   \item Assessing the potential impact of imputation on subsequent analyses.
#'   \item Reporting the methodology used in handling missing data.
#' }
#'
#' @note
#' \itemize{
#'   \item This method returns the value stored in the 'nImputation' slot of the ClustAllObject.
#'   \item A return value of 0 does not necessarily mean the original data had no
#'     missing values; it could also indicate that imputation was explicitly skipped.
#'   \item The number of imputations is typically set during the creation of the
#'     ClustAllObject with the \code{\link{createClustAll}} function.
#'   \item For accessing the actual imputed datasets, use the \code{\link{dataImputed}} method.
#' }#'
#' @seealso \code{\link{createClustAll}}, \code{\link{dataImputed}},
#' \code{\link{ClustAllObject-class}}, \code{\link[mice]{mice}}
#'
#' @examples
#' data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' obj_NA <- createClustAll(data = wdbcNA, colValidation = "Diagnosis",
#'                          dataImputed = wdbcMIDS)
#' nImputation(obj_NA)
#' @export
setGeneric(
  name="nImputation",
  def=function(Object){standardGeneric("nImputation")}
)

setMethod(
  f="nImputation",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@nImputation}
)


#' @title Retrieve Summary of Clustering Results from ClustAllObject
#' @aliases summary_clusters,ClustAllObject-method
#' @description
#' This method extracts and returns a comprehensive summary of all clustering
#' results (stratifications) generated by the ClustALL algorithm. It provides
#' access to the complete set of clustering solutions, including both robust
#' and non-robust stratifications.
#'
#' @usage summary_clusters(Object)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this method.
#'
#' @return A list where each element represents a stratification. Each stratification
#' is a vector of cluster assignments for each sample in the dataset. Returns NULL
#' if \code{\link{runClustAll}} has not been executed on the object.
#'
#' @details
#' The summary_clusters method provides access to all clustering results generated
#' during the ClustALL analysis:
#'
#' \enumerate{
#'   \item Comprehensive Results:
#'   \itemize{
#'     \item Includes all stratifications generated, regardless of their robustness.
#'     \item Each stratification represents a unique combination of data embedding,
#'           distance metric, clustering algorithm, and number of clusters.
#'   }
#'
#'   \item Stratification Structure:
#'   \itemize{
#'     \item Each element in the returned list is named according to the parameters
#'           used to generate it (e.g., "cuts_a_1" for the first cut using method 'a').
#'     \item Each stratification is a vector of integers, where each integer represents
#'           a cluster assignment for a sample.
#'   }
#'
#'   \item Analysis Possibilities:
#'   \itemize{
#'     \item Allows for comparison of different clustering solutions.
#'     \item Enables examination of how different algorithm parameters affect clustering outcomes.
#'     \item Facilitates identification of consistent patterns across multiple stratifications.
#'   }
#' }
#'
#' This method is particularly useful for:
#' \itemize{
#'   \item Accessing the full range of clustering solutions for in-depth analysis.
#'   \item Comparing robust stratifications (identified by other methods) with the full set of results.
#'   \item Extracting specific stratifications for further analysis or visualization.
#' }
#'
#' @note
#' \itemize{
#'   \item This method returns the data stored in the 'summary_clusters' slot of the ClustAllObject.
#'   \item It will return NULL if \code{\link{runClustAll}} has not been executed on the object.
#'   \item The returned list includes all stratifications, not just those deemed robust.
#'     For accessing only robust stratifications, consider using the \code{\link{resStratification}} function.
#'   \item The order and naming of stratifications in the returned list correspond to
#'     the order in which they were generated during the ClustALL process.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{resStratification}},
#' \code{\link{JACCARD_DISTANCE_F}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = FALSE)
#' summary_clusters(obj_noNA1)
#' @export
setGeneric(
  name="summary_clusters",
  def=function(Object){standardGeneric("summary_clusters")}
)

setMethod(
  f="summary_clusters",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@summary_clusters}
)


#' @title Retrieve Jaccard Distance Matrix for Robust Stratifications
#' @aliases JACCARD_DISTANCE_F,ClustAllObject-method
#' @description
#' This method extracts and returns the matrix of Jaccard distances between
#' robust stratifications identified by the ClustALL algorithm. It provides a
#' quantitative measure of similarity between different clustering solutions
#' that have passed the bootstrapping process for population-based robustness.
#'
#' @usage JACCARD_DISTANCE_F(Object)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this method.
#'
#' @return A square matrix where each element represents the Jaccard distance
#' between two robust stratifications. The row and column names correspond to
#' the names of the robust stratifications. Returns NULL if \code{\link{runClustAll}}
#' has not been executed on the object.
#'
#' @details
#' The JACCARD_DISTANCE_F method provides crucial information about the similarity
#' structure of robust clustering solutions:
#'
#' \enumerate{
#'   \item Jaccard Distance:
#'   \itemize{
#'     \item A measure of dissimilarity between sample sets, calculated as 1 minus the Jaccard coefficient.
#'     \item Ranges from 0 (identical stratifications) to 1 (completely different stratifications).
#'     \item Lower values indicate higher similarity between stratifications.
#'   }
#'
#'   \item Matrix Structure:
#'   \itemize{
#'     \item Symmetric matrix with stratification names as row and column labels.
#'     \item Diagonal elements are always 0 (each stratification is identical to itself).
#'     \item Off-diagonal elements represent pairwise Jaccard distances.
#'   }
#'
#'   \item Robust Stratifications:
#'   \itemize{
#'     \item Only includes stratifications that passed the bootstrapping process.
#'     \item Represents the most stable and reliable clustering solutions.
#'   }
#' }
#'
#' This method is particularly useful for:
#' \itemize{
#'   \item Identifying groups of similar stratifications.
#'   \item Assessing the diversity of robust clustering solutions.
#'   \item Selecting representative stratifications for further analysis.
#'   \item Visualizing the relationships between different clustering outcomes.
#'   \item Input for further clustering or dimensionality reduction of stratifications.
#' }
#'
#' @note
#' \itemize{
#'   \item This method returns the data stored in the 'JACCARD_DISTANCE_F' slot of the ClustAllObject.
#'   \item It will return NULL if \code{\link{runClustAll}} has not been executed on the object.
#'   \item The Jaccard distance is calculated based on the co-occurrence of samples in clusters,
#'     not on the specific cluster labels.
#'   \item This matrix is often used as input for the \code{\link{plotJACCARD}} function
#'     to visualize the similarity structure of stratifications.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{plotJACCARD}},
#' \code{\link{resStratification}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = FALSE)
#' JACCARD_DISTANCE_F(obj_noNA1)
#' @export
setGeneric(
  name="JACCARD_DISTANCE_F",
  def=function(Object){standardGeneric("JACCARD_DISTANCE_F")}
)

setMethod(
  f="JACCARD_DISTANCE_F",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@JACCARD_DISTANCE_F}
)


#' @title Check Processing Status of ClustAllObject
#' @aliases processed,ClustAllObject-method
#' @description
#' This method retrieves the processing status of a ClustAllObject, indicating
#' whether the ClustALL algorithm has been executed on the object. It provides a
#' quick way to verify if clustering results are available for analysis.
#'
#' @usage processed(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#'
#' @return A logical value:
#' \itemize{
#'   \item TRUE if \code{\link{runClustAll}} has been executed on the object.
#'   \item FALSE if the object has not yet been processed by \code{\link{runClustAll}}.
#' }
#'
#' @details
#' The processed method serves as a crucial indicator in the ClustALL workflow:
#'
#' \enumerate{
#'   \item Processing Status:
#'   \itemize{
#'     \item Indicates whether the ClustALL algorithm has been applied to the object.
#'     \item A TRUE value means clustering results are available for analysis.
#'     \item A FALSE value indicates the object only contains input data and preprocessing.
#'   }
#'
#'   \item Workflow Implications:
#'   \itemize{
#'     \item Helps determine which methods and analyses can be performed on the object.
#'     \item Guides users in the correct sequence of operations in the ClustALL pipeline.
#'   }
#'
#'   \item Data Availability:
#'   \itemize{
#'     \item TRUE status implies availability of:
#'     \itemize{
#'       \item Stratification results (\code{\link{summary_clusters}})
#'       \item Jaccard distance matrix (\code{\link{JACCARD_DISTANCE_F}})
#'       \item Other clustering-related outputs
#'     }
#'     \item FALSE status means only input and preprocessed data are available.
#'   }
#' }
#'
#' @note
#' \itemize{
#'   \item This method checks the 'processed' slot of the ClustAllObject.
#'   \item The processed status is automatically set to TRUE when \code{\link{runClustAll}}
#'     completes successfully.
#'   \item Users should not manually modify this status to ensure consistency between
#'     the status and the actual content of the object.
#'   \item A FALSE status does not necessarily indicate an error; it simply means
#'     \code{\link{runClustAll}} needs to be executed before accessing clustering results.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{createClustAll}},
#' \code{\link{ClustAllObject-class}}, \code{\link{summary_clusters}},
#' \code{\link{JACCARD_DISTANCE_F}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' processed(obj_noNA)
#' @export
setGeneric(
  name="processed",
  def=function(Object){standardGeneric("processed")}
)

setMethod(
  f="processed",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {

    return(Object@processed)
  }
)


#' @title Retrieve Validation Data from ClustAllObject
#' @aliases dataValidation,ClustAllObject-method
#' @description
#' This method extracts and returns the validation data (true labels) stored in
#' a ClustAllObject. These labels represent known classifications or groupings
#' of samples, which can be used to assess the performance of clustering results.
#'
#' @usage dataValidation(Object)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}} or modified by \code{\link{addValidationData}}.
#'
#' @return A numeric vector containing the validation data (true labels) if available.
#' Returns NULL if no validation data has been added to the object.
#'
#' @details
#' The dataValidation method provides access to the ground truth or reference
#' classifications for the samples in the dataset:
#'
#' \enumerate{
#'   \item Validation Data Content:
#'   \itemize{
#'     \item Contains known classifications or groupings of samples.
#'     \item Typically represents biological, clinical, or other meaningful categorizations.
#'     \item Used as benchmarking to evaluate clustering performance.
#'   }
#'
#'   \item Data Characteristics:
#'   \itemize{
#'     \item Returned as a numeric vector.
#'     \item Length matches the number of samples in the original dataset.
#'     \item Each element corresponds to a sample's true label or classification.
#'   }
#'
#'   \item Availability and Source:
#'   \itemize{
#'     \item May be added during object creation via the colValidation parameter in \code{\link{createClustAll}}.
#'     \item Can be added later using the \code{\link{addValidationData}} function.
#'     \item If not available, the method returns NULL.
#'   }
#' }
#'
#' @note
#' \itemize{
#'   \item This method returns the data stored in the 'dataValidation' slot of the ClustAllObject.
#'   \item The validation data is not used in the clustering process itself; it is solely for evaluation purposes.
#'   \item If validation data was not provided during object creation or added later, this method will return NULL.
#'   \item Always check for NULL before using the returned data in calculations or visualizations.
#'   \item The interpretation and use of validation data depend on the specific context of your study.
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{addValidationData}},
#' \code{\link{validateStratification}}, \code{\link{ClustAllObject-class}}

#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' obj_noNA <- createClustAll(data = wdbc, colValidation="Diagnosis")
#' dataValidation(obj_noNA)
#' @export
setGeneric(
  name="dataValidation",
  def=function(Object){standardGeneric("dataValidation")}
)

setMethod(
  f="dataValidation",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {Object@dataValidation}
)

#' @title Add Validation Data to ClustAllObject
#' @aliases addValidationData,ClustAllObject,numericOrCharacter-method
#' @description
#' This function adds or updates the validation data (true labels) in a
#' ClustAllObject. It allows users to incorporate known classifications or
#' groupings of samples after the object has been created, enabling subsequent
#' evaluation of clustering results against these true labels.
#'
#' @usage addValidationData(Object, dataValidation)
#'
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#' @param dataValidation A numeric or character vector containing the validation
#' data (true labels) for the samples. The length of this vector must match the
#' number of rows in the original input data used in
#' \code{\link{createClustAll}}.
#'
#' @return An updated \code{\link{ClustAllObject-class}} object with the new
#' validation data added to the dataValidation slot.
#'
#' @details
#' Adding validation data to a ClustAllObject is crucial for assessing the
#' performance of clustering results. This function allows for flexible
#' workflow where true labels can be incorporated at any stage of the analysis:
#' \itemize{
#'   \item It can be used to add validation data that was not available during
#'     initial object creation.
#'   \item It can also update existing validation data with new or corrected labels.
#'   \item The added data can be used with functions like
#'   \code{\link{validateStratification}}
#'     to evaluate clustering performance.
#' }
#' Key points to consider:
#' \itemize{
#'   \item The length of dataValidation must exactly match the number of samples
#'     in the original dataset.
#'   \item If the object already contains validation data, this function will
#'     overwrite it with the new data.
#'   \item Both numeric and character vectors are accepted, allowing for various
#'     types of classification schemes.
#' }
#'
#' @note
#' This function modifies the 'dataValidation' slot of the ClustAllObject in-place.
#' Always ensure that the provided validation data correctly corresponds to the
#' samples in your dataset to avoid misinterpretation of subsequent analyses.
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{dataValidation}},
#' \code{\link{validateStratification}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' label <- as.numeric(as.factor(wdbc$Diagnosis))
#' wdbc <- wdbc[,-c(1, 2)] # delete patients IDs & label
#' obj_noNA <- createClustAll(data = wdbc)
#' obj_noNA <- addValidationData(Object = obj_noNA,
#'                               dataValidation = label)
#' @export
setGeneric(
  name="addValidationData",
  def=function(Object, dataValidation){standardGeneric("addValidationData")}
)

setMethod(
  f="addValidationData",
  signature=signature(
    Object="ClustAllObject",
    dataValidation="numericOrCharacter"),
  definition=function(Object, dataValidation) {

    if (!is.null(Object@dataValidation)) {
      message("The object already has a labelling.")
      message("Rewriting the labelling data...")
    }

    dataValidation <- checkVectorIntroduced(dataValidation)

    if (length(dataValidation) != nrow(Object@data)) {
      message("The introduced data  and the original data labelling have different lengths.")
      message("Make sure the introduced data is correct.")
      stop()
    }

    Object@dataValidation <- dataValidation
    return(Object)
  }
)

#' @title extractData
#' @aliases extractData,ClustAllObject-method
#' @description
#' This function retrieves all data components stored in a
#' \code{\link{ClustAllObject-class}},
#' including the preprocessed data, original input data, and imputed datasets
#' (if applicable). It provides a comprehensive view of the data at different
#' stages of the ClustALL pipeline.
#' @usage extractData(Object)
#' @param Object A \code{\link{ClustAllObject-class}} object created by
#' \code{\link{createClustAll}}.
#' @return A list containing three elements:
#' \itemize{
#'   \item Data_modified: A data frame of the preprocessed data used for clustering.
#'   \item Data_original: A data frame of the original, unmodified input data.
#'   \item Data_imputed: A 'mids' object from the mice package containing imputed
#'     datasets, if imputation was performed. NULL otherwise.
#' }
#'
#' @details
#' The extractData function provides access to data at various stages of the
#' ClustALL pipeline:
#' \itemize{
#'   \item Data: Reflects preprocessing steps such as one-hot encoding
#'     for categorical variables and removal of the validation column.
#'   \item DataOriginal: The exact data as input to \code{\link{createClustAll}},
#'     useful for reference and verifying preprocessing steps.
#'   \item Data_imputed: Multiple imputed datasets if missing data was present
#'     and imputation was performed.
#' }
#' This function is particularly useful for:
#' \itemize{
#'   \item Verifying preprocessing steps and their effects on the data.
#'   \item Accessing original data for additional analyses or visualizations.
#'   \item Examining imputed datasets to understand how missing data was handled.
#'   \item Exporting data at different stages for use in other analyses or packages.
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{ClustAllObject-class}},
#' \code{\link{runClustAll}}
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' \donttest{
#' obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
#' extractData(obj_noNA)
#' }
#' @export
setGeneric(
  name="extractData",
  def=function(Object){standardGeneric("extractData")}
)

setMethod(
  f="extractData",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {
    out_list <- list(Object@data, Object@dataOriginal, Object@dataImputed)
    names(out_list) <- c("Data_modified", "Data_original", "Data_imputed")

    return(out_list)
  }
)

#' @title Extract Clustering Results from ClustAllObject
#' @aliases extractResults,ClustAllObject-method
#' @description
#' This function retrieves the complete set of clustering results from a
#' processed ClustAllObject, including all generated stratifications and the
#' subset of statistically robust stratifications. It provides comprehensive
#' access to the outcomes of the ClustALL algorithm.
#'
#' @usage extractResults(Object)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this function.
#'
#' @return A list containing two elements:
#' \itemize{
#'   \item All_clusters: A list of all stratifications generated by the ClustALL algorithm.
#'   \item Robust_clusters: A list of statistically robust stratifications that passed
#'     the bootstrapping process.
#' }
#' If \code{\link{runClustAll}} has not been executed, the function returns a list
#' with a single NULL element.
#'
#' @details
#' The extractResults function provides comprehensive access to the clustering
#' outcomes of the ClustALL algorithm:
#' \itemize{
#'   \item All_clusters: Contains every stratification generated, regardless of
#'     statistical robustness. Each element is a vector of cluster assignments
#'     for the samples.
#'   \item Robust_clusters: A subset of All_clusters, containing only those
#'     stratifications that passed the bootstrapping process for population-based
#'     robustness.
#' }
#' This function is particularly useful for:
#' \itemize{
#'   \item Comprehensive analysis of all generated clustering solutions.
#'   \item Comparing robust stratifications with non-robust ones.
#'   \item Exporting clustering results for further analysis in other tools.
#'   \item Assessing the impact of robustness criteria on stratification selection.
#' }
#'
#' @note
#' This function will return a list with a single NULL element if
#' \code{\link{runClustAll}} has not been executed on the object. Always check
#' if the returned list contains valid results before proceeding with analysis.
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{summary_clusters}},
#' \code{\link{resStratification}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=-ID)
#' \donttest{
#' obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' extractResults(obj_noNA1)
#' }
#'
#' @export
setGeneric(
  name="extractResults",
  def=function(Object){standardGeneric("extractResults")}
)

setMethod(
  f="extractResults",
  signature=signature(
    Object="ClustAllObject"),
  definition=function(Object) {
    if (Object@processed)
    {
      stratification_names <- colnames(Object@JACCARD_DISTANCE_F)
      stratification_robust <- Object@summary_clusters[stratification_names]
      out_list <- list(Object@summary_clusters, stratification_robust)
      names(out_list) <- c("All_clusters", "Robust_clusters")
    } else {
      message("There are no results generated. Please run runClustAll before.")
      out_list <- list(NULL)
    }

    return(out_list)
  }
)


# Cocumenting DataSets ---------------------------------------------------------
#' wdbc: Diagnostic Wisconsin Breast Cancer Database.
#'
#' The Breast Cancer Wisconsin (Diagnostic) dataset, also known as "wdbc", contains
#' features computed from digitized images of fine needle aspirates (FNA) of breast
#' masses. The features describe characteristics of the cell nuclei present in each image.
#'
#' The dataset includes 569 patients, each characterized by 30 numerical features and one
#' categorical feature. The numerical features are computed from ten different measurements
#' of the cell nuclei, and each measurement is repeated three times, resulting in a total
#' of 30 features per patient (10 features x 3 measurements).
#'
#' The categorical feature is the diagnosis, which indicates whether the tumor is
#' malignant (M) or benign (B). This feature serves as the target class for
#' classification tasks.
#'
#' @source <https://archive.ics.uci.edu/dataset/17/breast+cancer+wisconsin+diagnostic>
#'
#' \itemize{
#'   \item Diagnosis Label says tumor is malingnant or benignant
#'   \item radius. Mean of distances from the center to points on the perimeter
#'   \item perimeter
#'   \item area
#'   \item smoothness. Local variation in radius lengths
#'   \item compactness. (Perimeter^2 / Area) - 1.0
#'   \item concavity. Severity of concave portions of the contour
#'   \item concave points. Number of concave portions of the contour
#'   \item symmetry.
#'   \item fractal dimension. “Coastline approximation” - 1.
#' }
#'
#' @docType data
#' @keywords datasets
#' @name wdbc
#' @usage data("BreastCancerWisconsin", package = "ClustAll")
#' @format A data frame with 660 rows and 31 variables
#' @return wdbc dataset
NULL

#' wdbcNA: Diagnostic Wisconsin Breast Cancer Database with missing values
#'
#' The "wdbcNA" dataset is a modified version of the Breast Cancer Wisconsin
#' (Diagnostic) dataset (\code{\link{wdbc}}), incorporating missing values at
#' random. This dataset is designed to demonstrate and evaluate the handling
#' of missing data in the context of breast cancer diagnosis.
#'
#' The dataset retains the same structure as the original "wdbc" dataset, with
#' 569 patients and 32 variables. However, some values in the numerical features
#' have been randomly replaced with missing values (NA).
#'
#' For a detailed description of the features and the original dataset, please
#' refer to the documentation of the "wdbc" dataset (\code{\link{wdbc}}).
#'
#' @docType data
#' @keywords datasets
#' @name wdbcNA
#' @usage data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' @format A data frame with 660 rows and 31 variables
#' @return wdbcNA dataset
NULL

#' wdbcMIDS: Diagnostic Wisconsin Breast Cancer Database with imputed values
#'
#' The "wdbcMIDS" dataset is an imputed version of the "wdbcNA" dataset, which is
#' a modified version of the Breast Cancer Wisconsin (Diagnostic) dataset
#' (\code{\link{wdbc}}) with missing values introduced at random. The missing values
#' have been imputed using the Multiple Imputation by Chained Equations (MICE)
#' algorithm, resulting in a "mids" object manually.
#'
#' For more information on the original dataset and the version with missing values,
#' please refer to the documentation of the "wdbc" (\code{\link{wdbc}}).
#'
#' @docType data
#' @keywords datasets
#' @name wdbcMIDS
#' @usage data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' @format A data frame with 660 rows and 31 variables
#' @return wdbcMIDS dataset
NULL

#' obj_noNA1: Processed wdbc dataset for testing purposed
#'
#' The "obj_noNA1" dataset is a processed version of the Breast Cancer Wisconsin
#' (Diagnostic) dataset (\code{\link{wdbc}}), prepared for testing purposes and
#' used in the ClustAll package vignette. It has been processed using the ClustAll
#' package methods, which include data preprocessing, feature transformation, and
#' the application of clustering algorithms.
#'
#' The "obj_noNA1" dataset can be used as a reference for users who want to
#' understand the ClustAll package workflow and replicate the analysis presented
#' in the vignette.
#'
#' For more information on the original dataset, please refer to the
#' documentation of the "wdbc" (\code{\link{wdbc}}) dataset.
#'
#'
#' @docType data
#' @keywords datasets
#' @name obj_noNA1
#' @usage data("testData", package = "ClustAll")
#' @format A processed ClustAllObject
#' @return ClustAllObject Object
NULL

#' obj_noNA1simplify: Processed wdbc dataset for testing purposed
#'
#' The "obj_noNA1simplify" dataset is a processed version of the Breast Cancer Wisconsin
#' (Diagnostic) dataset (\code{\link{wdbc}}), prepared for testing purposes and used in
#' the ClustAll package vignette. It has been processed using the ClustAll package
#' methods with the `simplify` parameter set to TRUE, which reduces the computational
#' complexity of the clustering algorithms by considering only a subset of the
#' dendrogram depths.
#'
#' The "obj_noNA1simplify" dataset can be used as a reference for users who want to
#' understand the ClustAll package workflow and replicate the simplified analysis
#' presented in the vignette.
#'
#' For more information on the original dataset and the full processed version, please
#' refer to the documentation of the "wdbc" (\code{\link{wdbc}}).
#'
#' @docType data
#' @keywords datasets
#' @name obj_noNA1simplify
#' @usage data("testData", package = "ClustAll")
#' @format A processed ClustAllObject
#' @return ClustAllObject Object
NULL

#' obj_noNAno1Validation: Processed wdbc dataset for testing purposed
#'
#' The "obj_noNAno1Validation" dataset is a processed version of the Breast
#' Cancer Wisconsin (Diagnostic) dataset (\code{\link{wdbc}}), prepared for
#' testing purposes and used in the ClustAll package vignette. It has been
#' processed using the ClustAll package methods, but with the validation data
#' removed.
#'
#' The "obj_noNAno1Validation" dataset can be used as a reference for users who want
#' to understand the ClustAll package workflow and replicate the analysis presented
#' in the vignette, focusing on unsupervised learning aspects.
#'
#' For more information on the original dataset and the processed version with
#' validation data, please refer to the documentation of the "wdbc"
#' (\code{\link{wdbc}}).
#'
#' @docType data
#' @keywords datasets
#' @name obj_noNAno1Validation
#' @usage data("testData", package = "ClustAll")
#' @format A processed ClustAllObject
#' @return ClustAllObject Object
NULL

#' Heart Disease Dataset
#'
#' This dataset contains various medical and lifestyle attributes of patients,
#' along with their heart disease diagnosis status. It is commonly used for
#' predicting the presence of heart disease in patients.
#'
#' @description
#' The dataset comprises both categorical and numerical features derived from
#' medical examinations and patient history. Each row represents a patient,
#' characterized by 13 attributes, with the target variable indicating the
#' presence or absence of heart disease.
#'
#' @source Kaggle: https://www.kaggle.com/datasets/johnsmith88/heart-disease-dataset
#'
#' @format A data frame with 918 rows and 12 variables:
#' \describe{
#'   \item{Age}{Numeric. Age of the patient in years.}
#'   \item{Sex}{Categorical. Patient's gender (M = Male, F = Female).}
#'   \item{ChestPainType}{Categorical. Type of chest pain experienced (TA = Typical Angina, ATA = Atypical Angina, NAP = Non-Anginal Pain, ASY = Asymptomatic).}
#'   \item{RestingBP}{Numeric. Resting blood pressure in mm Hg.}
#'   \item{Cholesterol}{Numeric. Serum cholesterol in mg/dl.}
#'   \item{FastingBS}{Binary. Fasting blood sugar > 120 mg/dl (1 = true; 0 = false).}
#'   \item{RestingECG}{Categorical. Resting electrocardiogram results (Normal, ST = having ST-T wave abnormality, LVH = showing probable or definite left ventricular hypertrophy by Estes' criteria).}
#'   \item{MaxHR}{Numeric. Maximum heart rate achieved.}
#'   \item{ExerciseAngina}{Categorical. Exercise-induced angina (Y = Yes, N = No).}
#'   \item{Oldpeak}{Numeric. ST depression induced by exercise relative to rest.}
#'   \item{ST_Slope}{Categorical. The slope of the peak exercise ST segment (Up, Flat, Down).}
#'   \item{HeartDisease}{Binary. Output class (1 = heart disease, 0 = normal).}
#' }
#'
#' @details
#' This dataset is valuable for developing and testing machine learning models
#' for heart disease prediction. It includes a mix of demographic information,
#' vital signs, and results from various medical tests, making it a comprehensive
#' resource for studying factors associated with heart disease.
#'
#' @docType data
#' @keywords datasets
#' @name heart_data
#' @usage data("heart_data", package = "ClustAll")
#' @return heart dataset
NULL


# END OF ClustAll_ClustAllObject_Class.R

# ClustAllObject_Methods--------------------------------------------------------
#' @import ComplexHeatmap
#' @import circlize
#' @import RColorBrewer
#' @import ggplot2
#' @import grid
#' @import grDevices
#' @title Visualize Jaccard Distances Between Robust Stratifications
#' @aliases plotJACCARD,ClustAllObject,logicalOrNA,numericOrNA-method
#' @description
#' This function generates a heatmap visualization of the Jaccard distances
#' between robust stratifications identified by the ClustALL algorithm. It
#' provides a visual representation of the similarity between different
#' clustering solutions, helping to identify groups of related stratifications.
#'
#' @usage plotJACCARD(Object, paint = TRUE, stratification_similarity = 0.7)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this function.
#' @param paint Logical. If TRUE (default), the function highlights groups of
#' similar stratifications on the heatmap with red squares. This helps in
#' visually identifying clusters of similar stratifications.
#' @param stratification_similarity Numeric value between 0 and 1. Sets the
#' threshold Jaccard distance for considering two stratifications as similar.
#' Default is 0.7. Higher values result in more stringent similarity criteria.
#'
#' @return A plot displaying a correlation matrix heatmap that shows the Jaccard
#' Distances between population-based robust stratifications. The heatmap
#' visually distinguishes groups of similar stratifications according to the
#' specified “stratification_similarity” threshold.
#'
#' @details
#' The plotJACCARD function visualizes the similarity between robust
#' stratifications using a heatmap of Jaccard distances:
#'
#' \itemize{
#'   \item The heatmap color scale represents Jaccard distances, with darker colors
#'     indicating higher similarity (lower distance).
#'   \item Stratifications are ordered based on hierarchical clustering of their
#'     Jaccard distances.
#'   \item The 'paint' option highlights groups of similar stratifications, making it
#'     easier to identify clusters of related solutions.
#'   \item The 'stratification_similarity' parameter allows fine-tuning of what is
#'     considered "similar" for the purpose of highlighting.
#' }
#'
#' The function provides annotations for each stratification, including:
#' \itemize{
#'   \item Distance metric used (e.g., Correlation, Gower)
#'   \item Clustering method employed (e.g., H-Clustering, K-Means, K-Medoids)
#'   \item Depth of the dendrogram cut used in the Data Complexity Reduction step
#' }
#'
#' This visualization is particularly useful for:
#' \itemize{
#'   \item Identifying groups of similar stratifications
#'   \item Assessing the overall diversity of robust solutions
#'   \item Guiding the selection of representative stratifications for further analysis
#' }
#'
#' @note
#' \itemize{
#'   \item This function requires a processed ClustAllObject.
#'     Ensure \code{\link{runClustAll}}
#'     has been executed before using plotJACCARD.
#'   \item The 'paint' feature may not be visible if there are no groups of stratifications
#'     meeting the similarity threshold.
#'   \item For exploring stratifications, it's recommended to start with a high
#'     'stratification_similarity' value and gradually decrease it to examine
#'     various levels of stratification grouping.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{resStratification}},
#' \code{\link{ClustAllObject-class}}, \code{\link{JACCARD_DISTANCE_F}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' \donttest{
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' plotJACCARD(obj_noNA1, paint = TRUE, stratification_similarity = 0.9)
#' }
#' @export
setGeneric(
  name="plotJACCARD",
  def=function(Object, paint=TRUE, stratification_similarity=0.7)
  {standardGeneric("plotJACCARD")}
)

setMethod(
  f="plotJACCARD",
  signature=signature(
    Object="ClustAllObject",
    paint="logicalOrNA",
    stratification_similarity="numericOrNA"),
  definition=function(Object, paint=TRUE, stratification_similarity=0.7) {

    if (isProcessed(Object) == FALSE) {
      message("The object is not processed. You need to run runClustAll.")
      message("Note that the number of cores to use can be specified.")
      stop()
    }

    maxgo <- max(Object@JACCARD_DISTANCE_F[Object@JACCARD_DISTANCE_F < 1])
    ordergo <- hclust(1 - as.dist(Object@JACCARD_DISTANCE_F))$order
    m <- Object@JACCARD_DISTANCE_F[ordergo, ordergo]
    robust_stratification <- obtain_metadata(m)
    res <- resStratification(Object, population=1e-9, all=TRUE,
                             stratification_similarity)
    full_length <- ncol(Object@JACCARD_DISTANCE_F)

    # Correlation matrix heatmap with the robust stratifications
    col_fun <- colorRamp2(c(0, 1),
                          colors = grDevices::colorRampPalette(brewer.pal(9,"Blues"))(25),
                          breaks=seq(0, 1, length.out = 25))

    legend <- HeatmapAnnotation(JACCARD_index = seq(0, 1,
                                length.out = ncol(m)),
                                col = list(lg = col_fun),
                                annotation_name_side = "right")
    ra <- rowAnnotation(
            Distance=robust_stratification[,"Distance"],
            Clustering=robust_stratification[,"Clustering"],
            Depth=robust_stratification[,"Depth"],
            col = list(Distance=structure(names=c("Correlation","Gower"),
                                          c("#CCCCFF","blue4") ),
                       Clustering=structure(names=c("H-Clustering", "K-Means",
                                                    "K-Medoids"),
                                            c("forestgreen", "sandybrown",
                                              "tomato3")),
                       Depth=colorRamp2(c(1,
                                          round(max(robust_stratification[, "Depth"])/2),
                                          max(robust_stratification[, "Depth"])),
                                        c("darkcyan", "#F7DCCA", "#C75F97"))))

    hp <- Heatmap(as.matrix(m), name="hp", cluster_columns=FALSE,
                  cluster_rows=FALSE, left_annotation=ra, col=col_fun,
                  bottom_annotation = NULL, show_column_names = FALSE,
                  heatmap_legend_param = list(
                    direction = "vertical", title="JACCARD index", at=c(0, 1),
                    legend_width = unit(10, "cm")
                  ))

    if (is.null(res)) {
      paint <- FALSE
    }

    if (paint == TRUE) {
      ht_opt$message <- FALSE
      draw(hp)
      ngroup <- 0
      paint_names <- unlist(lapply(res, function(sublist) {
        c(sublist[[1]][[1]], sublist[[length(sublist)]][[1]])
      }))

      invisible(lapply(seq(from = 1, to = length(paint_names), by = 2), function(z) {
              ngroup <- ngroup + 1
              index <- which(rownames(m) %in% c(paint_names[z], paint_names[z + 1]))
              start <- index[1] - 1
              finish <- index[2]
              decorate_heatmap_body("hp", row_slice = 1, column_slice = 1, {
                grid::grid.rect(unit(start / full_length, "npc"), unit(1 - start / full_length, "npc"), # top left
                                width = (finish - start) / full_length,
                                height = (finish - start) / full_length,
                                gp = gpar(lwd = 2.5, lty = 2.5, fill = FALSE, col = "red"),
                                just = c("left", "top"), draw = TRUE
                )
              })
            }))

    } else {
      return(hp)
    }
  }
)


#' @title Extract Representative Stratifications from ClustAllObject
#' @aliases resStratification,ClustAllObject,numericOrNA,logicalOrNA,numericOrNA-method
#' @description
#' This function retrieves and filters representative stratifications from a
#' processed ClustAllObject. It allows users to explore the most robust and
#' significant clustering solutions generated by the ClustALL algorithm, based
#' on population size criteria and stratification similarity.
#'
#' @usage resStratification(Object, population = 0.05, all = FALSE,
#'                          stratification_similarity = 0.7)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this function.
#'
#' @param population Numeric value between 0 and 1. Specifies the minimum
#' proportion of the total population that a cluster within a stratification must
#' contain to be considered valid. Default is 0.05.
#'
#' @param all A logical value. If set to TRUE, the function will return all
#' stratification representatives that meet the robustness criteria of each
#' group of similar stratifications. If set to FALSE, only the centroid
#' stratification (the central that serves as the representative stratification)
#' for each group of similar stratifications will be returned.
#'
#' @param stratification_similarity Numeric value between 0 and 1. Sets the
#' threshold Jaccard distance for considering two stratifications as similar.
#' Default is 0.7. Higher values result in more stringent similarity criteria.
#'
#' @return A list of representative stratifications and their associated clusters.
#' The structure of the return value depends on the 'all' parameter:
#' \itemize{
#'   \item If all = FALSE: A named list where each element represents the centroid
#'     stratification for a group of similar stratifications.
#'   \item If all = TRUE: A nested list where each top-level element represents a group
#'     of similar stratifications, and contains all stratifications in that group.
#' }
#' Each stratification is represented by a table showing the distribution of
#' patients across clusters.
#'
#' @details
#' The resStratification function performs several key steps:
#'
#' \enumerate{
#'   \item Filters stratifications based on the 'population' parameter, ensuring that
#'     each cluster in a stratification contains at least the specified proportion
#'     of the total population.
#'   \item Groups similar stratifications based on their Jaccard distances, using the
#'     'stratification_similarity' threshold.
#'   \item For each group of similar stratifications:
#'   \itemize{
#'     \item If all = FALSE, selects the centroid (most representative) stratification.
#'     \item If all = TRUE, includes all stratifications in the group.
#'   }
#' }
#'
#' This function is particularly useful for:
#' \itemize{
#'   \item Identifying the most robust and significant clustering solutions.
#'   \item Reducing the number of stratifications to a manageable set for further analysis.
#'   \item Exploring how different similarity thresholds affect the grouping of stratifications.
#'   \item Comparing multiple similar stratifications within each group (when all = TRUE).
#' }
#'
#' @note
#' \itemize{
#'   \item This function requires a processed ClustAllObject. Ensure
#'     \code{\link{runClustAll}}
#'     has been executed before using resStratification.
#'   \item The 'population' parameter helps filter out stratifications with very small,
#'     potentially insignificant clusters.
#'   \item The 'stratification_similarity' parameter allows for fine-tuning the balance
#'     between diversity and similarity in the returned stratifications.
#'   \item When exploring results, it's often useful to try different combinations of
#'     'population' and 'stratification_similarity' values to understand the
#'     characteristics of your clustering solutions.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{plotJACCARD}},
#' \code{\link{cluster2data}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' \donttest{
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' resStratification(Object = obj_noNA1, population = 0.05,
#'                   stratification_similarity = 0.88, all = FALSE)
#' }
#'
#' @export
setGeneric(
  name="resStratification",
  def=function(Object, population=0.05, all=FALSE,
               stratification_similarity=0.7)
  {standardGeneric("resStratification")}
)

setMethod(
  f="resStratification",
  signature=signature(
    Object="ClustAllObject",
    population="numericOrNA",
    all="logicalOrNA",
    stratification_similarity="numericOrNA"),
  definition=function(Object, population=0.05, all=FALSE,
                      stratification_similarity=0.7) {

    if (isProcessed(Object) == FALSE) {
      message("The object has not been processed yet.")
      message(". You need to execute runClustAll.")
      message("Note that the number of cores to use can be specified.")
      stop()
    }

    maxgo <- max(Object@JACCARD_DISTANCE_F[Object@JACCARD_DISTANCE_F < 1])
    ordergo <- hclust(1 - as.dist(Object@JACCARD_DISTANCE_F))$order

    # obtain the definitive clusters
    definitive_clusters <- obtainDefCluster(Object@JACCARD_DISTANCE_F[ordergo,
                                                                      ordergo],
                                            stratification_similarity)

    if (length(definitive_clusters) > 0) {
      # choose the representative stratification considering at least a minimum
      # percentage of the total population in each cluster. Default is 0.05 (5%)
      res <- chooseClusters(definitive_clusters, Object@summary_clusters,
                            population, all)
      stratificationRep <- lapply(seq_along(res), function(i) {
        if (all == TRUE) {
          inner_list <- lapply(seq_along(res[[i]]), function(j) {
            list(res[[i]][j], table(Object@summary_clusters[[res[[i]][j]]]))
          })
          names(inner_list) <- paste0("Stratification_", seq_along(res[[i]]))
          inner_list
        } else {
          list(table(Object@summary_clusters[[res[[i]]]]))
        }
      })

      if (all == FALSE) {
        names(stratificationRep) <- res
      } else {
      names(stratificationRep) <- paste0("Cluster_",
                                         seq(length(stratificationRep)))
      }

      return(stratificationRep)

    } else {
      message("There are no robust groups of stratification for the selected parameters.")
      return(list(NULL))
    }
  }
)


#' @title Export Stratification Results with Original Data
#' @aliases cluster2data,ClustAllObject,character-method
#' @description
#' This function combines the original input data with one or more selected
#' stratifications from the ClustALL algorithm results. It allows users to
#' examine how samples are clustered in the context of their original features,
#' facilitating further analysis and interpretation of the stratification
#' results.
#'
#' @usage cluster2data(Object, stratificationName)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object.
#' The object must have been processed by \code{\link{runClustAll}} before using
#' this function.
#' @param stratificationName A character vector specifying the names of one or more
#' stratifications to be exported. These names should correspond to stratifications
#' generated by the ClustALL algorithm and stored in the Object.
#'
#' @return
#' A data.frame that includes the original data with additional column(s)
#' containing the selected stratification(s). Each selected stratification will
#' be added as a separate column to the original dataset.
#'
#' @details
#' The cluster2data function serves some important purposes in the ClustALL workflow:
#'
#' 1. Data Integration: It combines clustering results with the original feature data,
#'    allowing for comprehensive analysis of how cluster assignments relate to
#'    input variables.
#'
#' 2. Preparation for External Analysis: The resulting data frame can be easily
#'    exported for use in other analytical tools or visualization software.
#'
#' The function is particularly useful for:
#' \itemize{
#'   \item Identifying features that distinguish different clusters
#'   \item Comparing how samples are grouped across different stratifications
#'   \item Preparing data for cluster-specific statistical analyses
#'   \item Creating visualizations that incorporate both cluster assignments and original features
#' }
#'
#' @note
#' \itemize{
#'   \item This function requires a processed ClustAllObject. Ensure \code{\link{runClustAll}}
#'     has been executed before using cluster2data.
#'   \item The stratificationName parameter accepts multiple stratification names, allowing
#'     for simultaneous export of multiple clustering solutions.
#'   \item Stratification names can be obtained from the results of \code{\link{resStratification}}
#'     or by examining the names in the summary_clusters slot of the ClustAllObject.
#'   \item The original data in the returned data frame includes all preprocessing steps
#'     applied during the creation of the ClustAllObject, such as one-hot encoding
#'     of categorical variables.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{resStratification}},
#' \code{\link{ClustAllObject-class}}, \code{\link{createClustAll}}
#'
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' obj_noNA <- createClustAll(data = wdbc)
#' \donttest{
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' resStratification(Object = obj_noNA1, population = 0.05,
#'                   stratification_similarity = 0.88, all = FALSE)
#' df <- cluster2data(Object = obj_noNA1,
#'                    stratificationName = c("cuts_a_1","cuts_b_5","cuts_a_5"))
#' }
#' @export
setGeneric(
  name="cluster2data",
  def=function(Object, stratificationName){standardGeneric("cluster2data")}
)

setMethod(
  f="cluster2data",
  signature=signature(
    Object="ClustAllObject",
    stratificationName="character"),
  definition=function(Object, stratificationName) {

    if (isProcessed(Object) == FALSE) {
      message("The object is not processed. You need to run runClustAll.")
      message("Note that the number of cores to use can be specified.")
      stop()
    }

    checkCluster(stratificationName, Object@summary_clusters)

    df <- Object@dataOriginal
    df[, stratificationName] <- Object@summary_clusters[stratificationName]

    return(df)
  }
)


#' @import networkD3
#' @import dplyr
#' @title Visualize Stratification Comparisons with Sankey Diagram
#' @aliases plotSANKEY,ClustAllObject,character,logicalOrNA-method
#' @description
#' This function generates a Sankey diagram to visualize the relationships between
#' different stratifications or between a stratification and the true labels (if available).
#' It provides an intuitive representation of how samples are distributed across
#' clusters in different stratifications or how they align with known stratifications.
#'
#' @usage plotSANKEY(Object, clusters, validationData = FALSE)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} before using this function.
#' @param clusters A character vector specifying the names of stratifications to compare.
#' If validationData is FALSE, exactly two stratification names should be provided.
#' If validationData is TRUE, provide one stratification name to compare with true labels.
#' @param validationData Logical. If TRUE, compares the specified stratification with
#' the true labels (validation data) if available. Default is FALSE.
#'
#' @return A Sankey plot showing the composition and flow of clusters between
#' the selected stratifications. If true labels are available and
#' “validationData” is TRUE, the plot will compare the selected stratification
#' against the true labels.
#'
#' @details
#' The plotSANKEY function provides a powerful visualization tool for understanding
#' the relationships between different clustering solutions or between a clustering
#' solution and known classifications:
#'
#' \enumerate{
#'   \item Stratification Comparison (validationData = FALSE):
#'   \itemize{
#'     \item Visualizes how samples are distributed across clusters in two different stratifications.
#'     \item Helps identify similarities and differences between clustering solutions.
#'     \item Useful for understanding how changes in clustering parameters affect sample groupings.
#'   }
#'
#'   \item Validation Comparison (validationData = TRUE):
#'   \itemize{
#'     \item Compares a single stratification with true labels (if available).
#'     \item Helps assess how well the clustering aligns with known stratifications.
#'     \item Useful for evaluating the biological or clinical relevance of a clustering solution.
#'   }
#' }
#'
#' The Sankey diagram represents:
#' \itemize{
#'   \item Clusters (or true labels) as nodes on the left and right sides of the diagram.
#'   \item Flows between nodes indicating how samples are distributed.
#'   \item The width of each flow is proportional to the number of samples it represents.
#' }
#'
#' This visualization is particularly useful for:
#' \itemize{
#'   \item Identifying stable sample groupings across different stratifications.
#'   \item Detecting major shifts in cluster assignments between solutions.
#'   \item Evaluating the concordance between clustering results and known stratifications.
#'   \item Understanding the impact of different clustering approaches on sample groupings.
#' }
#'
#' @note
#' \itemize{
#'   \item This function requires a processed ClustAllObject. Ensure
#'     \code{\link{runClustAll}}
#'     has been executed before using plotSANKEY.
#'   \item When validationData is TRUE, the ClustAllObject must contain validation data
#'     (true labels). This can be added using \code{\link{addValidationData}} if not
#'     provided during object creation.
#'   \item Stratification names can be obtained from the results of
#'     \code{\link{resStratification}}
#'     or by examining the names in the summary_clusters slot of the ClustAllObject.
#'   \item The Sankey diagram may become cluttered if there are many clusters or if the
#'     clustering solutions are very different. In such cases, consider focusing on
#'     specific subsets of clusters or using additional filtering criteria.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{resStratification}},
#' \code{\link{addValidationData}}, \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' label <- as.numeric(as.factor(wdbc$Diagnosis))
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' label <- label[16:30]
#' obj_noNA <- createClustAll(data = wdbc)
#' \donttest{
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' resStratification(Object = obj_noNA1, population = 0.05,
#'                   stratification_similarity = 0.88, all = FALSE)
#' plotSANKEY(Object = obj_noNA1, clusters = c("cuts_a_1","cuts_b_5"))
#'
#' obj_noNA1 <- addValidationData(obj_noNA1, label)
#' plotSANKEY(Object = obj_noNA1, clusters = "cuts_a_1", validationData=TRUE)
#' }
#'
#' @export
setGeneric(
  name="plotSANKEY",
  def=function(Object, clusters, validationData=FALSE)
  {standardGeneric("plotSANKEY")}
)

setMethod(
  f="plotSANKEY",
  signature=signature(
    Object="ClustAllObject",
    clusters="character",
    validationData="logicalOrNA"),
  definition=function(Object, clusters, validationData=FALSE) {
    if (isProcessed(Object) == FALSE) {
      message("The object has not been processed yet.")
      message("You need to execute runClustAll.")
      message("Note that the number of cores to use can be specified.")
      stop()
    }

    if (validationData) {
      if (is.null(Object@dataValidation)) {
        message("The ClustALL Object does not include labels.")
        message("Please create a new object or modidy the object with the original labelling data. \nFor that check addValidationData method.")
        stop()
      } else if (length(clusters) != 1) {
        message("More than one stratifications have been selected.")
        message("Only the first one will be considered to plot against the original labelling data.")
        clusters <- clusters[1]
      }
    } else if (length(clusters) != 2) {
      message("You need to include the name of a pair of stratifications.")
      message("To obtain the stratifications you may use resStratification.")
      stop()
    }

    checkCluster(clusters, Object@summary_clusters)

    df <- cluster2data(Object, clusters)

    if (validationData) {
      df[, "validation"] <- Object@dataValidation
      clusters <- c(clusters, "validation")
    }

    df <- df[, clusters]
    names1 <- paste0(clusters[1], "_Group_",
                     seq_len(length(unique(df[,clusters[1]]))))
    names2 <- paste0(clusters[2], "_Group_",
                     seq_len(length(unique(df[,clusters[2]]))))

    source <- sort(rep(names1, times=length(unique(df[,clusters[2]]))))
    target <- rep(names2, times=length(unique(df[,clusters[1]])))

    value <- unlist(lapply(unique(df[, 1]), function(i) {
      df_tmp <- df[df[, 1] == i, ]
      tmp <- nrow(df)
      unlist(lapply(unique(df[, 2]), function(j) {
        length(which(df_tmp[, 2] == j)) / tmp
      }))
    }))

    links <- data.frame(source = source,
                        target = target,
                        value = value)

    nodes <- data.frame(name=c(as.character(links$source),
                               as.character(links$target)) %>% unique()
    )

    links$IDsource <- match(links$source, nodes$name)-1
    links$IDtarget <- match(links$target, nodes$name)-1

    plot <- networkD3::sankeyNetwork(Links = links, Nodes = nodes,
                                     Source = "IDsource", Target = "IDtarget",
                                     Value = "value", NodeID = "name",
                                     sinksRight=FALSE)

    return(plot)
  }
)


#' @title Validate Stratification Results Against True Labels
#' @aliases validateStratification,ClustAllObject,characterOrNA-method
#' @description
#' This function calculates the sensitivity and specificity of a selected
#' stratification by comparing it to the true labels (validation data) stored
#' in the ClustAllObject. It provides a quantitative assessment of how well
#' the clustering aligns with known classifications.
#'
#' @usage validateStratification(Object, stratificationName)
#'
#' @param Object A processed \code{\link{ClustAllObject-class}} object. The object
#' must have been processed by \code{\link{runClustAll}} and contain validation
#' data (true labels).
#' @param stratificationName A character string specifying the name of the
#' stratification to be validated. This should correspond to a stratification
#' generated by the ClustALL algorithm and stored in the Object.
#'
#' @return A named numeric vector containing two elements:
#' \itemize{
#'   \item sensitivity: The proportion of true positive classifications
#'   \item specificity: The proportion of true negative classifications
#' }
#'
#' @details
#' The validateStratification function provides a crucial step in assessing the
#' biological or clinical relevance of clustering results:
#'
#' \enumerate{
#'   \item Comparison Mechanism:
#'   \itemize{
#'     \item The function compares the cluster assignments of the selected stratification
#'       with the true labels provided in the validation data.
#'     \item It treats the problem as a binary classification task, considering one
#'       class as the "positive" class and all others as "negative".
#'   }
#'
#'   \item Sensitivity (True Positive Rate):
#'   \itemize{
#'     \item Measures the proportion of actual positive cases that were correctly identified.
#'     \item Calculated as: (True Positives) / (True Positives + False Negatives)
#'   }
#'
#'   \item Specificity (True Negative Rate):
#'   \itemize{
#'     \item Measures the proportion of actual negative cases that were correctly identified.
#'     \item Calculated as: (True Negatives) / (True Negatives + False Positives)
#'   }
#'
#'   \item Interpretation:
#'   \itemize{
#'     \item Higher sensitivity indicates better identification of the positive class.
#'     \item Higher specificity indicates better identification of the negative classes.
#'     \item The function automatically adjusts calculations if necessary to ensure
#'       sensitivity and specificity are always higher than 0.5.
#'   }
#' }
#'
#' This function is particularly useful for:
#' \itemize{
#'   \item Evaluating the clinical or biological relevance of clustering solutions
#'   \item Comparing different stratifications based on their alignment with known classifications
#'   \item Identifying stratifications that best capture known groupings in the data
#'   \item Providing quantitative metrics to support the selection of optimal clustering solutions
#' }
#'
#' @note
#' \itemize{
#'   \item This function requires a processed ClustAllObject with validation data.
#'     Ensure \code{\link{runClustAll}} has been executed and validation data
#'     has been added using \code{\link{addValidationData}} if not provided during
#'     object creation.
#'   \item The function assumes binary classification. For multi-class problems, it
#'     effectively treats one class as "positive" and all others as "negative".
#'   \item Stratification names can be obtained from the results of \code{\link{resStratification}}
#'     or by examining the names in the summary_clusters slot of the ClustAllObject.
#'   \item The function will stop with an error if the ClustAllObject does not contain
#'     validation data or if the specified stratification name is not found.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{resStratification}},
#' \code{\link{addValidationData}}, \code{\link{plotSANKEY}},
#' \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' label <- as.numeric(as.factor(wdbc$Diagnosis))
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' label <- label[16:30]
#' obj_noNA <- createClustAll(data = wdbc)
#' \donttest{
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' resStratification(Object = obj_noNA1, population = 0.05,
#'                   stratification_similarity = 0.88, all = FALSE)
#' obj_noNA1 <- addValidationData(Object = obj_noNA1,
#'                                dataValidation = label)
#' validateStratification(obj_noNA1, "cuts_a_1")
#' }
#'
#' @export
setGeneric(
  name="validateStratification",
  def=function(Object, stratificationName){
    standardGeneric("validateStratification")}
)

setMethod(
  f="validateStratification",
  signature=signature(
    Object="ClustAllObject",
    stratificationName="characterOrNA"),
  definition=function(Object, stratificationName) {

    if (is.null(Object@dataValidation)) {
      message("The ClustALL Object does not include labels.")
      message("Please create a new object or modify the object with the original labelling data. \nFor that check addValidationData method")
      stop()
    }

    if (isProcessed(Object) == FALSE) {
      message("The object has not been processed yet.")
      message("You need to execute runClustAll.")
      message("Note that the number of cores to use can be specified.")
      stop()
    }

    checkCluster(stratificationName, Object@summary_clusters)

    if (length(stratificationName) != 1) {
      message("More than one stratifications have been selected.")
      message("Only the first one will be considered.")
      stratificationName <- stratificationName[1]
    }

    df <- cluster2data(Object, stratificationName)
    res <- table(df[,stratificationName], Object@dataValidation)
    sensitivity <- res[3]/(res[3]+res[4])
    specifity <- res[2]/(res[2]+res[1])

    if (sensitivity < 0.5 & specifity < 0.5)
    {
      sensitivity <- 1 - sensitivity
      specifity <- 1 - specifity
    }

    showRes <- c(sensitivity, specifity)
    base::names(showRes) <- c("sensitivity", "specificity")

    return(showRes)
  }
)

# END OF ClustAll_ClustAllObject_Methods.R

## ----style, echo = FALSE, results = 'asis', include=FALSE---------------------
BiocStyle::markdown()
knitr::opts_chunk$set(
  collapse = TRUE,
  cache = FALSE,
  comment = "#>"
)

## ----echo=FALSE---------------------------------------------------------------
table <- data.frame(Nomenclature=c("a","b","c","d"), 
                    `Distance Metric`=rep(c("Correlation", "Gower"), each=2), 
                    `Clustering Method`=c("K-means", "Hierarchical Clustering", 
                                          "K-medoids", "Hierarchical-Clustering"))

## ----echo=FALSE---------------------------------------------------------------
knitr::kable(table, align = c("l", "l", "l"), caption = "ClustAll Stratification Output Interpretation")

## ----installation, eval=FALSE-------------------------------------------------
# if (!require("BiocManager", quietly = TRUE)) install.packages("BiocManager ")
# 
# BiocManager::install("ClustAll")

## ----load package-------------------------------------------------------------
library(ClustAll)

## ----load data----------------------------------------------------------------
data("BreastCancerWisconsin", package = "ClustAll") 

data_use <- subset(wdbc, select=-ID)

## ----check missing values-----------------------------------------------------
sum(is.na(data_use)) 
dim(data_use)

## ----create ClustAllObject----------------------------------------------------
obj_noNA <- createClustAll(data = data_use, nImputation = NULL, 
                           dataImputed = NULL, colValidation = "Diagnosis")

## ----run ClustAll, results=FALSE----------------------------------------------
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 2, simplify = FALSE)

## ----check result-------------------------------------------------------------
obj_noNA1

## ----plot1, fig.height=12, fig.width=12, warning=FALSE, fig.cap = "Correlation matrix heatmap. It depcits the similarity between population-robust stratifications. The discontinuous red rectangles highlight alternative stratifications solutions based on those stratifications that exhibit certain level of similarity. The heatmap row annotation describes the combination of parameters —distance metric, clustering method, and embedding number— from which each stratification is derived."----

plotJACCARD(Object = obj_noNA1, stratification_similarity = 0.9, paint = TRUE)

## ----explore representative clusters------------------------------------------
resStratification(Object = obj_noNA1, population = 0.05, 
                  stratification_similarity = 0.9, all = FALSE)

## ----plot2, fig.cap = "Flow and distribution of patients across clusters. Patient transitions between representative stratifications cuts_c_3 and cuts_a_9.", echo = FALSE----
plotSANKEY(Object = obj_noNA1, clusters = c("cuts_c_9","cuts_a_28"), 
           validationData = FALSE)

## ----plot3, fig.cap = "Flow and distribution of patients across clusters. Patient transitions between representative stratifications cuts_c_9 and the ground truth.", echo = FALSE----
plotSANKEY(Object = obj_noNA1, clusters = c("cuts_c_9"), 
           validationData = TRUE)

## ----export stratifications---------------------------------------------------
df <- cluster2data(Object = obj_noNA1,
                   stratificationName = c("cuts_c_9","cuts_a_28","cuts_c_4"))
head(df,3)

## ----validate stratifications-------------------------------------------------
# STRATIFICATION 1
validateStratification(obj_noNA1, "cuts_a_28")
# STRATIFICATION 2
validateStratification(obj_noNA1, "cuts_c_9")
# STRATIFICATION 3
validateStratification(obj_noNA1, "cuts_c_4")

## ----session info-------------------------------------------------------------
sessionInfo()

# runClustAll ------------------------------------------------------------------
#' @import clValid
#' @import mice
#' @import bigstatsr
#' @import FactoMineR
#' @import modeest
#' @import dplyr
#' @import fpc
#' @import doSNOW
#' @import foreach
#' @import flock
#' @import cluster
#' @import utils
#' @import pbapply
#' @importFrom grDevices colorRampPalette
#' @importFrom parallel detectCores makeCluster stopCluster
#' @importFrom methods is new validObject
#' @importFrom stats as.dist cor cutree hclust median quantile sd
#' @title Execute ClustALL Algorithm on a ClustAllObject
#' @aliases runClustAll,ClustAllObject,numericOrNA,logicalOrNA-method
#' @description
#' This function applies the ClustALL algorithm to the data stored in a
#' ClustAllObject. It performs a comprehensive analysis, generating multiple
#' patient stratifications based on various clustering methods and parameters.
#' The function implements the core steps of the ClustALL framework: Data
#' Complexity Reduction (DCR), Stratification Process (SP), and Consensus-based
#' Stratifications (CbS).
#'
#' @usage runClustAll(Object, threads = 1, simplify = FALSE)
#'
#' @param Object An unprocessed \code{\link{ClustAllObject-class}} created by
#' \code{\link{createClustAll}}. The object should contain the original input
#' data and any preprocessed versions of it, but no stratification results yet.
#' @param threads An integer specifying the number of CPU cores to use for
#' parallel computing. Default is 1 (single-core processing).
#' @param simplify A logical value. If TRUE, only every fourth depth of the
#' dendrogram will be considered in the DCR and SP steps, reducing execution
#' time but potentially sacrificing detail. Default is FALSE.
#'
#' @return A processed \code{\link{ClustAllObject-class}} containing
#' stratification results from the ClustALL pipeline. The object's
#' summary_clusters and JACCARD_DISTANCE_F slots will be populated with results.
#'
#' @details
#' The runClustAll function implements the three main steps of the ClustALL
#' framework:
#'
#' \enumerate{
#'   \item Data Complexity Reduction (DCR):
#'   \itemize{
#'     \item Creates multiple data embeddings to replace highly correlated variable
#'       sets with lower-dimension projections derived from Principal Component
#'       Analysis (PCA).
#'     \item Explores all relevant groupings derived from a hierarchical
#'       clustering-based dendrogram.
#'     \item Computes an embedding for each depth in the dendrogram.
#'   }
#'
#'   \item Stratification Process (SP):
#'   \itemize{
#'     \item Calculates and preliminarily evaluates stratifications for each embedding.
#'     \item Computes a stratification for each feasible combination of embedding,
#'       dissimilarity metric, and clustering method.
#'     \item Determines the optimal number of clusters using three internal validation
#'       measures: sum-of-squares (WB-ratio), Dunn index, and average silhouette width.
#'   }
#'
#'   \item Consensus-based Stratifications (CbS):
#'   \itemize{
#'     \item Filters out non-robust stratifications through bootstrapping.
#'     \item Excludes stratifications with less than 85% stability.
#'     \item Selects representatives of very similar outcomes from the remaining
#'       stratifications.
#'   }
#' }
#'
#' The 'simplify' parameter, when set to TRUE, reduces computation time by
#' considering only every fourth depth of the dendrogram in the first and second
#' steps. While useful for preliminary results, it's recommended to set it to
#' FALSE for more robust and detailed results.
#'
#' @note
#' \itemize{
#'   \item This function modifies the input ClustAllObject in-place, populating it with
#'     stratification results.
#'   \item The process can be computationally intensive,
#'     especially for large datasets or when 'simplify' is set to FALSE.
#'   \item Consider using multiple threads for improved performance on multi-core systems.
#' }
#'
#' @seealso \code{\link{createClustAll}}, \code{\link{resStratification}},
#' \code{\link{plotJACCARD}}, \code{\link{cluster2data}},
#' \code{\link{ClustAllObject-class}}
#'
#' @examples
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
#' wdbc <- wdbc[1:15,1:8]
#' \donttest{
#' obj_noNA <- createClustAll(data = wdbc)
#' obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
#' obj_noNA1
#' }
#' @export

setGeneric(
  name="runClustAll",
  def=function(Object, threads=1, simplify=FALSE) {
    standardGeneric("runClustAll")
  }
)


setMethod(
  f="runClustAll",
  signature=signature(
    Object="ClustAllObject",
    threads="numericOrNA",
    simplify="logicalOrNA"),
  definition=function(Object, threads=1, simplify=FALSE) {

    if (Object@processed == TRUE) {
      message("ClustAll pipeline has been already executed.")
      message("Stopping the process...")
      message("You may want to use resStratification to explore the results.")
      stop()
    }

    packages.parallel <- c("clValid", "mice", "bigstatsr", "FactoMineR",
                           "modeest", "dplyr","fpc")
    functions.parallel <- c("obtainImputationData", "obtainDataPCA",
                            "cstats.table_PAM", "cstats.table_hclust",
                            "generatePCA_derived")
    nvariables <- ncol(Object@data)

    if (Object@nImputation == 0) {
      nRow <- 1
    } else {
      nRow <- Object@nImputation
    }

    # create empty arrays
    summary_clusters_a <- as_FBM(matrix(0, ncol(Object@data), nRow))
    summary_clusters_b <- as_FBM(matrix(0, ncol(Object@data), nRow))
    summary_clusters_c <- as_FBM(matrix(0, ncol(Object@data), nRow))
    summary_clusters_d <- as_FBM(matrix(0, ncol(Object@data), nRow))

    summary_matrices_a <- createEmptyArrays(ncol(Object@data), Object@data)
    summary_matrices_b <- createEmptyArrays(ncol(Object@data), Object@data)
    summary_matrices_c <- createEmptyArrays(ncol(Object@data), Object@data)
    summary_matrices_d <- createEmptyArrays(ncol(Object@data), Object@data)

    # set parallelization parameters
    lock <- tempfile() # synchronization between R processes

    if (Object@nImputation == 0) {
      nimp <- 1
    } else {
      nimp <- Object@nImputation
    }

    if (simplify == TRUE) {
      message("WARNING! The simplify parameter is set to TRUE.")
      message("For more robust results consider changing the simplify parameter to FALSE.")
      simplifyNumber <- 4
    } else {
      simplifyNumber <- 1
    }

    if (threads > detectCores()) {
      message("A greater number of cores than detected have been specified.")
      message("The maximum number of cores will be used.")
      threads <- detectCores()
    }

    printLogo()

    message("Running Data Complexity Reduction and Stratification Process.")
    message("This step may take some time...\n")

    if (threads == 1) {
      message("Only one core is being used.")
      message("Consider selecting more cores for a faster performance.")
      message("\n")
    }

    cl <- makeCluster(threads)
    registerDoSNOW(cl)

    if (nimp == 1) { # conditional if only one or no imputation was applied
      impgo <- 1
      ## Step 1. Data Complexity Reduction
      if (Object@nImputation == 0) {
        impData <- Object@data
        impData <- apply(impData, 2, as.numeric)
      } else {
        impData <- obtainImputationData(Object@dataImputed, impgo)
      }

      ### Step 1.1. Compute the dendogram among inpute variables
      cor_est_var <- cor(impData, method="spearman") # obtain correlations

      variables_clust <- hclust(as.dist(cor_est_var)) # hierarchical
      possible_heights <- variables_clust$height

      pb <- txtProgressBar(max=length(seq((length(possible_heights)-(ncol(Object@data)-2)),
                                          (length(possible_heights)-1), simplifyNumber)), style=3)
      progress <- function(n) setTxtProgressBar(pb, n)
      opts <- list(progress=progress)

      ### Step 1.2. Reprocessing
      # compute for all depths
      foreach(heights_cut=seq((length(possible_heights)-(ncol(Object@data)-2)),
                              (length(possible_heights)-1), simplifyNumber),
              .packages=packages.parallel, .export=functions.parallel,
              .options.snow=opts) %dopar% {

                data_PCA <- obtainDataPCA(impData, variables_clust, possible_heights, heights_cut)
                ## END OF Step 1. Data Complexity Reduction


                ## Step 2. Statrification Process
                ### Step 2.1. Conducting statrifications
                # scale PCA values for correlation distances: (a) K-MEANS and
                # (b) H-CLUST clustering
                data_PCA_scaled <- apply(data_PCA, 2, scale)
                # rename otherwise clValid function does not detect rownames
                rownames(data_PCA_scaled) <- seq(nrow(data_PCA_scaled))


                #### Step 2.1.1. a) K-Means method
                data_PCA.clValid_internal_kmeans <- clValid(data_PCA_scaled,
                                                            seq(from=2,to=6),
                                                            clMethods=c("kmeans"),
                                                            validation="internal",
                                                            maxitems=nrow(data_PCA_scaled),
                                                            metric="correlation")
                oS_kmeans <- as.numeric(mlv(optimalScores(data_PCA.clValid_internal_kmeans)[,3],
                                            method = "mfv"))

                if (length(oS_kmeans) > 1) {
                  # Choose the consensus (best k) after evaluating the
                  # cluster number by different metrics.
                  oS_kmeans <- median(oS_kmeans)
                }

                kmeans_res <- clusters(data_PCA.clValid_internal_kmeans, "kmeans")
                kmeans_res_c <- kmeans_res[as.character(oS_kmeans)][[1]]$cluster

                invisible(sapply(seq_len(as.numeric(oS_kmeans)), function(t) {
                  induse <- as.numeric(base::names(kmeans_res_c[kmeans_res_c==t]))

                  locked <- flock::lock(lock) # synchronization between processes
                  summary_matrices_a[[heights_cut]][induse, induse] <- summary_matrices_a[[heights_cut]][induse, induse] + 1
                  flock::unlock(locked)
                }))


                summary_clusters_a[heights_cut, impgo] <- oS_kmeans


                #### Step 2.1.2. b) Correlation Distance and H-Clust clustering method
                data_PCA.clValid_internal_hclust <- clValid(data_PCA_scaled, seq(from=2, to=6),
                                                            clMethods=c("hierarchical"),
                                                            validation="internal",
                                                            maxitems=nrow(data_PCA_scaled),
                                                            metric="correlation")
                oS_hclust <- as.numeric(mlv(optimalScores(data_PCA.clValid_internal_hclust)[,3], method = "mfv"))

                if (length(oS_hclust) > 1) {
                  oS_hclust <- median(oS_hclust) # choose the median
                }

                hclust_res <- clusters(data_PCA.clValid_internal_hclust,
                                       "hierarchical")
                hclust_res_c <- cutree(hclust_res, k=oS_hclust)

                invisible(sapply(seq_len(oS_hclust), function(t) {
                  induse <- as.numeric(base::names(hclust_res_c[hclust_res_c == t]))
                  locked <- flock::lock(lock) # synchronization between processes
                  summary_matrices_b[[heights_cut]][induse, induse] <- summary_matrices_b[[heights_cut]][induse, induse] + 1
                  flock::unlock(locked)
                }))

                summary_clusters_b[heights_cut, impgo] <- oS_hclust


                # Gower distances: (c) K-Medoids clustering method and
                # (d) H-Clust clustering method
                PCA_gower <- as.data.frame(data_PCA)
                colnames(PCA_gower) <- c(seq_len(dim(PCA_gower)[2]))
                # those variables with binary values
                binary <- which(apply(PCA_gower,2,function(x) { all(x %in% seq(from=0, to=1)) }))

                if (length(binary)==1) {
                  PCA_gower[,binary] <- factor(PCA_gower[,binary])

                } else {
                  PCA_gower[,binary] <- data.frame(apply(PCA_gower[,binary],2,
                                                         as.logical))
                }

                PCA_gower <- PCA_gower %>% mutate_if(is.character, as.factor)
                gower_dist <- cluster::daisy(PCA_gower, metric="gower")


                #### Step 2.1.3. c) Gower Distance and K-Medoids clustering method.
                # Apply the previous function to get the optimal number of clusters
                # for each depth of the dendrogram, considering Gower Distance and
                # K-Medoids clustering method
                summary_clusters_c[heights_cut,impgo] <- cstats.table_PAM(dist=gower_dist,
                                                                          k=6)
                pam_res <- cluster::pam(gower_dist, k=summary_clusters_c[heights_cut,impgo])
                pam_res_c <- pam_res$clustering

                # Compute the stratification for each depth of the dendrogram,
                # each imputation and its corresponding optimal number of clusters
                invisible(sapply(seq_len(summary_clusters_c[heights_cut, impgo]), function(t) {
                  induse <- as.numeric(base::names(pam_res_c[pam_res_c == t]))

                  locked <- flock::lock(lock) # synchronization between processes
                  summary_matrices_c[[heights_cut]][induse, induse] <- summary_matrices_c[[heights_cut]][induse, induse] + 1
                  flock::unlock(locked)
                }))


                #### Step 2.1.4. d) Gower Distance and H-Clust clustering method
                divisive.clust <- cluster::diana(as.matrix(gower_dist),
                                                 diss = TRUE, keep.diss = TRUE)
                summary_clusters_d[heights_cut,impgo] <- cstats.table_hclust(gower_dist,
                                                                             divisive.clust, 6)
                hclustgow_res_c <- cutree(divisive.clust,
                                          k=summary_clusters_d[heights_cut,impgo])
                base::names(hclustgow_res_c) <- seq_len(dim(Object@data)[1])

                invisible(sapply(seq_len(summary_clusters_d[heights_cut, impgo]), function(t) {
                  induse <- as.numeric(base::names(hclustgow_res_c[hclustgow_res_c == t]))
                  locked <- flock::lock(lock) # synchronization between processes
                  summary_matrices_d[[heights_cut]][induse, induse] <- summary_matrices_d[[heights_cut]][induse, induse] + 1
                  flock::unlock(locked)
                }))

              }

      ### END OF step, if only one or no imputation were considered
    } else { # if more than one imputation was considered

      pb <- txtProgressBar(max=nimp, style=3)
      progress <- function(n) setTxtProgressBar(pb, n)
      opts <- list(progress=progress)

      ## Step 1. Data Complexity Reduction
      foreach(impgo=seq_len(nimp), .packages=packages.parallel, .export=functions.parallel, .options.snow=opts) %dopar% { # for every imputation

        if (Object@nImputation == 0) {
          impData <- Object@data
          impData <- apply(impData, 2, as.numeric)
        } else {
          impData <- obtainImputationData(Object@dataImputed, impgo)
        }

        ### Step 1.1. Compute the dendrogram among input variables
        # obtain correlations between input variables
        cor_est_var <- cor(impData, method="spearman")

        # Compute the dendrogram among input variables
        variables_clust <- hclust(as.dist(cor_est_var))
        possible_heights <- variables_clust$height


        ### Step 1.2. Reprocessing to obtain the embeddings
        # compute for all possible heights
        for (heights_cut in seq((length(possible_heights)-(ncol(Object@data)-2)),
                                (length(possible_heights)-1), simplifyNumber)) {

          data_PCA <- obtainDataPCA(impData, variables_clust, possible_heights,
                                    heights_cut)
          ## END OF Step 1. Data Complexity Reduction


          ## Step 2. Statrification Process
          ### Step 2.1. Conducting statrifications
          # scale PCA values for correlation distances:
          # (a) K-MEANS and (b) H-CLUST clustering
          data_PCA_scaled <- apply(data_PCA, 2, scale)
          # rename otherwise clValid function does not detect rownames
          rownames(data_PCA_scaled) <- seq_len(nrow(data_PCA_scaled))


          #### Step 2.1.1. a) Correlation Distance and K-Means clustering method
          data_PCA.clValid_internal_kmeans <- clValid(data_PCA_scaled, seq(from=2, to=6),
                                                      clMethods=c("kmeans"),
                                                      validation="internal",
                                                      maxitems=nrow(data_PCA_scaled),
                                                      metric="correlation")
          oS_kmeans <- as.numeric(mlv(optimalScores(data_PCA.clValid_internal_kmeans)[,3], method = "mfv"))

          if (length(oS_kmeans) > 1) {
            # Choose the consensus (best k) after evaluating
            # the cluster number by different metrics
            oS_kmeans <- median(oS_kmeans) # choose the median
          }

          kmeans_res <- clusters(data_PCA.clValid_internal_kmeans, "kmeans")
          kmeans_res_c <- kmeans_res[as.character(oS_kmeans)][[1]]$cluster

          invisible(sapply(seq_len(as.numeric(oS_kmeans)), function(t) {
            induse <- as.numeric(base::names(kmeans_res_c[kmeans_res_c == t]))

            locked <- flock::lock(lock) # synchronization between processes
            summary_matrices_a[[heights_cut]][induse, induse] <- summary_matrices_a[[heights_cut]][induse, induse] + 1
            flock::unlock(locked)
          }))

          summary_clusters_a[heights_cut, impgo] <- oS_kmeans


          #### Step 2.1.2. b) Correlation Distance and H-Clust clustering method
          data_PCA.clValid_internal_hclust <- clValid(data_PCA_scaled, seq(from=2, to=6),
                                                      clMethods=c("hierarchical"),
                                                      validation="internal",
                                                      maxitems=nrow(data_PCA_scaled),
                                                      metric="correlation")
          oS_hclust <- as.numeric(mlv(optimalScores(data_PCA.clValid_internal_hclust)[,3], method = "mfv"))

          if (length(oS_hclust) > 1) {
            # Choose the consensus (best k) after evaluating the
            # cluster number by different metrics
            oS_hclust <- median(oS_hclust)
          }

          hclust_res <- clusters(data_PCA.clValid_internal_hclust, "hierarchical")
          hclust_res_c <- cutree(hclust_res, k=oS_hclust)

          invisible(sapply(seq_len(oS_hclust), function(t) {
            induse <- as.numeric(base::names(hclust_res_c[hclust_res_c == t]))
            locked <- flock::lock(lock) # synchronization
            summary_matrices_b[[heights_cut]][induse, induse] <- summary_matrices_b[[heights_cut]][induse, induse] + 1 # add result
            flock::unlock(locked)
          }))

          summary_clusters_b[heights_cut, impgo] <- oS_hclust


          # Gower distances: (c)K-Medoids clustering method and
          # (d) H-Clust clustering method
          PCA_gower <- as.data.frame(data_PCA)
          colnames(PCA_gower) <- c(seq_len(dim(PCA_gower)[2]))
          binary <- which(apply(PCA_gower,2,function(x) { all(x %in% seq(from=0, to=1)) })) # those variables with binary values

          if (length(binary)==1) {
            PCA_gower[,binary] <- factor(PCA_gower[,binary])

          } else {
            PCA_gower[,binary] <- data.frame(apply(PCA_gower[,binary], 2, as.logical))
          }

          PCA_gower <- PCA_gower %>% mutate_if(is.character, as.factor)
          gower_dist <- cluster::daisy(PCA_gower, metric="gower")


          #### Step 2.1.3. c) Gower Distance and K-Medoids clustering method.
          # Apply the previous function to get the optimal number of clusters
          # for each depth of the dendrogram, considering Gower Distance and
          # K-Medoids clustering method.
          summary_clusters_c[heights_cut,impgo] <- cstats.table_PAM(dist=gower_dist,
                                                                    k=6)
          pam_res <- cluster::pam(gower_dist, k=summary_clusters_c[heights_cut,impgo])
          pam_res_c <- pam_res$clustering

          # calculate TREE for each cut and each imputation and
          # its corresponding optimal K
          invisible(sapply(seq_len(summary_clusters_c[heights_cut, impgo]), function(t) {
            induse <- as.numeric(base::names(pam_res_c[pam_res_c == t]))
            locked <- flock::lock(lock) # synchronization
            summary_matrices_c[[heights_cut]][induse, induse] <- summary_matrices_c[[heights_cut]][induse, induse] + 1
            flock::unlock(locked)
          }))


          #### Step 2.1.4. d) Gower Distance and H-Clust clustering method
          divisive.clust <- cluster::diana(as.matrix(gower_dist), diss = TRUE, keep.diss = TRUE)
          summary_clusters_d[heights_cut,impgo] <- cstats.table_hclust(gower_dist, divisive.clust, 6)
          hclustgow_res_c <- cutree(divisive.clust, k=summary_clusters_d[heights_cut,impgo])
          base::names(hclustgow_res_c) <- seq_len(dim(Object@data)[1])

          invisible(sapply(seq_len(summary_clusters_d[heights_cut, impgo]), function(t) {
            induse <- as.numeric(base::names(hclustgow_res_c[hclustgow_res_c == t]))
            locked <- flock::lock(lock) # synchronization between processes
            summary_matrices_d[[heights_cut]][induse, induse] <- summary_matrices_d[[heights_cut]][induse, induse] + 1
            flock::unlock(locked)
          }))

        }
      }
    }
    ### END OF step if  more than one imputation were applied

    stopCluster(cl) # end of parallelization
    ### END OF Step 2.1. Conducting stratifications

    if (Object@nImputation != 0) {
      # put all the clusters together
      summary_n_clust <- obtainSummaryCluster(summary_clusters_a,
                                              summary_clusters_b,
                                              summary_clusters_c,
                                              summary_clusters_d)
    } else { # remove 0s and put all together
      summary_n_clust <- c(summary_clusters_a[][summary_clusters_a[]!=0],
                           summary_clusters_b[][summary_clusters_b[]!=0],
                           summary_clusters_c[][summary_clusters_c[]!=0],
                           summary_clusters_d[][summary_clusters_d[]!=0])
    }

    # rename the stratification matrices
    base::names(summary_matrices_a) <- paste0("cuts_a_",
                                        seq_len(length(summary_matrices_a)),
                                        sep="")
    base::names(summary_matrices_b) <- paste0("cuts_b_",
                                        seq_len(length(summary_matrices_b)),
                                        sep="")
    base::names(summary_matrices_c) <- paste0("cuts_c_",
                                        seq_len(length(summary_matrices_c)),
                                        sep="")
    base::names(summary_matrices_d) <- paste0("cuts_d_",
                                        seq_len(length(summary_matrices_d)),
                                        sep="")

    summary_matrices_MEASURES <- c(summary_matrices_a, summary_matrices_b,
                                   summary_matrices_c, summary_matrices_d)

    # remove those matrices with only 0s
    tmp <- lapply(summary_matrices_MEASURES, function(x) as.matrix(x[]))
    if (length(which(lapply(tmp, sum)==0)) > 0) {
      summary_matrices_MEASURES <- summary_matrices_MEASURES[-which(lapply(summary_matrices_MEASURES, function(x) sum(x[]))==0)]
    }


    ### Step 2.2. Filtering non-robust stratifications
    summary_clusters <- vector("list", length(summary_matrices_MEASURES))

    for (i in seq_len(length(summary_clusters))) {
      hclustgo <- hclust(1-as.dist(summary_matrices_MEASURES[[i]][]))
      summary_clusters[[i]] <- cutree(hclustgo, k=summary_n_clust[i])
    }
    base::names(summary_clusters) <- base::names(summary_matrices_MEASURES)

    message("")
    message("\nCalculating the correlation distance matrix of the stratifications...\n")
    pb <- txtProgressBar(max=nimp, style=3)
    progress <- function(n) setTxtProgressBar(pb, n)
    opts <- list(progress=progress)

    # Register the parallel backend
    cl <- makeCluster(threads)
    registerDoSNOW(cl)

    # Create the matrix
    JACCARD_DISTANCE <- matrix(NA, length(summary_matrices_MEASURES),
                               length(summary_matrices_MEASURES))
    rownames(JACCARD_DISTANCE) <- base::names(summary_matrices_MEASURES)
    colnames(JACCARD_DISTANCE) <- rownames(JACCARD_DISTANCE)

    # For two stratifications, this function calculates the similarity statistic
    # in comemberships of the observations.
    # The comembership is defined as the pairs of observations that are
    # clustered together.
    JACCARD_DISTANCE <- foreach(i = 1:nrow(JACCARD_DISTANCE), .combine = 'rbind', .options.snow=opts) %dopar% {
      result_row <- numeric(nrow(JACCARD_DISTANCE))
      for (j in i:nrow(JACCARD_DISTANCE)) {
        result_row[j] <- cluster_similarity_adapt(summary_clusters[[i]],
                                                  summary_clusters[[j]],
                                                  similarity = "jaccard")
      }
      result_row
    }

    # Stop the parallel backend
    stopCluster(cl)

    # Convert the result to a matrix
    JACCARD_DISTANCE <- as.matrix(JACCARD_DISTANCE)

    # Copy the upper triangle to the lower triangle
    JACCARD_DISTANCE[lower.tri(JACCARD_DISTANCE)] <- t(JACCARD_DISTANCE)[lower.tri(JACCARD_DISTANCE)]

    # Optionally, set the diagonal to 1
    diag(JACCARD_DISTANCE) <- 1

    rownames(JACCARD_DISTANCE) <- base::names(summary_matrices_MEASURES)
    colnames(JACCARD_DISTANCE) <- rownames(JACCARD_DISTANCE)

    message("")
    message("\nFiltering non-robust stratifications...\n")

    # Population based-robustness: Bootstrapping
    result_list <- pblapply(summary_matrices_MEASURES, function(mat) {
      invisible(capture.output( # avoid printing function messages
        r1 <- clusterboot(data=as.dist(1000-mat[]),
                          B=100, distances=TRUE, bootmethod="boot",
                          bscompare=TRUE, multipleboot=FALSE,
                          jittertuning=0.05, noisetuning=c(0.05,4),
                          subtuning=floor(nrow(data)/2),
                          clustermethod=disthclustCBI,noisemethod=FALSE,
                          count=TRUE, showplots=FALSE,dissolution=0.5,
                          recover=0.75,method="complete",k=2)
      ))

      stability <- as.numeric(r1$bootmean[seq(from=1, to=2)])
      mean_stability <- mean(stability)
      return(c(stability, mean_stability))
    })

    summary_matrices_STABILITY <- do.call(rbind, result_list)

    quantileuse <- 0.85 # Stratifications with less than 85% stability are excluded
    qgo <- quantile(summary_matrices_STABILITY[,3], quantileuse)
    JACCARD_DISTANCE_F <- JACCARD_DISTANCE[summary_matrices_STABILITY[, 3] >= qgo,
                                           summary_matrices_STABILITY[, 3]>=qgo]
    ### END OF Step 2.2. Filtering non-robust stratifications

    Object@summary_clusters <- summary_clusters
    Object@JACCARD_DISTANCE_F <- JACCARD_DISTANCE_F
    Object@processed <- TRUE

    message("\nClustAll pipeline finished successfully!\n")

    return(Object)
  }
)
# END OF ClustAll_runClustAll.R

# runClustAll_internal functions definition ------------------------------------
# These functions are not meant to be invoked directly by the user.
# See the createClusteAll function instead.

# This function creates a list with FMB objects to store the results
createEmptyArrays <- function(nvariables, data_use) {
  summary_matrices <- lapply(seq_len(nvariables), function(i) {
    as_FBM(matrix(0, nrow(data_use), nrow(data_use)))
  })
  return(summary_matrices)
}


# This function generates the PCA
generatePCA_derived <- function(data, variability, maxvar) {
  pca_go <- PCA(data, graph = FALSE, ncp=min(c(maxvar,ncol(data))))
  variab <- pca_go$eig[,3]
  whichgo <- min(which(variab>50))
  varigo <- min(c(whichgo,maxvar))
  result <- pca_go$ind$coord[,c(seq_len(varigo))]

  return(result)
}


# This functions fills the missing values with imputed data
obtainImputationData <- function(imp, impgo) {
  impData <- complete(imp,impgo)
  impData[is.na(impData)] <- 0
  impData <- data.frame(apply(impData, 2, as.numeric))
  impData <- impData[,apply(impData,2,sd)>0]

  return(impData)
}

# This function reads the slot of process from the object
isProcessed <- function(Object) {
  return(Object@processed)
}


# This function reduces the dimension by grouping the input variables into a
# dendrogram and generating PCAs for the resulting groups of variables
obtainDataPCA <- function(impData, variables_clust,
                          possible_heights,
                          heights_cut) {
  treego <- cutree(variables_clust, h=possible_heights[heights_cut])
  groups_go <- unique(treego)
  variables_use <- base::names(treego[treego==groups_go[1]])

  if (length(variables_use)==1) {
    data_PCA <- impData[,variables_use]

  } else {
    data_PCA <- generatePCA_derived(data=impData[,variables_use],
                                    variability=50, maxvar=3)
  }

  if (length(groups_go) > 1) {
    for (h in seq(from=2, to=length(groups_go))) {

      variables_use <- base::names(treego[treego==groups_go[h]])
      if (length(variables_use) == 1) {
        data_PCA <- cbind(data_PCA,impData[,variables_use])

      } else {
        data_PCA <- cbind(data_PCA,
                          generatePCA_derived(data=impData[,variables_use],
                                              variability=50,
                                              maxvar=3))
      }
    }
  }

  return(data_PCA)
}


# This function applies the K-Medoids clustering method, considering
# Gower distance, and return the results (c)
cstats.table_PAM <- function(dist, k) {
  clust.assess <- c("cluster.number", "wb.ratio", "dunn", "avg.silwidth")
  output.stats <- matrix(ncol = length(clust.assess), nrow = k-1)

  for (i in seq(from=2, to=k)) {
    pam_fit <- cluster::pam(dist, diss = TRUE, k = i)
    pam_clust_num <- (pam_fit$clustering)

    output.stats[i-1,] <- unlist(cluster.stats(d = dist,
                                               clustering = pam_clust_num)[clust.assess])
  }

  colnames(output.stats) <- clust.assess
  rownames(output.stats) <- c(seq(from=2, to=k))

  #return(output.stats)
  output.stats.df <- as.data.frame(output.stats)

  resultado <- median(c(output.stats.df[which.max(output.stats.df$avg.silwidth),]$cluster.number,
                        output.stats.df[which.max(output.stats.df$dunn),]$cluster.number,
                        output.stats.df[which.min(output.stats.df$wb.ratio),]$cluster.number))

  return(resultado)
}


# This function function applies the H-clust clustering method,
# considering Gower distance, and return the results (d)
cstats.table_hclust <- function(dist, tree, k) {
  clust.assess <- c("cluster.number","wb.ratio","dunn","avg.silwidth")
  output.stats <- matrix(ncol = length(clust.assess), nrow = k-1)

  result_list <- lapply(seq(from = 2, to = k), function(i) {
    unlist(cluster.stats(d = dist, clustering = cutree(tree, k = i))[clust.assess])
  })

  output.stats <- do.call(rbind, result_list)

  colnames(output.stats) <- clust.assess
  rownames(output.stats) <- seq(from = 2, to = k)

  output.stats.df <- as.data.frame(output.stats)

  result <- median(c(output.stats.df[which.max(output.stats.df$avg.silwidth),]$cluster.number,
                     output.stats.df[which.max(output.stats.df$dunn),]$cluster.number,
                     output.stats.df[which.min(output.stats.df$wb.ratio),]$cluster.number))

  return(result)
}



# This function filters the summary clusters with 0s and joins the four
# of the into a vector
obtainSummaryCluster <- function(summary_clusters_a, summary_clusters_b,
                                 summary_clusters_c, summary_clusters_d) {
  # remove those rows with only 0s
  nclust_a <- as.data.frame(summary_clusters_a[which(apply(summary_clusters_a[],
                                                           1, sum)>0),])
  nclust_b <- as.data.frame(summary_clusters_b[which(apply(summary_clusters_b[],
                                                           1, sum)>0),])
  nclust_c <- as.data.frame(summary_clusters_c[which(apply(summary_clusters_c[],
                                                           1, sum)>0),])
  nclust_d <- as.data.frame(summary_clusters_d[which(apply(summary_clusters_d[],
                                                           1, sum)>0),])

  # put all the clusters together
  summary_n_clust <- c(apply(nclust_a, 1, function(x) median(x, na.rm=TRUE)),
                       apply(nclust_b, 1, function(x) median(x, na.rm=TRUE)),
                       apply(nclust_c, 1, function(x) median(x, na.rm=TRUE)),
                       apply(nclust_d, 1, function(x) median(x, na.rm=TRUE)))

  return(summary_n_clust)
}


# This function prints the  ClustAll logo
printLogo <- function() {
  message("      ______ __              __   ___     __     __    ")
  message("     / ____// /__  __ _____ / /_ /   |   / /    / /    ")
  message("    / /    / // / / // ___// __// /| |  / /    / /     ")
  message("   / /___ / // /_/ /(__  )/ /_ / ___ | / /___ / /___   ")
  message("  /_____//_/ |__,_//____/ |__//_/  |_|/_____//_____/   ")
}


# The following code has been adapted from the clusteval v0.1 package created
# by John A. Ramey. https://cran.r-project.org/src/contrib/Archive/clusteval
# Also the rcpp_comembership and rcpp_comembership functions in C have been
# adapted to R
cluster_similarity_adapt <- function(labels1, labels2,
                                     similarity = c("jaccard", "rand"),
                                     method = "independence") {
  similarity <- match.arg(similarity)
  method <- match.arg(method)

  # Currently, we ignore the `method` argument and only use the similarity
  # statistics derived under an independence assumption
  switch(similarity,
         jaccard = jaccard_indep(labels1, labels2),
         rand = rand_indep(labels1, labels2))
}


jaccard_indep <- function(labels1, labels2) {
  com_table <- comembership_table(labels1, labels2)
  jaccard_out <- with(com_table, n_11 / (n_11 + n_10 + n_01))

  # In the case where 'labels1' and 'labels2' contain all singletons,the Jaccard
  # coefficient results in the expression 0 / 0, which yields a NaN value in R
  # We define such cases as 0
  if (is.nan(jaccard_out)) {
    warning("The two clusterings contain all singletons -- returning 0.")
    jaccard_out <- 0
  }
  jaccard_out
}


rand_indep <- function(labels1, labels2) {
  com_table <- comembership_table(labels1, labels2)
  with(com_table, (n_11 + n_00) / (n_11 + n_10 + n_01 + n_00))
}


#' @references Tibshirani, R. and  Walther, G. (2005). Cluster Validation by
#' Prediction Strength. Journal of Computational and Graphical Statistics, 14,3,
#' 511-528. \url{http://amstat.tandfonline.com/doi/abs/10.1198/106186005X59243}
comembership <- function(labels) {
  n <- length(labels)

  # The comembership vector is of length "n choose 2"
  comembership <- numeric(n * (n - 1) / 2)

  # The comembership index
  idx_comembership <- 1

  # Traverse through all pairs of observations to identify comemberships
  for (i in seq_len(n - 1)) {
    for (j in (i + 1):n) {
      if (labels[i] == labels[j]) {
        comembership[idx_comembership] <- 1
      }
      idx_comembership <- idx_comembership + 1
    }
  }

  return(comembership)
}

comembership_table <- function(labels1, labels2) {
  n1 <- length(labels1)
  n2 <- length(labels2)

  if (n1 != n2) {
    stop("The two vectors of cluster labels must be of equal length.")
  }

  # The counts of comembership pairs
  # n_11: the number of comemberships in both partitions
  # n_10: the number of comemberships in clustering 1 but not in clustering 2
  # n_01: the number of comemberships in clustering 2 but not in clustering 1
  # n_00: the number of non-comemberships in both partitions
  n_11 <- 0
  n_10 <- 0
  n_01 <- 0
  n_00 <- 0

  # Flags that indicate if the current pair of cluster labels in clusterings 1
  # and 2 are comemberships
  comembership1 <- FALSE
  comembership2 <- FALSE

  # Traverse through all pairs of observations to identify comemberships
  for (i in seq_len(n1 - 1)) {
    for (j in (i + 1):n1) {
      # If either of the clusterings have a comembership, set the comembership
      # flag as true.
      comembership1 <- labels1[i] == labels1[j]
      comembership2 <- labels2[i] == labels2[j]

      if (comembership1 && comembership2) {
        n_11 <- n_11 + 1
      } else if (comembership1 && !comembership2) {
        n_10 <- n_10 + 1
      } else if (!comembership1 && comembership2) {
        n_01 <- n_01 + 1
      } else {  # if (!comembership1 && !comembership2)
        n_00 <- n_00 + 1
      }
    }
  }

  # Returns a list that contains the 2x2 contingency table results
  return(list(n_11 = n_11, n_10 = n_10, n_01 = n_01, n_00 = n_00))
}


# END OF ClustAll_runClustAll_internal.R

data("testData", package = "ClustAll")

# Test to check obtained sratifications with simplified parameter are the same
test_simplify <- function() {
  checkEquals(obj_noNA1@summary_clusters$cuts_a_9,
              obj_noNA1simplify@summary_clusters$cuts_a_9)
  checkEquals(obj_noNA1@summary_clusters$cuts_b_13,
              obj_noNA1simplify@summary_clusters$cuts_b_13)
}

# Internal functions -----------------------------------------------------------
# ## This functions are for testing internal functions from runClustAll.
# ##As these function are not exported cannot be tested.
# ## This tests are for internal development.
# require(bigstatsr)
# require(FactoMineR)
# require(stats)
# require(fpc)
#
# source("R/ClustAll_runClustAll_internal.R")
#
# # Test for createEmptyArrays, create the empty arrays correctly
# test_createEmptyArrays <- function() {
#   data <- matrix(1:9, nrow = 3)
#   nvariables <- 2
#   empty_arrays <- createEmptyArrays(2, data)
#   checkEquals(length(empty_arrays), nvariables) # check there are as many arrays as variables
#   for (i in seq_along(empty_arrays)) {
#     checkEquals(dim(empty_arrays[[i]]), c(nrow(data), nrow(data))) # check dimensions of the arrays/matrix
#     checkTrue(all(empty_arrays[[i]][] == 0))  # check every value is 0
#   }
# }
#
# # Test for obtainDataPCA, generate the PCA correctly
# test_obtainDataPCA <- function() {
#   set.seed(123)
#   data <- matrix(rnorm(50), ncol = 5)
#   colnames(data) <- c("A", "B", "C", "D", "E")
#   rownames(data) <- c(1:10)
#
#   cor_est_var <- cor(data, method="spearman")
#   variables_clust <- hclust(as.dist(cor_est_var))
#   possible_heights <- variables_clust$height
#   heights_cut <- 2
#
#   data_PCA <- obtainDataPCA(data, variables_clust, possible_heights, heights_cut)
#   checkTrue(is(data_PCA, "matrix")) # check it's a matrix
#   checkTrue(ncol(data_PCA) < ncol(data)) # expected less columns as original data as it is a PCA
# }
#
# # Test for obtainImputationData, fill the NA values correctly
# test_obtainImputationData <- function() {
#   set.seed(123)
#   data <- data.frame(matrix(sample(c(1:5, NA), 100, replace = TRUE), ncol = 10))
#   dataImputed <- mice::mice(data, m=2, maxit=5, seed=123)
#   impgo <- 2
#   impData <- obtainImputationData(dataImputed, impgo)
#   checkTrue(is(impData, "data.frame")) # expect obtained a data frame
#   checkEquals(sum(is.na(impData)), 0) # check there are no NAs
#   checkTrue(!anyNA(impData)) # check again there is no NAs
# }
#
# # Test for cstats.table_hclust
# test_cstats.table_hclust <- function() {
#   set.seed(123)
#   dist <- dist(matrix(rnorm(100), ncol = 10))
#   tree <- hclust(dist)
#   k <- 3
#   result <- cstats.table_hclust(dist, tree, k)
#   checkTrue(is(result, "numeric")) # check obtained a numeric vector
#   checkEquals(length(result), 1) # check there is only one result
# }
#
# # Test for cstats.table_PAM, the statistic calculation is correct
# test_cstats.table_PAM <- function() {
#   set.seed(123)
#   dist <- dist(matrix(rnorm(100), ncol = 10))
#   k <- 3
#   result <- cstats.table_PAM(dist, k)
#   checkTrue(is(result, "numeric")) # check obtained a numeric vector
#   checkEquals(length(result), 1) # check there is only one result
# }
#
# # Test for obtainSummaryCluster, summarize correctly
# test_obtainSummaryCluster <- function() {
#   summary_clusters_a <- matrix(9:17, nrow = 3)
#   summary_clusters_b <- matrix(rep(1, 9), nrow = 3)
#   summary_clusters_c <- matrix(1:9, nrow = 3)
#   summary_clusters_d <- matrix(rep(2, 9), nrow = 3)
#   summary_n_clust <- obtainSummaryCluster(summary_clusters_a, summary_clusters_b, summary_clusters_c, summary_clusters_d)
#   checkTrue(is(summary_n_clust, "numeric")) # check all values numeric
#   checkEquals(length(summary_n_clust), 12)  # The length must be the sum of the rows of all matrices
# }
#
# # Test for cluster_similarity_adapt, check that the cluster membership is calculated correctly
# test_cluster_similarity_adapt <- function() {
#   labels1 <- c(1, 1, 2, 2)
#   labels2 <- c(1, 1, 1, 2)
#   labels3 <- c(2, 2, 1, 1)
#   labels4 <- c(1, 2, 1, 2)
#
#   similarity1 <- cluster_similarity_adapt(labels1, labels2, similarity = "jaccard") # expect 0.25
#   checkEquals(similarity1, 0.25)
#   similarity2 <- cluster_similarity_adapt(labels1, labels1, similarity = "jaccard") # expect 1  checkEquals(similarity1, 0.25)
#   checkEquals(similarity2, 1)
#   similarity3 <- cluster_similarity_adapt(labels1, labels3, similarity = "jaccard") # expect 1
#   checkEquals(similarity3, 1)
#   similarity4 <- cluster_similarity_adapt(labels1, labels4, similarity = "jaccard") # expect 0
#   checkEquals(similarity4, 0)
#
#   checkTrue(is(similarity1, "numeric")) # check result numeric
#   checkEquals(length(similarity1), 1) # check only 1 result
# }

##########################################################
# Running the pipeline with parallelization
##########################################################
require("ClustAll")
data("BreastCancerWisconsin", package = "ClustAll") # load example data
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8] # reduce the number of variables for a less computational time
obj <- createClustAll(data = wdbc, colValidation = NULL,
                      nImputation = NULL, dataImputed = NULL)


test_pipeline1 <- function() {
  # 1. No parallelization, 2. YES simplified (use all depth)
  runClustAll(obj, threads = 1, simplify = TRUE)
}
#
test_pipeline2 <- function() {
  # 1. YES parallelization, 2. YES simplified (one depth every four)
  runClustAll(obj, threads = 2, simplify = TRUE)
}

###########################################
# All possibilities to create the object
###########################################
require("ClustAll")
data("BreastCancerWisconsin", package = "ClustAll")
data("BreastCancerWisconsinMISSING", package = "ClustAll")

test_creatingClustAll1 <- function() {
  # Scenario 1: 1.No NA, 2.No imputation, 3.No imputation implemented
  createClustAll(data = wdbc, colValidation = "Diagnosis",
                 nImputation = NULL, dataImputed = NULL)
}

test_creatingClustAll2 <- function() {
  # Scenario 2: 1.Yes NA, 2.Yes imputation, 3.Imputations automatically (default)
  createClustAll(wdbcNA, nImputation = 2,  colValidation = "Diagnosis")
  createClustAll(wdbcNA, dataImputed = wdbcMIDS,
                 colValidation = "Diagnosis")
}

test_creatingClustAll3 <- function() {
  # Scenario 3: 1.Yes NA, 2.Yes imputation, 3.Imputations manually
  createClustAll(wdbcNA, dataImputed = wdbcMIDS,
                 colValidation = "Diagnosis")
}

# createClustAll ---------------------------------------------------------------
#' @title Create ClustAllObject for Patient Stratification Analysis
#' @aliases createClustAll,data.frame,numericOrNA,ANY,characterOrNA-method
#' @description
#' This function initializes a ClustAllObject, which serves as the core data
#' structure for the ClustAll package. It preprocesses the input data, handles
#' missing values through imputation if necessary, and prepares the data for
#' subsequent clustering analysis.
#'
#' @usage createClustAll(data, nImputation = NULL, dataImputed = NULL,
#'                       colValidation = NULL)
#'
#' @param data A data frame containing the input data. It may include missing
#' values (NAs) and can contain both numeric and categorical variables.
#' @param nImputation An integer specifying the number of imputations to perform
#' if the data contains missing values. Default is NULL, which means no imputation
#' unless missing values are detected.
#' @param dataImputed A 'mids' object created by the mice package, containing
#' pre-computed imputations. If provided, this will be used instead of performing
#' new imputations. Default is NULL.
#' @param colValidation A character string specifying the name of the column in
#' 'data' that contains validation labels (true classifications). This column
#' will be extracted and stored separately. Default is NULL.
#'
#' @return An unprocessed ClustAllObject without stratification results. Use
#' runClustAll on this object to execute the ClustAll pipeline.
#'
#' @details
#' The createClustAll function performs several key steps in preparing data for
#' the ClustAll analysis pipeline:
#'
#' \enumerate{
#'   \item Data Preprocessing:
#'   \itemize{
#'     \item Applies one-hot encoding to categorical variables, converting them to
#'           a format suitable for clustering algorithms.
#'     \item Extracts the validation column (if specified) and stores it separately.
#'   }
#'
#'   \item Missing Data Handling:
#'   \itemize{
#'     \item If the data contains missing values and no imputed data is provided,
#'           it performs multiple imputation using the mice package.
#'     \item The number of imputations is determined by the 'nImputation' parameter
#'           or set to a default if not specified.
#'   }
#'
#'   \item Object Initialization:
#'   \itemize{
#'     \item Creates a new ClustAllObject with slots for original data, processed data,
#'           imputed data (if applicable), and validation data (if provided).
#'   }
#' }
#'
#' The function accommodates three main scenarios:
#' \itemize{
#'   \item Data without missing values: Preprocessing is applied, no imputation needed.
#'   \item Data with missing values, no pre-computed imputations: Automatic imputation is performed.
#'   \item Data with missing values and pre-computed imputations: The provided imputations are used.
#' }
#'
#' @note
#' \itemize{
#'   \item Categorical variables in the input data should be coded as factors.
#'   \item If 'dataImputed' is provided, it must correspond exactly to the input data
#'         in terms of dimensions and variable names.
#'   \item The 'colValidation' parameter allows for the incorporation of known
#'         classifications, which can be used later for validating clustering results.
#'   \item After creating the ClustAllObject, use \code{\link{runClustAll}} to perform
#'         the actual clustering analysis.
#' }
#'
#' @seealso \code{\link{runClustAll}}, \code{\link{ClustAllObject-class}},
#' \code{\link{addValidationData}}
#'
#' @examples
#' # Scenario 1: data does not contain missing values
#' data("BreastCancerWisconsin", package = "ClustAll")
#' wdbc <- wdbc[,-c(1,2)]
#' obj_noNA <- createClustAll(data = wdbc)
#'
#' # Scenario 2: data contains NAs and there is no imputed data.
#' # Then it performs the imputations automatically
#' data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' \donttest{
#' obj_NA <- createClustAll(wdbcNA, nImputation = 2)
#' }
#' # Scenario 3: data contains NAs and imputed data is provided manually
#' data("BreastCancerWisconsinMISSING", package = "ClustAll")
#' ini <- mice::mice(wdbcNA, maxit = 0, print = FALSE)
#' pred <- ini$pred # predictor matrix
#' pred["radius1", c("perimeter1", "area1", "smoothness1")] <- 0 # example of
#' # how to remove predictors
#' \donttest{
#' imp <- mice::mice(wdbcNA, m=5, pred=pred, maxit=5, seed=1234, print=FALSE)
#' obj_imp <- createClustAll(data=wdbcNA, dataImputed = imp)
#' }
#'
#' @export
setGeneric(
  name="createClustAll",
  def=function(data=data, nImputation=NULL, dataImputed=NULL,
               colValidation=NULL)
  {standardGeneric("createClustAll")}
)

setMethod(
  f="createClustAll",
  signature=signature(
    data="data.frame",
    nImputation="numericOrNA",
    dataImputed="ANY",
    colValidation="characterOrNA"),
  definition=function(data=data, nImputation=NULL,
                      dataImputed=NULL, colValidation=NULL) {
    dataOriginal <- data
    if (is.null(dataImputed)) {imputedNull <- TRUE} else {imputedNull <- FALSE}
    if (is.null(nImputation)) {nImputation <- 0}
    data <- checkDataIntroduced(data)
    nImputation <- validnImputation(nImputation, imputedNull)

    if (!is.null(colValidation)) {
      checkColumn(data, colValidation)
      dataValidation <- data[, colValidation]
      data <- subset(data, select = -which(colnames(data)==colValidation))
    } else {
      dataValidation <- NULL
    }

    if (validData(data, nImputation, dataImputed)) {nImputation <- 0}
    if (nImputation == 0 & is.null(dataImputed)) {
      dataImputed <- NULL
    } else if (is.null(dataImputed)) {
      message("Running default multiple imputation method.")
      message("For more information check mice package.")
      dataImputed <- mice(data, m=nImputation, maxit=5, seed=1234)
    } else if (!is.null(dataImputed)) {
      # check the imputed data
      if (validDataImputed(data=data, dataImputed=dataImputed,
                           dataOriginal=dataOriginal)) {
        nImputation <- dataImputed$m
      }
    }
    clustAllObj <- new("ClustAllObject",data=data,dataOriginal=dataOriginal,
                       dataImputed=dataImputed, nImputation=nImputation,
                       dataValidation=dataValidation)
    message("\nClustALL object was created successfully. You can run runClustAll.")

    return(clustAllObj)
  }
)
# END OF ClustAll_createClustAll.R

# ClustAllObject_Methods_internal functions definition -------------------------
# These functions are not meant to be invoked directly by the user.
# See the ClustAllObject_Methods functions instead.

# This function returns a vector with the definitive stratifications based on
# the distance matrix
obtainDefCluster <- function(mat_using, cluster_similarity=0.7){
    candidates_clustering <- c()
    definitive_clusters <- list()
    j <- 1

    for (i in seq_len(ncol(mat_using)-1)) {
        # Avoid repeating same cluster
        if (i < j-1 | base::names(mat_using[i,])[j] %in% candidates_clustering) {
            next
        }

        if (i == ncol(mat_using)-1) {
            if (mat_using[i,i+1] >= cluster_similarity) {
                candidates_clustering <- c(base::names(mat_using[i,])[i],
                                           base::names(mat_using[i,])[i+1])
                definitive_clusters <- append(definitive_clusters,
                                                list(candidates_clustering))
            }
        } else {

            if (mat_using[i,i+1] >= cluster_similarity) {
                candidates_clustering <- c(base::names(mat_using[i,])[i])

                for (j in seq(from=(i+1), to=(ncol(mat_using)))) {

                    if (j==ncol(mat_using)) {
                        candidates_clustering <- c(candidates_clustering,
                                                   base::names(mat_using[i,])[j])
                        definitive_clusters <- append(definitive_clusters,
                                                    list(candidates_clustering))
                        break
                }

                if(mat_using[i,j] >= cluster_similarity) {
                    candidates_clustering <- c(unique(candidates_clustering),
                                               base::names(mat_using[i,])[j])
                    if (j == (ncol(mat_using)-2)) {
                        append(definitive_clusters, list(candidates_clustering))
                    }

            # The lower this value is, the larger group of clusters is obtained
                } else if (mat_using[i+1,j] >= cluster_similarity){
                    candidates_clustering <- c(unique(candidates_clustering),
                                               base::names(mat_using[i,])[j])
                    if (j == (ncol(mat_using)-2)) {
                        append(definitive_clusters, list(candidates_clustering))
                    }
                } else {
                    definitive_clusters <- append(definitive_clusters,
                                                    list(candidates_clustering))
                    break
                    }
                }
            }
        }
    }

    min_NperGroup <- 3
    definitive_clusters <- definitive_clusters[which(unlist(lapply(definitive_clusters,
                                               function(x) {length(x)>=min_NperGroup})))]

    return(definitive_clusters)
}


# Choose the representative stratification considering at least a minimum
# percentage of the total population in each cluster. Default is 0.05 (5%)
chooseClusters <- function(definitive_clusters, summary_clusters,
                           population = 0.05, all = TRUE) {
  if (0 > population | population >= 1) {
    message("Not a valid value. A value from 0 to 1 should be introduced.")
    message("Clusters contain at least 5% of the total population.")
    population <- 0.05
  }

  chosen_clusters <- list()

  possible_stratifications <- lapply(summary_clusters, function(cluster) {
    as.numeric(table(cluster))
  })

  definitive_clusters <- lapply(definitive_clusters, function(cluster) {
    for (j in cluster) {
      if (min(unlist(possible_stratifications[j])) < (length(summary_clusters[[1]])) * population) {
        cluster <- cluster[cluster != j]
      }
    }
    return(cluster)
  })

  chosen_clusters <- lapply(definitive_clusters, function(cluster) {
    if (length(cluster) == 0) {
      return(NULL)
    } else if ((length(cluster) %% 2) == 0) {
      return(cluster[length(cluster) / 2])
    } else {
      return(cluster[ceiling(length(cluster) / 2)])
    }
  })

  if (all == TRUE) {
    return(definitive_clusters)
  } else {
    return(chosen_clusters)
  }
}


# This function checks if the introduced cluster exists in the list of clusters
checkCluster <- function(cluster, lCluster) {
  stopProcess <- FALSE
  booleans <- cluster %in% base::names(lCluster)

  if(any(!booleans)) {
    message("The following cluster(s) do(es) not exist:")
    message(paste0(cluster[!booleans], sep="\n"))
    message("You may want to check the clusters using resStratification.")
    stopProcess <- TRUE
  }

  if (stopProcess){
    stop()
  }
}


# This function obtains the metadata fot the stratifications displayed in the
# correlation matrix heatmap with the Jaccard distance between robust
# stratifications
obtain_metadata <- function(m) {
    names <- rownames(m)
    split_names <- strsplit(names, "_")
    names_clustering <- sapply(split_names, function(x) x[2])
    names_depth <- sapply(split_names, function(x) as.numeric(x[3]))
    names_distance <- ifelse(names_clustering %in% c("a", "b"), "Correlation",
                                "Gower")
    names_clusteringmeth <- names_clustering
    names_clusteringmeth[which(names_clusteringmeth %in% c("b",
                                                        "d"))] <- "H-Clustering"
    names_clusteringmeth[which(names_clusteringmeth == "a")] <- "K-Means"
    names_clusteringmeth[which(names_clusteringmeth == "c")] <- "K-Medoids"

    return(data.frame("Distance"=names_distance,
                        "Clustering"=names_clusteringmeth,
                        "Depth"=names_depth))
}
# END OF ClustAll_ClustAllObject_Methods_internal.R

data("testData", package = "ClustAll")

# Test obtain expected result for a certain similarity
test_defClusters <- function() {
  expected_result <- c("cuts_a_28", "cuts_c_9",  "cuts_c_4")
  result <- resStratification(Object=obj_noNA1, stratification_similarity=0.9,
                              all = F)

  checkEquals(names(result), expected_result)
}

# Test for validation data does not exist
test_validationData <- function() {
  validateStratification(obj_noNA1, stratificationName = "cuts_b_13")
  checkException(validateStratification(obj_noNA1, stratificationName = "NOTexist"))
  checkException(plotSANKEY(obj_noNA1, clusters = c("cuts_b_13","NOTexist")))
  checkException(cluster2data(obj_noNA1, stratificationName = "NOTexist"))

  checkException(plotSANKEY(obj_noNAno1Validation, clusters = "cuts_b_13", validationData = TRUE)) # exception as validation data is not included
  checkException(validateStratification(obj_noNAno1Validation, stratificationName = "cuts_b_13")) # exception as validation data is not included
}


# Internal functions -----------------------------------------------------------
# ## This functions are for testing internal functions from runClustAll.
# ##As these function are not exported cannot be tested.
# ## This tests are for internal development.
#
# # source("R/ClustAll_ClustAllObject_Methods_internal.R")
#
# # Test for obtainDefCluster
# test_obtainDefCluster <- function() {
#   mat_using <- matrix(c(1, 0.75, 0.4, 0.11, 0.75, 1, 0.12 , 0.12, 0.4, 0.12, 1, 0.13, 0.11, 0.12, 0.13, 1), nrow = 4)
#   colnames(mat_using) <- c("Cluster_1", "Cluster_2", "Cluster_3", "Cluster_4")
#   rownames(mat_using) <- c("Cluster_1", "Cluster_2", "Cluster_3", "Cluster_4")
#
#   cluster_similarity <- 0.7
#   expected_result <- list(c("Cluster_1", "Cluster_2"))
#   result <- obtainDefCluster(mat_using, cluster_similarity)
#   checkEquals(result, expected_result)
# }
#
# # Test for chooseClusters, that obtains the correctly the clusters taking into account the population
# test_chooseClusters <- function() {
#   definitive_clusters <- list(c("Cluster_1", "Cluster_2"))
#   summary_clusters <- list("Cluster_1" = c(1, 1, 1, 2), "Cluster_2" = c(1, 2, 2, 1))
#   population1 <- 0.15
#   population2 <- 0.35
#   expected_result <-
#   resultAll <- chooseClusters(definitive_clusters, summary_clusters, population1, all=TRUE)
#   resultNoAll <- chooseClusters(definitive_clusters, summary_clusters, population1, all=FALSE)
#   resulPopulation <- chooseClusters(definitive_clusters, summary_clusters, population2, all=TRUE)
#   checkEquals(resultAll, list(c("Cluster_1", "Cluster_2"))) # Expected to obtain all the result
#   checkEquals(resultNoAll, list("Cluster_1")) # Expected to obtain only the representative
#   checkEquals(resulPopulation, list("Cluster_2")) # Population is 35% expected only obtain Cluster_2
# }
#
# # Test checkCluster, checks that the cluster exist
# test_checkCluster <- function() {
#   lCluster <- c("Cluster_1", "Cluster_2")
#   names(lCluster) <- lCluster
#   checkCluster("Cluster_1", lCluster)
#   checkException(checkCluster("Cluster_3", lCluster))
# }
#
# # Test for obtain_metadata, extracts the metadata correctly
# test_obtain_metadata <- function() {
#   set.seed(123)
#   data <- matrix(runif(16), nrow = 4, ncol = 4)
#   colnames(data) <- c("cuts_a_1", "cuts_b_2", "cuts_c_3", "cuts_d_4")
#   rownames(data) <- c("cuts_a_1", "cuts_b_2", "cuts_c_3", "cuts_d_4")
#
#   expected_result <- data.frame("Distance" = c("Correlation", "Correlation", "Gower", "Gower"),
#                                 "Clustering" = c("Hierarchical", "k-means", "Hierarchical", "k-medoids"),
#                                 "Depth" = c(1, 2, 3, 4))
#   result <- obtain_metadata(data)
#   checkEquals(result, expected_result)
# }

require(mice)

# Unit tests for the introduced data is correct, and transformed correctly
test_introducedData <- function() {
  data_binary <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B")) # b is binary
  data_categorical <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B"), # b is binary and c has 3 categories
                                 c = c("A", "B", "A", "C"))
  data_categorical2 <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B"), # b is binary and c has 4 categories
                                  c = c("A", "B", "C", "D"))

  obj_binary <- createClustAll(data=data_binary)
  obj_categorical <- createClustAll(data=data_categorical)
  obj_categorical2 <- createClustAll(data=data_categorical2)

  checkEquals(ncol(obj_binary@data), ncol(data_binary)) # Expected same number of columns as the introduced data (b) is binary

  additional_columns <- length(unique(data_categorical$c)) - 1  # In one hot encoding expected one binary column for each categorical value
  checkEquals(ncol(data_categorical) + additional_columns, ncol(obj_categorical@data))

  additional_columns2 <- length(unique(data_categorical2$c)) - 1  # In one hot encoding expected one binary column for each categorical value
  checkEquals(ncol(data_categorical2) + additional_columns2, ncol(obj_categorical2@data))

  checkTrue(!any(sapply(obj_binary@data, is.character)))  # There should be no categorical variables after the transformation
  checkTrue(!any(sapply(obj_categorical@data, is.character)))  # There should be no categorical variables after the transformation
}

# Unit tests for valid number of imputations
test_nImputation <- function() {
  data_NA <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B"),
                        c = c("A", "B", "A", NA))
  data_noNA <- data.frame(a = c(1, 2, 3, 4), b = c("A", "A", "A", "B"),
                          c = c("A", "B", "A", "B"))
  objnoNA <- createClustAll(data=data_noNA, nImputation = 2) # When no NA values no imputations happens
  checkEquals(objnoNA@nImputation, 0) # Even we specified 2 imputations should not have as it not contains NAs

  obj_NAn1 <- createClustAll(data=data_NA, nImputation = 2)
  obj_NAn25 <- createClustAll(data=data_NA, nImputation = 2.5) # round down
  obj_NAn26 <- createClustAll(data=data_NA, nImputation = 2.6) # round up

  checkEquals(obj_NAn1@nImputation, 2)
  checkEquals(obj_NAn25@nImputation, 2)
  checkEquals(obj_NAn26@nImputation, 3)

  checkException(createClustAll(data=data_NA, nImputation = 0)) # 0 imputation are not allowed when there are NAs
  checkException(createClustAll(data=data_NA, nImputation = -1)) # negative values are not allowed
  checkException(createClustAll(data=data_NA, nImputation = "NOTnumber")) # not numeric vector allowed
}

# Unit tests when imputations are done manually
test_ValidImputation <- function() {
  data_NA <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B"),
                        c = c("A", "B", "A", NA))

  dataImputed <- mice::mice(data_NA, m=2, maxit=5, seed=123) # manual imputation
  obj_imputed <- createClustAll(data_NA, dataImputed = dataImputed)  # Expected it works as the original data is the same
}

test_addValidationData <- function() {
  data_validation <- data.frame(a = c(1, 2, 3, 4), b = c("A", "B", "A", "B"), # b is binary and c has 3 categories
                                c = c("A", "B", "A", "A"), d = c(1, 1, 1, 2)) # d is validation data
  obj_validation <- createClustAll(data=data_validation, colValidation = "d")
  checkEquals(ncol(obj_validation@data), ncol(data_validation)-1) # expected one column less as the validation column has been substracted

  checkException(createClustAll(data=data_validation, colValidation = "NOTexist")) # introduced a not existing validation data

  validation <- c(1, 1, 1, 2)
  incorrectValidation <- c(1, 1, 1, 2, 1) # more elements than patients

  obj_noValidation <- createClustAll(data_validation)
  addValidationData(obj_noValidation, validation) # add validation after creating object
  checkException(addValidationData(obj_noValidation, incorrectValidation))
}

---
title: "ClustAll User's Guide"
author: "Asier Ortega-Legarreta and Sara Palomino-Echeverria"
package: ClustAll
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{ClustALL User's Guide}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

```{r style, echo = FALSE, results = 'asis', include=FALSE}
BiocStyle::markdown()
knitr::opts_chunk$set(
  collapse = TRUE,
  cache = FALSE,
  comment = "#>"
)
```

# Introduction

ClustAll is an R package designed for patient stratification in complex diseases. It addresses common challenges encountered in clinical data analysis and provides a versatile framework for identifying patient subgroups.

Patient stratification is essential in biomedical research for understanding disease heterogeneity, identifying prognostic factors, and guiding personalized treatment strategies. The ClustAll underlying concept is that a robust stratification should be reproducible through various clustering methods. ClustAll employs diverse distance metrics (Correlation-based distance and Gower distance) and clustering methods (K-Means, K-Medoids, and H-Clust).

## ClustAll key features:

-   **Handles Diverse Data Types**, including missing values, mixed data, and correlated variables.
-   **Provides Multiple Stratification Solutions**, enabling exploration of different clustering algorithms and parameters.
-   **Robustness Analysis**, to identify stable and reproducible clusters.
-   **Validation** , for assessing the reliability of clustering results using clinical phenotypes (ground truth) if available.
-   **Visualization** functions for interpreting clustering results and comparing different stratifications.

## Interpreting ClustAll Stratification Output

The names of ClustAll stratification outputs consist of a letter followed by a number, such as *cuts_a\_9*. The letter denotes the combination of distance metric and clustering method utilized to generate the particular stratification, while the number corresponds to the embedding derived from the depth at which the dendrogram with grouped variables was cut.

```{r, echo=FALSE}
table <- data.frame(Nomenclature=c("a","b","c","d"), 
                    `Distance Metric`=rep(c("Correlation", "Gower"), each=2), 
                    `Clustering Method`=c("K-means", "Hierarchical Clustering", 
                                          "K-medoids", "Hierarchical-Clustering"))
```

```{r, echo=FALSE}
knitr::kable(table, align = c("l", "l", "l"), caption = "ClustAll Stratification Output Interpretation")
```

![Schematic representation of the ClustAll pipeline](./img/workflow.jpg)


# Installation

ClustAll is developed using S4 object-oriented programming, and requires R (\>=4.2.0). It utilizes other R packages that are currently available from CRAN and Bioconductor.

You can find the package repository on GitHub, [ClustAll](https://github.com/translationalBioinformaticsUnit/ClustAll).

The ClustAll package can be downloaded and installed by running the following code within R:

```{r installation, eval=FALSE}
if (!require("BiocManager", quietly = TRUE)) install.packages("BiocManager ")

BiocManager::install("ClustAll")
```

After installation, load the ClustAll package:

```{r load package}
library(ClustAll)
```

# ClustAll Application Example

We will use the data provided in the data package [ClustAll](https://github.com/translationalBioinformaticsUnit/ClustAll) to demonstrate how to stratify a population using clinical data.

**Breast Cancer Wisconsin (Diagnostic)** ClustAll includes a real dataset of breast cancer, described at [doi: 10.24432/C5DW2B](https://doi.org/10.24432/C5DW2B). This dataset comprises two types of features ---categorical and numerical--- derived from a digitized image of a fine needle aspirate (FNA) of a breast mass from 659 patients. Each patient is characterized by 30 features (10x3) and belongs to one of two target classes: 'malignant' or 'benign'. To showcase ClustAll's when dealing with missing data, a modification with random missing values was applied to the dataset, demonstrating the package's resilience in handling missing data. The breast cancer dataset includes the following features:

a)  **radius:** Mean of distances from the center to points on the perimeter.
b)  **texture:** Standard deviation of gray-scale values.
c)  **perimeter:** Perimeter of the breast mass affected by the cancer.
d)  **area:** Area of the breast mass affected by the cancer
e)  **smoothness:** Local variation in radius lengths.
f)  **compactness:** (Perimeter\^2 / Area) - 1.0.
g)  **concavity:** Severity of concave portions of the contour.
h)  **concave points:** Number of concave portions of the contour.
i)  **symmetry:** Degree of symmetry in the shape and structure of the breast mass, with higher values indicating greater symmetry and lower values indicating asymmetry.
j)  **fractal dimension:** "Coastline approximation" - 1.

The dataset also includes the patient ID and diagnosis (M = malignant, B = benign).

We denote the data set as BreastCancerWisconsin (wdbc).

## Get data from example

We load the breast cancer dataset, which is available in [Kaggle](https://www.kaggle.com/datasets/uciml/breast-cancer-wisconsin-data). The data set can be loaded with the following code:

```{r load data}
data("BreastCancerWisconsin", package = "ClustAll") 

data_use <- subset(wdbc, select=-ID)
```

An initial exploration reveals the absence of missing values. The dataset comprises 30 numerical features and one categorical feature (the ground truth). As the initial data does not contain missing values we will apply the ClustAll workflow accordingly.

```{r check missing values}
sum(is.na(data_use)) 
dim(data_use)
```

## Create the ClustAll object

First, the ClustAllObject is created and stored. In this step, we indicate if there is a feature that contains the ground truth (true labels) in the argument `colValidation`. This feature is not consider to compute the stratification. In this specific case, it corresponds to "Diagnosis".

```{r create ClustAllObject}
obj_noNA <- createClustAll(data = data_use, nImputation = NULL, 
                           dataImputed = NULL, colValidation = "Diagnosis")
```

## Execute the ClustAll algorithm

Next, we apply the ClustAll algorithm. The output is stored in a ClustAllObject, which contains the clustering results.

```{r run ClustAll, results=FALSE}
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 2, simplify = FALSE)
```

We show the object:

```{r check result}
obj_noNA1
```

## Represent the Jaccard Distance between population-robust stratifications

To display population-robust stratifications (\>85% bootstrapping stability), we call `plotJaccard`, using the ClustAllObject as input. In addition, we specify the threshold to consider similar a pair of stratifications in the `stratification_similarity` argument.

In this specific case, a similarity of 0.9 reveals three different groups of alternatives for stratifying the population, indicated by the the red rectangles:

```{r plot1, fig.height=12, fig.width=12, warning=FALSE, fig.cap = "Correlation matrix heatmap. It depcits the similarity between population-robust stratifications. The discontinuous red rectangles highlight alternative stratifications solutions based on those stratifications that exhibit certain level of similarity. The heatmap row annotation describes the combination of parameters —distance metric, clustering method, and embedding number— from which each stratification is derived."}

plotJACCARD(Object = obj_noNA1, stratification_similarity = 0.9, paint = TRUE)
```

## Retrieve stratification representatives

We can displayed the centroids (a representative) from each group of alternative stratification solutions (highlighted in red squares in the previous step) using `resStratification`. Each representative stratification illustrates the number of clusters and the patients belonging to each cluster.

In this case, the alternative stratifications have been computed with the following specifications:

-   cuts_a\_28: This stratification was generated using Embedding 28 with the correlation distance metric and the kmeans clustering algorithm. It consists of two clusters, with 183 and 386 patients, respectively.
-   cuts_c\_9: This stratification was generated using Embedding 9 with the gower distance metric and the kmedoids clustering algorithm. It consists of two clusters, with 197 and 372 patients, respectively.
-   cuts_c\_4: This stratification was generated using Embedding 4 with the Gower distance metric and the kmedoids algorithm. It consists of two clusters, with 199 and 370 patients, respectively.

```{r explore representative clusters}
resStratification(Object = obj_noNA1, population = 0.05, 
                  stratification_similarity = 0.9, all = FALSE)
```

## Generate Sankey diagrams comparing pairs of stratifications, or a stratification with the ground truth

In order to compare two sets of representative stratifications, `plotSankey` was implemented. The ClustAllObject is used as input. In addition, we specify the pairs of stratifications we want to compare in the `clusters` argument.

In this case, the first Sankey plot illustrates patient transitions between two sets of representative stratifications (cuts_c\_9 and cuts_a\_28), revealing the flow and distribution of patients across the clusters. The second Sankey plot illustrates patient transitions between a representative stratifications (cuts_a\_28) and the ground truth, revealing the flow and distribution of patients across the clusters.

```{r plot2, fig.cap = "Flow and distribution of patients across clusters. Patient transitions between representative stratifications cuts_c_3 and cuts_a_9.", echo = FALSE}
plotSANKEY(Object = obj_noNA1, clusters = c("cuts_c_9","cuts_a_28"), 
           validationData = FALSE)
```

```{r plot3, fig.cap = "Flow and distribution of patients across clusters. Patient transitions between representative stratifications cuts_c_9 and the ground truth.", echo = FALSE}
plotSANKEY(Object = obj_noNA1, clusters = c("cuts_c_9"), 
           validationData = TRUE)
```

## Retrieve the original dataset with the selected ClustAll stratification(s)

The stratification representatives can be added to the initial dataset to facilitate further exploration.

In this case, we add the three stratification representatives to the dataset. For simplicity, we show the two top rows of the dataset:

```{r export stratifications}
df <- cluster2data(Object = obj_noNA1,
                   stratificationName = c("cuts_c_9","cuts_a_28","cuts_c_4"))
head(df,3)
```

## Assess the results the sensitivity and specifity of the selected ClustAll stratifications against ground truth (if available)

To evaluate the performance of the selected ClustAll stratifications against ground truth, sensitivity and specificity can be assessed using `validateStratification`. Higher values indicate greater precision in the stratification process.

In this particular case, our method retrieves three stratification representatives with a sensitivity and specificity exceeding 80% and 90%, respectively, despite being computed using different methods. These results underscore the notion that a robust stratification should be consistent across diverse clustering methods.

```{r validate stratifications}
# STRATIFICATION 1
validateStratification(obj_noNA1, "cuts_a_28")
# STRATIFICATION 2
validateStratification(obj_noNA1, "cuts_c_9")
# STRATIFICATION 3
validateStratification(obj_noNA1, "cuts_c_4")
```

# Session Info

```{r session info}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{extractResults}
\alias{extractResults}
\alias{extractResults,ClustAllObject-method}
\title{Extract Clustering Results from ClustAllObject}
\usage{
extractResults(Object)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this function.}
}
\value{
A list containing two elements:
\itemize{
  \item All_clusters: A list of all stratifications generated by the ClustALL algorithm.
  \item Robust_clusters: A list of statistically robust stratifications that passed
    the bootstrapping process.
}
If \code{\link{runClustAll}} has not been executed, the function returns a list
with a single NULL element.
}
\description{
This function retrieves the complete set of clustering results from a
processed ClustAllObject, including all generated stratifications and the
subset of statistically robust stratifications. It provides comprehensive
access to the outcomes of the ClustALL algorithm.
}
\details{
The extractResults function provides comprehensive access to the clustering
outcomes of the ClustALL algorithm:
\itemize{
  \item All_clusters: Contains every stratification generated, regardless of
    statistical robustness. Each element is a vector of cluster assignments
    for the samples.
  \item Robust_clusters: A subset of All_clusters, containing only those
    stratifications that passed the bootstrapping process for population-based
    robustness.
}
This function is particularly useful for:
\itemize{
  \item Comprehensive analysis of all generated clustering solutions.
  \item Comparing robust stratifications with non-robust ones.
  \item Exporting clustering results for further analysis in other tools.
  \item Assessing the impact of robustness criteria on stratification selection.
}
}
\note{
This function will return a list with a single NULL element if
\code{\link{runClustAll}} has not been executed on the object. Always check
if the returned list contains valid results before proceeding with analysis.
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
\donttest{
obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
extractResults(obj_noNA1)
}

}
\seealso{
\code{\link{runClustAll}}, \code{\link{summary_clusters}},
\code{\link{resStratification}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Methods.R
\name{plotSANKEY}
\alias{plotSANKEY}
\alias{plotSANKEY,ClustAllObject,character,logicalOrNA-method}
\title{Visualize Stratification Comparisons with Sankey Diagram}
\usage{
plotSANKEY(Object, clusters, validationData = FALSE)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this function.}

\item{clusters}{A character vector specifying the names of stratifications to compare.
If validationData is FALSE, exactly two stratification names should be provided.
If validationData is TRUE, provide one stratification name to compare with true labels.}

\item{validationData}{Logical. If TRUE, compares the specified stratification with
the true labels (validation data) if available. Default is FALSE.}
}
\value{
A Sankey plot showing the composition and flow of clusters between
the selected stratifications. If true labels are available and
“validationData” is TRUE, the plot will compare the selected stratification
against the true labels.
}
\description{
This function generates a Sankey diagram to visualize the relationships between
different stratifications or between a stratification and the true labels (if available).
It provides an intuitive representation of how samples are distributed across
clusters in different stratifications or how they align with known stratifications.
}
\details{
The plotSANKEY function provides a powerful visualization tool for understanding
the relationships between different clustering solutions or between a clustering
solution and known classifications:

\enumerate{
  \item Stratification Comparison (validationData = FALSE):
  \itemize{
    \item Visualizes how samples are distributed across clusters in two different stratifications.
    \item Helps identify similarities and differences between clustering solutions.
    \item Useful for understanding how changes in clustering parameters affect sample groupings.
  }

  \item Validation Comparison (validationData = TRUE):
  \itemize{
    \item Compares a single stratification with true labels (if available).
    \item Helps assess how well the clustering aligns with known stratifications.
    \item Useful for evaluating the biological or clinical relevance of a clustering solution.
  }
}

The Sankey diagram represents:
\itemize{
  \item Clusters (or true labels) as nodes on the left and right sides of the diagram.
  \item Flows between nodes indicating how samples are distributed.
  \item The width of each flow is proportional to the number of samples it represents.
}

This visualization is particularly useful for:
\itemize{
  \item Identifying stable sample groupings across different stratifications.
  \item Detecting major shifts in cluster assignments between solutions.
  \item Evaluating the concordance between clustering results and known stratifications.
  \item Understanding the impact of different clustering approaches on sample groupings.
}
}
\note{
\itemize{
  \item This function requires a processed ClustAllObject. Ensure
    \code{\link{runClustAll}}
    has been executed before using plotSANKEY.
  \item When validationData is TRUE, the ClustAllObject must contain validation data
    (true labels). This can be added using \code{\link{addValidationData}} if not
    provided during object creation.
  \item Stratification names can be obtained from the results of
    \code{\link{resStratification}}
    or by examining the names in the summary_clusters slot of the ClustAllObject.
  \item The Sankey diagram may become cluttered if there are many clusters or if the
    clustering solutions are very different. In such cases, consider focusing on
    specific subsets of clusters or using additional filtering criteria.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
label <- as.numeric(as.factor(wdbc$Diagnosis))
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
label <- label[16:30]
obj_noNA <- createClustAll(data = wdbc)
\donttest{
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
resStratification(Object = obj_noNA1, population = 0.05,
                  stratification_similarity = 0.88, all = FALSE)
plotSANKEY(Object = obj_noNA1, clusters = c("cuts_a_1","cuts_b_5"))

obj_noNA1 <- addValidationData(obj_noNA1, label)
plotSANKEY(Object = obj_noNA1, clusters = "cuts_a_1", validationData=TRUE)
}

}
\seealso{
\code{\link{runClustAll}}, \code{\link{resStratification}},
\code{\link{addValidationData}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{wdbcNA}
\alias{wdbcNA}
\title{wdbcNA: Diagnostic Wisconsin Breast Cancer Database with missing values}
\format{
A data frame with 660 rows and 31 variables
}
\usage{
data("BreastCancerWisconsinMISSING", package = "ClustAll")
}
\value{
wdbcNA dataset
}
\description{
The "wdbcNA" dataset is a modified version of the Breast Cancer Wisconsin
(Diagnostic) dataset (\code{\link{wdbc}}), incorporating missing values at
random. This dataset is designed to demonstrate and evaluate the handling
of missing data in the context of breast cancer diagnosis.
}
\details{
The dataset retains the same structure as the original "wdbc" dataset, with
569 patients and 32 variables. However, some values in the numerical features
have been randomly replaced with missing values (NA).

For a detailed description of the features and the original dataset, please
refer to the documentation of the "wdbc" dataset (\code{\link{wdbc}}).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{extractData}
\alias{extractData}
\alias{extractData,ClustAllObject-method}
\title{extractData}
\usage{
extractData(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
A list containing three elements:
\itemize{
  \item Data_modified: A data frame of the preprocessed data used for clustering.
  \item Data_original: A data frame of the original, unmodified input data.
  \item Data_imputed: A 'mids' object from the mice package containing imputed
    datasets, if imputation was performed. NULL otherwise.
}
}
\description{
This function retrieves all data components stored in a
\code{\link{ClustAllObject-class}},
including the preprocessed data, original input data, and imputed datasets
(if applicable). It provides a comprehensive view of the data at different
stages of the ClustALL pipeline.
}
\details{
The extractData function provides access to data at various stages of the
ClustALL pipeline:
\itemize{
  \item Data: Reflects preprocessing steps such as one-hot encoding
    for categorical variables and removal of the validation column.
  \item DataOriginal: The exact data as input to \code{\link{createClustAll}},
    useful for reference and verifying preprocessing steps.
  \item Data_imputed: Multiple imputed datasets if missing data was present
    and imputation was performed.
}
This function is particularly useful for:
\itemize{
  \item Verifying preprocessing steps and their effects on the data.
  \item Accessing original data for additional analyses or visualizations.
  \item Examining imputed datasets to understand how missing data was handled.
  \item Exporting data at different stages for use in other analyses or packages.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
\donttest{
obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
extractData(obj_noNA)
}
}
\seealso{
\code{\link{createClustAll}}, \code{\link{ClustAllObject-class}},
\code{\link{runClustAll}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{class}
\name{ClustAllObject-class}
\alias{ClustAllObject-class}
\title{ClustAllObject}
\value{
ClustAllObject class object.
}
\description{
The ClustAllObject class is the central data structure of the ClustAll
package, designed to store and manage data and results throughout the patient
stratification process. It encapsulates the original data, preprocessed data,
imputation results, and clustering outcomes, providing a cohesive framework
for the entire ClustALL workflow.
}
\details{
The ClustAllObject is designed to efficiently manage all aspects of the data
and results throughout the ClustAll pipeline:
\itemize{
  \item It preserves the original data while storing preprocessed versions for analysis.
  \item It handles missing data through multiple imputation, storing both original and imputed datasets.
  \item It maintains separation between data used for clustering and validation data.
  \item It stores all generated stratifications and identifies robust solutions.
  \item It provides a framework for comparing different stratification solutions.
}
This structure allows for a streamlined workflow from data input through
preprocessing, imputation (if needed), stratification, and final analysis of
results.
}
\section{Slots}{

\describe{
\item{\code{data}}{A data frame containing the preprocessed input data after applying
one-hot encoding to categorical variables and removing the validation column
(if present). This is the data used directly in the clustering process.}

\item{\code{dataOriginal}}{A data frame containing the original, unmodified input data
as provided to \code{\link{createClustAll}}. This preserves the initial state
of the data for reference and validation purposes.}

\item{\code{dataImputed}}{If imputation was applied, this slot contains a 'mids' object
from the mice package with the imputed datasets. If no imputation was performed,
this is NULL.}

\item{\code{dataValidation}}{A numeric vector containing the reference labels (true labels)
of the original dataset, if provided. These labels are used for validation purposes
and are not used in the stratification process itself. NULL if no validation data
is available.}

\item{\code{nImputation}}{An integer indicating the number of imputations to be
computed. It should be set to 0 if the dataset is already completed, or if it
the dataset has been imputed out of ClustAll framework.}

\item{\code{processed}}{A logical flag. TRUE if \code{\link{runClustAll}} has been
executed on the object, FALSE otherwise. Indicates whether the object contains
stratification results.}

\item{\code{summary_clusters}}{A list containing the resulting stratifications for each
combination of clustering methods (distance metric + clustering algorithm) and
embedding depth. This is populated after \code{\link{runClustAll}} has been
executed. NULL otherwise.}

\item{\code{JACCARD_DISTANCE_F}}{A matrix of Jaccard distances between the robust
stratifications that passed the bootstrapping process. Used to assess similarity
between different stratification solutions. NULL if \code{\link{runClustAll}}
has not been executed.}
}}

\note{
The ClustAllObject is typically created using the
\code{\link{createClustAll}} function and processed using
\code{\link{runClustAll}}. Direct manipulation of the object's slots is not
recommended as it may lead to inconsistencies in the analysis pipeline.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{class}
\name{matrixOrNULL-class}
\alias{matrixOrNULL-class}
\title{Class Union: matrixOrNULL}
\description{
This class union allows for flexibility in method signatures and slot
definitions by accepting either a matrix or NULL. It is particularly useful
when a slot or function parameter might contain a matrix of data but could
also be empty or explicitly set to NULL.
}
\details{
The matrixOrNULL class union includes:
\itemize{
  \item matrix: A standard R matrix object
  \item NULL: Representing an empty or unset value
}

This union is useful in scenarios where:
\itemize{
  \item A function might return a matrix of results or NULL if no results are available
  \item A slot in an S4 object could contain a matrix of data or be empty
  \item A function parameter could accept a matrix input, but also work with default settings if nothing is provided
}
}
\seealso{
\code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_createClustAll.R
\name{createClustAll}
\alias{createClustAll}
\alias{createClustAll,data.frame,numericOrNA,ANY,characterOrNA-method}
\title{Create ClustAllObject for Patient Stratification Analysis}
\usage{
createClustAll(data, nImputation = NULL, dataImputed = NULL,
                      colValidation = NULL)
}
\arguments{
\item{data}{A data frame containing the input data. It may include missing
values (NAs) and can contain both numeric and categorical variables.}

\item{nImputation}{An integer specifying the number of imputations to perform
if the data contains missing values. Default is NULL, which means no imputation
unless missing values are detected.}

\item{dataImputed}{A 'mids' object created by the mice package, containing
pre-computed imputations. If provided, this will be used instead of performing
new imputations. Default is NULL.}

\item{colValidation}{A character string specifying the name of the column in
'data' that contains validation labels (true classifications). This column
will be extracted and stored separately. Default is NULL.}
}
\value{
An unprocessed ClustAllObject without stratification results. Use
runClustAll on this object to execute the ClustAll pipeline.
}
\description{
This function initializes a ClustAllObject, which serves as the core data
structure for the ClustAll package. It preprocesses the input data, handles
missing values through imputation if necessary, and prepares the data for
subsequent clustering analysis.
}
\details{
The createClustAll function performs several key steps in preparing data for
the ClustAll analysis pipeline:

\enumerate{
  \item Data Preprocessing:
  \itemize{
    \item Applies one-hot encoding to categorical variables, converting them to
          a format suitable for clustering algorithms.
    \item Extracts the validation column (if specified) and stores it separately.
  }

  \item Missing Data Handling:
  \itemize{
    \item If the data contains missing values and no imputed data is provided,
          it performs multiple imputation using the mice package.
    \item The number of imputations is determined by the 'nImputation' parameter
          or set to a default if not specified.
  }

  \item Object Initialization:
  \itemize{
    \item Creates a new ClustAllObject with slots for original data, processed data,
          imputed data (if applicable), and validation data (if provided).
  }
}

The function accommodates three main scenarios:
\itemize{
  \item Data without missing values: Preprocessing is applied, no imputation needed.
  \item Data with missing values, no pre-computed imputations: Automatic imputation is performed.
  \item Data with missing values and pre-computed imputations: The provided imputations are used.
}
}
\note{
\itemize{
  \item Categorical variables in the input data should be coded as factors.
  \item If 'dataImputed' is provided, it must correspond exactly to the input data
        in terms of dimensions and variable names.
  \item The 'colValidation' parameter allows for the incorporation of known
        classifications, which can be used later for validating clustering results.
  \item After creating the ClustAllObject, use \code{\link{runClustAll}} to perform
        the actual clustering analysis.
}
}
\examples{
# Scenario 1: data does not contain missing values
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- wdbc[,-c(1,2)]
obj_noNA <- createClustAll(data = wdbc)

# Scenario 2: data contains NAs and there is no imputed data.
# Then it performs the imputations automatically
data("BreastCancerWisconsinMISSING", package = "ClustAll")
\donttest{
obj_NA <- createClustAll(wdbcNA, nImputation = 2)
}
# Scenario 3: data contains NAs and imputed data is provided manually
data("BreastCancerWisconsinMISSING", package = "ClustAll")
ini <- mice::mice(wdbcNA, maxit = 0, print = FALSE)
pred <- ini$pred # predictor matrix
pred["radius1", c("perimeter1", "area1", "smoothness1")] <- 0 # example of
# how to remove predictors
\donttest{
imp <- mice::mice(wdbcNA, m=5, pred=pred, maxit=5, seed=1234, print=FALSE)
obj_imp <- createClustAll(data=wdbcNA, dataImputed = imp)
}

}
\seealso{
\code{\link{runClustAll}}, \code{\link{ClustAllObject-class}},
\code{\link{addValidationData}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Methods.R
\name{resStratification}
\alias{resStratification}
\alias{resStratification,ClustAllObject,numericOrNA,logicalOrNA,numericOrNA-method}
\title{Extract Representative Stratifications from ClustAllObject}
\usage{
resStratification(Object, population = 0.05, all = FALSE,
                         stratification_similarity = 0.7)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this function.}

\item{population}{Numeric value between 0 and 1. Specifies the minimum
proportion of the total population that a cluster within a stratification must
contain to be considered valid. Default is 0.05.}

\item{all}{A logical value. If set to TRUE, the function will return all
stratification representatives that meet the robustness criteria of each
group of similar stratifications. If set to FALSE, only the centroid
stratification (the central that serves as the representative stratification)
for each group of similar stratifications will be returned.}

\item{stratification_similarity}{Numeric value between 0 and 1. Sets the
threshold Jaccard distance for considering two stratifications as similar.
Default is 0.7. Higher values result in more stringent similarity criteria.}
}
\value{
A list of representative stratifications and their associated clusters.
The structure of the return value depends on the 'all' parameter:
\itemize{
  \item If all = FALSE: A named list where each element represents the centroid
    stratification for a group of similar stratifications.
  \item If all = TRUE: A nested list where each top-level element represents a group
    of similar stratifications, and contains all stratifications in that group.
}
Each stratification is represented by a table showing the distribution of
patients across clusters.
}
\description{
This function retrieves and filters representative stratifications from a
processed ClustAllObject. It allows users to explore the most robust and
significant clustering solutions generated by the ClustALL algorithm, based
on population size criteria and stratification similarity.
}
\details{
The resStratification function performs several key steps:

\enumerate{
  \item Filters stratifications based on the 'population' parameter, ensuring that
    each cluster in a stratification contains at least the specified proportion
    of the total population.
  \item Groups similar stratifications based on their Jaccard distances, using the
    'stratification_similarity' threshold.
  \item For each group of similar stratifications:
  \itemize{
    \item If all = FALSE, selects the centroid (most representative) stratification.
    \item If all = TRUE, includes all stratifications in the group.
  }
}

This function is particularly useful for:
\itemize{
  \item Identifying the most robust and significant clustering solutions.
  \item Reducing the number of stratifications to a manageable set for further analysis.
  \item Exploring how different similarity thresholds affect the grouping of stratifications.
  \item Comparing multiple similar stratifications within each group (when all = TRUE).
}
}
\note{
\itemize{
  \item This function requires a processed ClustAllObject. Ensure
    \code{\link{runClustAll}}
    has been executed before using resStratification.
  \item The 'population' parameter helps filter out stratifications with very small,
    potentially insignificant clusters.
  \item The 'stratification_similarity' parameter allows for fine-tuning the balance
    between diversity and similarity in the returned stratifications.
  \item When exploring results, it's often useful to try different combinations of
    'population' and 'stratification_similarity' values to understand the
    characteristics of your clustering solutions.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
\donttest{
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
resStratification(Object = obj_noNA1, population = 0.05,
                  stratification_similarity = 0.88, all = FALSE)
}

}
\seealso{
\code{\link{runClustAll}}, \code{\link{plotJACCARD}},
\code{\link{cluster2data}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{wdbcMIDS}
\alias{wdbcMIDS}
\title{wdbcMIDS: Diagnostic Wisconsin Breast Cancer Database with imputed values}
\format{
A data frame with 660 rows and 31 variables
}
\usage{
data("BreastCancerWisconsinMISSING", package = "ClustAll")
}
\value{
wdbcMIDS dataset
}
\description{
The "wdbcMIDS" dataset is an imputed version of the "wdbcNA" dataset, which is
a modified version of the Breast Cancer Wisconsin (Diagnostic) dataset
(\code{\link{wdbc}}) with missing values introduced at random. The missing values
have been imputed using the Multiple Imputation by Chained Equations (MICE)
algorithm, resulting in a "mids" object manually.
}
\details{
For more information on the original dataset and the version with missing values,
please refer to the documentation of the "wdbc" (\code{\link{wdbc}}).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{dataImputed}
\alias{dataImputed}
\alias{dataImputed,ClustAllObject-method}
\title{Retrieve Imputed Data from ClustAllObject}
\usage{
dataImputed(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
A 'mids' object from the mice package containing the imputed datasets.
If no imputation was performed, the method returns NULL.
}
\description{
This method extracts and returns the imputed datasets stored in a ClustAllObject.
It provides access to the multiple imputed versions of the data generated to
handle missing values, if imputation was conducted and included in the object.
}
\details{
The dataImputed method provides access to the imputed data used in the ClustALL
analysis pipeline when missing values are present. Key aspects of this data include:

\enumerate{
  \item Imputation Structure:
  \itemize{
    \item Returns a 'mids' object, which contains multiple imputed datasets.
    \item Each imputed dataset is a complete version of the original data with
          missing values filled in.
    \item The number of imputed datasets corresponds to the 'nImputation' parameter.
  }

  \item Imputation Method:
  \itemize{
    \item Imputation is performed using the mice (Multivariate Imputation by Chained
          Equations) package.
    \item The specific imputation methods used for each variable can be examined
          in the returned 'mids' object.
  }

  \item Data Consistency:
  \itemize{
    \item The imputed datasets maintain the same structure (rows and columns) as
          the original data.
    \item Only variables with missing values are imputed; complete variables remain unchanged.
  }
}#'
}
\examples{
data("BreastCancerWisconsinMISSING", package = "ClustAll")
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
obj_NA <- createClustAll(data = wdbcNA, colValidation = "Diagnosis",
                         dataImputed = wdbcMIDS)
dataImputed(obj_NA)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{showData}},
\code{\link{dataOriginal}}, \code{\link{ClustAllObject-class}},
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Methods.R
\name{validateStratification}
\alias{validateStratification}
\alias{validateStratification,ClustAllObject,characterOrNA-method}
\title{Validate Stratification Results Against True Labels}
\usage{
validateStratification(Object, stratificationName)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} and contain validation
data (true labels).}

\item{stratificationName}{A character string specifying the name of the
stratification to be validated. This should correspond to a stratification
generated by the ClustALL algorithm and stored in the Object.}
}
\value{
A named numeric vector containing two elements:
\itemize{
  \item sensitivity: The proportion of true positive classifications
  \item specificity: The proportion of true negative classifications
}
}
\description{
This function calculates the sensitivity and specificity of a selected
stratification by comparing it to the true labels (validation data) stored
in the ClustAllObject. It provides a quantitative assessment of how well
the clustering aligns with known classifications.
}
\details{
The validateStratification function provides a crucial step in assessing the
biological or clinical relevance of clustering results:

\enumerate{
  \item Comparison Mechanism:
  \itemize{
    \item The function compares the cluster assignments of the selected stratification
      with the true labels provided in the validation data.
    \item It treats the problem as a binary classification task, considering one
      class as the "positive" class and all others as "negative".
  }

  \item Sensitivity (True Positive Rate):
  \itemize{
    \item Measures the proportion of actual positive cases that were correctly identified.
    \item Calculated as: (True Positives) / (True Positives + False Negatives)
  }

  \item Specificity (True Negative Rate):
  \itemize{
    \item Measures the proportion of actual negative cases that were correctly identified.
    \item Calculated as: (True Negatives) / (True Negatives + False Positives)
  }

  \item Interpretation:
  \itemize{
    \item Higher sensitivity indicates better identification of the positive class.
    \item Higher specificity indicates better identification of the negative classes.
    \item The function automatically adjusts calculations if necessary to ensure
      sensitivity and specificity are always higher than 0.5.
  }
}

This function is particularly useful for:
\itemize{
  \item Evaluating the clinical or biological relevance of clustering solutions
  \item Comparing different stratifications based on their alignment with known classifications
  \item Identifying stratifications that best capture known groupings in the data
  \item Providing quantitative metrics to support the selection of optimal clustering solutions
}
}
\note{
\itemize{
  \item This function requires a processed ClustAllObject with validation data.
    Ensure \code{\link{runClustAll}} has been executed and validation data
    has been added using \code{\link{addValidationData}} if not provided during
    object creation.
  \item The function assumes binary classification. For multi-class problems, it
    effectively treats one class as "positive" and all others as "negative".
  \item Stratification names can be obtained from the results of \code{\link{resStratification}}
    or by examining the names in the summary_clusters slot of the ClustAllObject.
  \item The function will stop with an error if the ClustAllObject does not contain
    validation data or if the specified stratification name is not found.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
label <- as.numeric(as.factor(wdbc$Diagnosis))
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
label <- label[16:30]
obj_noNA <- createClustAll(data = wdbc)
\donttest{
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
resStratification(Object = obj_noNA1, population = 0.05,
                  stratification_similarity = 0.88, all = FALSE)
obj_noNA1 <- addValidationData(Object = obj_noNA1,
                               dataValidation = label)
validateStratification(obj_noNA1, "cuts_a_1")
}

}
\seealso{
\code{\link{runClustAll}}, \code{\link{resStratification}},
\code{\link{addValidationData}}, \code{\link{plotSANKEY}},
\code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{show,ClustAllObject-method}
\alias{show,ClustAllObject-method}
\title{Display Summary of ClustAllObject}
\usage{
\S4method{show}{ClustAllObject}(object)
}
\arguments{
\item{object}{A \code{\link{ClustAllObject-class}} object to be summarized.}
}
\value{
No return value, called for printing to the console.
}
\description{
This method provides a concise summary of a ClustAllObject, displaying key
information about its contents and processing status. It offers a quick
overview of the object's characteristics without the need to inspect
individual slots.
}
\details{
The show method for ClustAllObject displays the following information:

\enumerate{
  \item Object Class: Confirms that the object is of class ClustAllObject.

  \item Data Dimensions:
  \itemize{
    \item Number of variables (columns) in the processed data.
    \item Number of patients (rows) in the dataset.
  }

  \item Imputation Status:
  \itemize{
    \item Indicates whether the data has been imputed.
    \item If imputed, shows the number of imputations performed.
  }

  \item Processing Status:
  \itemize{
    \item Indicates whether the ClustALL algorithm has been run on the object.
  }

  \item Stratification Results:
  \itemize{
    \item If processed, displays the number of stratifications generated.
    \item If not processed, indicates that stratification results are not available.
  }
}

This method is particularly useful for:
\itemize{
  \item Quick verification of object contents after creation or modification.
  \item Checking the processing status before running analyses.
  \item Confirming the number of stratifications generated after running the ClustALL algorithm.
  \item Easily sharing key object characteristics in reports or discussions.
}
}
\note{
\itemize{
  \item This method is automatically called when the object name is entered at the R console.
  \item It provides a high-level overview and does not display detailed data or results.
  \item For more detailed information about specific aspects of the object, use
    dedicated accessor methods or examine individual slots directly.
}
}
\seealso{
\code{\link{createClustAll}}, \code{\link{runClustAll}},
\code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{initialize,ClustAllObject-method}
\alias{initialize,ClustAllObject-method}
\title{initializeClustAllObject}
\usage{
\S4method{initialize}{ClustAllObject}(
  .Object,
  data,
  dataOriginal,
  dataImputed,
  dataValidation,
  nImputation,
  processed,
  summary_clusters,
  JACCARD_DISTANCE_F
)
}
\arguments{
\item{.Object}{initializing object}

\item{data}{Data Frame of the input data after applying one-hot encoding to the
categorical variables and extracting the validation (true label) column.}

\item{dataOriginal}{Data Frame of the input data.}

\item{dataImputed}{Mids object derived from the mice package that stores the
imputed data, in case imputation was applied. Otherwise NULL.}

\item{dataValidation}{A vector in the case there is a validation (true label)
column in the input data. This information can be added later with
\code{\link{addValidationData}}. Otherwise NULL.}

\item{nImputation}{Number of imputations performed.}

\item{processed}{A boolean. TRUE if \code{\link{runClustAll}} has been
executed. Otherwise FALSE.}

\item{summary_clusters}{List with the resulting stratifications
for each combination of clustering methods (distance + clustering algorithm)
and depth, in case \code{\link{runClustAll}} has been executed previously.
Otherwise NULL.}

\item{JACCARD_DISTANCE_F}{Matrix containing the Jaccard distances derived from
the robust stratifications after applying the bootstrapping if
\code{\link{runClustAll}} has been executed previously. Otherwise NULL.}
}
\value{
ClustAllObject class object.
}
\description{
constuctor for \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_runClustAll.R
\name{runClustAll}
\alias{runClustAll}
\alias{runClustAll,ClustAllObject,numericOrNA,logicalOrNA-method}
\title{Execute ClustALL Algorithm on a ClustAllObject}
\usage{
runClustAll(Object, threads = 1, simplify = FALSE)
}
\arguments{
\item{Object}{An unprocessed \code{\link{ClustAllObject-class}} created by
\code{\link{createClustAll}}. The object should contain the original input
data and any preprocessed versions of it, but no stratification results yet.}

\item{threads}{An integer specifying the number of CPU cores to use for
parallel computing. Default is 1 (single-core processing).}

\item{simplify}{A logical value. If TRUE, only every fourth depth of the
dendrogram will be considered in the DCR and SP steps, reducing execution
time but potentially sacrificing detail. Default is FALSE.}
}
\value{
A processed \code{\link{ClustAllObject-class}} containing
stratification results from the ClustALL pipeline. The object's
summary_clusters and JACCARD_DISTANCE_F slots will be populated with results.
}
\description{
This function applies the ClustALL algorithm to the data stored in a
ClustAllObject. It performs a comprehensive analysis, generating multiple
patient stratifications based on various clustering methods and parameters.
The function implements the core steps of the ClustALL framework: Data
Complexity Reduction (DCR), Stratification Process (SP), and Consensus-based
Stratifications (CbS).
}
\details{
The runClustAll function implements the three main steps of the ClustALL
framework:

\enumerate{
  \item Data Complexity Reduction (DCR):
  \itemize{
    \item Creates multiple data embeddings to replace highly correlated variable
      sets with lower-dimension projections derived from Principal Component
      Analysis (PCA).
    \item Explores all relevant groupings derived from a hierarchical
      clustering-based dendrogram.
    \item Computes an embedding for each depth in the dendrogram.
  }

  \item Stratification Process (SP):
  \itemize{
    \item Calculates and preliminarily evaluates stratifications for each embedding.
    \item Computes a stratification for each feasible combination of embedding,
      dissimilarity metric, and clustering method.
    \item Determines the optimal number of clusters using three internal validation
      measures: sum-of-squares (WB-ratio), Dunn index, and average silhouette width.
  }

  \item Consensus-based Stratifications (CbS):
  \itemize{
    \item Filters out non-robust stratifications through bootstrapping.
    \item Excludes stratifications with less than 85% stability.
    \item Selects representatives of very similar outcomes from the remaining
      stratifications.
  }
}

The 'simplify' parameter, when set to TRUE, reduces computation time by
considering only every fourth depth of the dendrogram in the first and second
steps. While useful for preliminary results, it's recommended to set it to
FALSE for more robust and detailed results.
}
\note{
\itemize{
  \item This function modifies the input ClustAllObject in-place, populating it with
    stratification results.
  \item The process can be computationally intensive,
    especially for large datasets or when 'simplify' is set to FALSE.
  \item Consider using multiple threads for improved performance on multi-core systems.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
\donttest{
obj_noNA <- createClustAll(data = wdbc)
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
obj_noNA1
}
}
\seealso{
\code{\link{createClustAll}}, \code{\link{resStratification}},
\code{\link{plotJACCARD}}, \code{\link{cluster2data}},
\code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{obj_noNA1}
\alias{obj_noNA1}
\title{obj_noNA1: Processed wdbc dataset for testing purposed}
\format{
A processed ClustAllObject
}
\usage{
data("testData", package = "ClustAll")
}
\value{
ClustAllObject Object
}
\description{
The "obj_noNA1" dataset is a processed version of the Breast Cancer Wisconsin
(Diagnostic) dataset (\code{\link{wdbc}}), prepared for testing purposes and
used in the ClustAll package vignette. It has been processed using the ClustAll
package methods, which include data preprocessing, feature transformation, and
the application of clustering algorithms.
}
\details{
The "obj_noNA1" dataset can be used as a reference for users who want to
understand the ClustAll package workflow and replicate the analysis presented
in the vignette.

For more information on the original dataset, please refer to the
documentation of the "wdbc" (\code{\link{wdbc}}) dataset.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{addValidationData}
\alias{addValidationData}
\alias{addValidationData,ClustAllObject,numericOrCharacter-method}
\title{Add Validation Data to ClustAllObject}
\usage{
addValidationData(Object, dataValidation)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}

\item{dataValidation}{A numeric or character vector containing the validation
data (true labels) for the samples. The length of this vector must match the
number of rows in the original input data used in
\code{\link{createClustAll}}.}
}
\value{
An updated \code{\link{ClustAllObject-class}} object with the new
validation data added to the dataValidation slot.
}
\description{
This function adds or updates the validation data (true labels) in a
ClustAllObject. It allows users to incorporate known classifications or
groupings of samples after the object has been created, enabling subsequent
evaluation of clustering results against these true labels.
}
\details{
Adding validation data to a ClustAllObject is crucial for assessing the
performance of clustering results. This function allows for flexible
workflow where true labels can be incorporated at any stage of the analysis:
\itemize{
  \item It can be used to add validation data that was not available during
    initial object creation.
  \item It can also update existing validation data with new or corrected labels.
  \item The added data can be used with functions like
  \code{\link{validateStratification}}
    to evaluate clustering performance.
}
Key points to consider:
\itemize{
  \item The length of dataValidation must exactly match the number of samples
    in the original dataset.
  \item If the object already contains validation data, this function will
    overwrite it with the new data.
  \item Both numeric and character vectors are accepted, allowing for various
    types of classification schemes.
}
}
\note{
This function modifies the 'dataValidation' slot of the ClustAllObject in-place.
Always ensure that the provided validation data correctly corresponds to the
samples in your dataset to avoid misinterpretation of subsequent analyses.
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
label <- as.numeric(as.factor(wdbc$Diagnosis))
wdbc <- wdbc[,-c(1, 2)] # delete patients IDs & label
obj_noNA <- createClustAll(data = wdbc)
obj_noNA <- addValidationData(Object = obj_noNA,
                              dataValidation = label)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{dataValidation}},
\code{\link{validateStratification}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{wdbc}
\alias{wdbc}
\title{wdbc: Diagnostic Wisconsin Breast Cancer Database.}
\format{
A data frame with 660 rows and 31 variables
}
\source{
<https://archive.ics.uci.edu/dataset/17/breast+cancer+wisconsin+diagnostic>

\itemize{
  \item Diagnosis Label says tumor is malingnant or benignant
  \item radius. Mean of distances from the center to points on the perimeter
  \item perimeter
  \item area
  \item smoothness. Local variation in radius lengths
  \item compactness. (Perimeter^2 / Area) - 1.0
  \item concavity. Severity of concave portions of the contour
  \item concave points. Number of concave portions of the contour
  \item symmetry.
  \item fractal dimension. “Coastline approximation” - 1.
}
}
\usage{
data("BreastCancerWisconsin", package = "ClustAll")
}
\value{
wdbc dataset
}
\description{
The Breast Cancer Wisconsin (Diagnostic) dataset, also known as "wdbc", contains
features computed from digitized images of fine needle aspirates (FNA) of breast
masses. The features describe characteristics of the cell nuclei present in each image.
}
\details{
The dataset includes 569 patients, each characterized by 30 numerical features and one
categorical feature. The numerical features are computed from ten different measurements
of the cell nuclei, and each measurement is repeated three times, resulting in a total
of 30 features per patient (10 features x 3 measurements).

The categorical feature is the diagnosis, which indicates whether the tumor is
malignant (M) or benign (B). This feature serves as the target class for
classification tasks.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{nImputation}
\alias{nImputation}
\alias{nImputation,ClustAllObject-method}
\title{Retrieve Number of Imputations from ClustAllObject}
\usage{
nImputation(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
An integer indicating the number of imputations performed. Returns 0
if no imputations were required or performed.
}
\description{
This method returns the number of imputations performed when creating or
processing the ClustAllObject. It provides information about how missing data
was handled in the ClustALL pipeline.
}
\details{
The nImputation method provides insight into the multiple imputation strategy
used in the ClustALL analysis pipeline:

This method is particularly useful for:
\itemize{
  \item Verifying whether imputation was performed on the dataset.
  \item Understanding the extent of the imputation process.
  \item Assessing the potential impact of imputation on subsequent analyses.
  \item Reporting the methodology used in handling missing data.
}
}
\note{
\itemize{
  \item This method returns the value stored in the 'nImputation' slot of the ClustAllObject.
  \item A return value of 0 does not necessarily mean the original data had no
    missing values; it could also indicate that imputation was explicitly skipped.
  \item The number of imputations is typically set during the creation of the
    ClustAllObject with the \code{\link{createClustAll}} function.
  \item For accessing the actual imputed datasets, use the \code{\link{dataImputed}} method.
}#'
}
\examples{
data("BreastCancerWisconsinMISSING", package = "ClustAll")
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
obj_NA <- createClustAll(data = wdbcNA, colValidation = "Diagnosis",
                         dataImputed = wdbcMIDS)
nImputation(obj_NA)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{dataImputed}},
\code{\link{ClustAllObject-class}}, \code{\link[mice]{mice}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{dataValidation}
\alias{dataValidation}
\alias{dataValidation,ClustAllObject-method}
\title{Retrieve Validation Data from ClustAllObject}
\usage{
dataValidation(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}} or modified by \code{\link{addValidationData}}.}
}
\value{
A numeric vector containing the validation data (true labels) if available.
Returns NULL if no validation data has been added to the object.
}
\description{
This method extracts and returns the validation data (true labels) stored in
a ClustAllObject. These labels represent known classifications or groupings
of samples, which can be used to assess the performance of clustering results.
}
\details{
The dataValidation method provides access to the ground truth or reference
classifications for the samples in the dataset:

\enumerate{
  \item Validation Data Content:
  \itemize{
    \item Contains known classifications or groupings of samples.
    \item Typically represents biological, clinical, or other meaningful categorizations.
    \item Used as benchmarking to evaluate clustering performance.
  }

  \item Data Characteristics:
  \itemize{
    \item Returned as a numeric vector.
    \item Length matches the number of samples in the original dataset.
    \item Each element corresponds to a sample's true label or classification.
  }

  \item Availability and Source:
  \itemize{
    \item May be added during object creation via the colValidation parameter in \code{\link{createClustAll}}.
    \item Can be added later using the \code{\link{addValidationData}} function.
    \item If not available, the method returns NULL.
  }
}
}
\note{
\itemize{
  \item This method returns the data stored in the 'dataValidation' slot of the ClustAllObject.
  \item The validation data is not used in the clustering process itself; it is solely for evaluation purposes.
  \item If validation data was not provided during object creation or added later, this method will return NULL.
  \item Always check for NULL before using the returned data in calculations or visualizations.
  \item The interpretation and use of validation data depend on the specific context of your study.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
obj_noNA <- createClustAll(data = wdbc, colValidation="Diagnosis")
dataValidation(obj_noNA)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{addValidationData}},
\code{\link{validateStratification}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{heart_data}
\alias{heart_data}
\title{Heart Disease Dataset}
\format{
A data frame with 918 rows and 12 variables:
\describe{
  \item{Age}{Numeric. Age of the patient in years.}
  \item{Sex}{Categorical. Patient's gender (M = Male, F = Female).}
  \item{ChestPainType}{Categorical. Type of chest pain experienced (TA = Typical Angina, ATA = Atypical Angina, NAP = Non-Anginal Pain, ASY = Asymptomatic).}
  \item{RestingBP}{Numeric. Resting blood pressure in mm Hg.}
  \item{Cholesterol}{Numeric. Serum cholesterol in mg/dl.}
  \item{FastingBS}{Binary. Fasting blood sugar > 120 mg/dl (1 = true; 0 = false).}
  \item{RestingECG}{Categorical. Resting electrocardiogram results (Normal, ST = having ST-T wave abnormality, LVH = showing probable or definite left ventricular hypertrophy by Estes' criteria).}
  \item{MaxHR}{Numeric. Maximum heart rate achieved.}
  \item{ExerciseAngina}{Categorical. Exercise-induced angina (Y = Yes, N = No).}
  \item{Oldpeak}{Numeric. ST depression induced by exercise relative to rest.}
  \item{ST_Slope}{Categorical. The slope of the peak exercise ST segment (Up, Flat, Down).}
  \item{HeartDisease}{Binary. Output class (1 = heart disease, 0 = normal).}
}
}
\source{
Kaggle: https://www.kaggle.com/datasets/johnsmith88/heart-disease-dataset
}
\usage{
data("heart_data", package = "ClustAll")
}
\value{
heart dataset
}
\description{
The dataset comprises both categorical and numerical features derived from
medical examinations and patient history. Each row represents a patient,
characterized by 13 attributes, with the target variable indicating the
presence or absence of heart disease.
}
\details{
This dataset contains various medical and lifestyle attributes of patients,
along with their heart disease diagnosis status. It is commonly used for
predicting the presence of heart disease in patients.


This dataset is valuable for developing and testing machine learning models
for heart disease prediction. It includes a mix of demographic information,
vital signs, and results from various medical tests, making it a comprehensive
resource for studying factors associated with heart disease.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{class}
\name{numericOrCharacter-class}
\alias{numericOrCharacter-class}
\alias{numericOrCharacter}
\title{Class Union: numericOrCharacter}
\description{
This class union allows for flexibility in method signatures and slot
definitions by accepting either a numeric or character value. It is particularly
useful when a slot or function parameter might contain either numeric data
or character strings representing numbers or categories.
}
\details{
The numericOrCharacter class union includes:
\itemize{
  \item numeric: A standard R numeric value or vector
  \item character: A standard R character string or vector
}

This union is useful in scenarios where:
\itemize{
  \item A function might accept or return either numeric values or their string representations
  \item A slot in an S4 object could contain either numeric data or categorical labels
  \item A function needs to handle both numeric and character input flexibly
}
}
\seealso{
\code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{dataOriginal}
\alias{dataOriginal}
\alias{dataOriginal,ClustAllObject-method}
\title{Retrieve Original Unprocessed Data from ClustAllObject}
\usage{
dataOriginal(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
A data frame containing the original, unprocessed input data exactly
as it was provided when creating the ClustAllObject.
}
\description{
This method extracts and returns the original, unmodified data that was used
to create the ClustAllObject. It provides access to the raw input data before
any preprocessing steps were applied, including one-hot encoding, validation
column removal, or imputation.
}
\details{
The dataOriginal method serves as a reference point for the initial state of
the data in the ClustALL analysis pipeline. Key aspects of this data include:

\enumerate{
  \item Data Integrity:
  \itemize{
    \item Contains all original variables, including any that may have been removed
          or transformed during preprocessing.
    \item Preserves original data types (e.g., factors for categorical variables).
    \item Includes the validation column if it was present in the original data.
  }

  \item Missing Data:
  \itemize{
    \item Reflects the original state of missing values (NAs) in the dataset.
  }

  \item Data Structure:
  \itemize{
    \item Maintains the original row and column order of the input data.
    \item No transformations or encodings have been applied.
  }
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
dataOriginal(obj_noNA)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{showData}},
\code{\link{dataImputed}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{JACCARD_DISTANCE_F}
\alias{JACCARD_DISTANCE_F}
\alias{JACCARD_DISTANCE_F,ClustAllObject-method}
\title{Retrieve Jaccard Distance Matrix for Robust Stratifications}
\usage{
JACCARD_DISTANCE_F(Object)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this method.}
}
\value{
A square matrix where each element represents the Jaccard distance
between two robust stratifications. The row and column names correspond to
the names of the robust stratifications. Returns NULL if \code{\link{runClustAll}}
has not been executed on the object.
}
\description{
This method extracts and returns the matrix of Jaccard distances between
robust stratifications identified by the ClustALL algorithm. It provides a
quantitative measure of similarity between different clustering solutions
that have passed the bootstrapping process for population-based robustness.
}
\details{
The JACCARD_DISTANCE_F method provides crucial information about the similarity
structure of robust clustering solutions:

\enumerate{
  \item Jaccard Distance:
  \itemize{
    \item A measure of dissimilarity between sample sets, calculated as 1 minus the Jaccard coefficient.
    \item Ranges from 0 (identical stratifications) to 1 (completely different stratifications).
    \item Lower values indicate higher similarity between stratifications.
  }

  \item Matrix Structure:
  \itemize{
    \item Symmetric matrix with stratification names as row and column labels.
    \item Diagonal elements are always 0 (each stratification is identical to itself).
    \item Off-diagonal elements represent pairwise Jaccard distances.
  }

  \item Robust Stratifications:
  \itemize{
    \item Only includes stratifications that passed the bootstrapping process.
    \item Represents the most stable and reliable clustering solutions.
  }
}

This method is particularly useful for:
\itemize{
  \item Identifying groups of similar stratifications.
  \item Assessing the diversity of robust clustering solutions.
  \item Selecting representative stratifications for further analysis.
  \item Visualizing the relationships between different clustering outcomes.
  \item Input for further clustering or dimensionality reduction of stratifications.
}
}
\note{
\itemize{
  \item This method returns the data stored in the 'JACCARD_DISTANCE_F' slot of the ClustAllObject.
  \item It will return NULL if \code{\link{runClustAll}} has not been executed on the object.
  \item The Jaccard distance is calculated based on the co-occurrence of samples in clusters,
    not on the specific cluster labels.
  \item This matrix is often used as input for the \code{\link{plotJACCARD}} function
    to visualize the similarity structure of stratifications.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = FALSE)
JACCARD_DISTANCE_F(obj_noNA1)
}
\seealso{
\code{\link{runClustAll}}, \code{\link{plotJACCARD}},
\code{\link{resStratification}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{obj_noNA1simplify}
\alias{obj_noNA1simplify}
\title{obj_noNA1simplify: Processed wdbc dataset for testing purposed}
\format{
A processed ClustAllObject
}
\usage{
data("testData", package = "ClustAll")
}
\value{
ClustAllObject Object
}
\description{
The "obj_noNA1simplify" dataset is a processed version of the Breast Cancer Wisconsin
(Diagnostic) dataset (\code{\link{wdbc}}), prepared for testing purposes and used in
the ClustAll package vignette. It has been processed using the ClustAll package
methods with the `simplify` parameter set to TRUE, which reduces the computational
complexity of the clustering algorithms by considering only a subset of the
dendrogram depths.
}
\details{
The "obj_noNA1simplify" dataset can be used as a reference for users who want to
understand the ClustAll package workflow and replicate the simplified analysis
presented in the vignette.

For more information on the original dataset and the full processed version, please
refer to the documentation of the "wdbc" (\code{\link{wdbc}}).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{showData}
\alias{showData}
\alias{showData,ClustAllObject-method}
\title{Retrieve Processed Data from ClustAllObject}
\usage{
showData(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
A data frame containing the processed data used for clustering analysis.
This data reflects all preprocessing steps applied during object creation but
does not include any imputation that may have been performed.
}
\description{
This method extracts and returns the processed data stored in a ClustAllObject.
The data returned is the version used for clustering analysis, which has undergone
preprocessing steps such as one-hot encoding for categorical variables and
removal of the validation column (if present).
}
\details{
The showData method provides access to the core dataset used in the ClustALL
analysis pipeline. Key aspects of this data include:

\enumerate{
  \item Preprocessing Applied:
  \itemize{
    \item Categorical variables have been converted to numeric form via one-hot encoding.
    \item The validation column (if specified during object creation) has been removed.
  }

  \item Data Structure:
  \itemize{
    \item All columns are numeric, suitable for use in clustering algorithms.
    \item Row order corresponds to the original input data.
  }

  \item Missing Data:
  \itemize{
    \item The returned data may still contain missing values (NAs) if imputation
          was not performed.
    \item For imputed versions of the data, use the \code{\link{dataImputed}} method.
  }
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=-ID)
obj_noNA <- createClustAll(data = wdbc, colValidation = "Diagnosis")
showData(obj_noNA)
}
\seealso{
\code{\link{createClustAll}}, \code{\link{dataOriginal}},
\code{\link{dataImputed}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{class}
\name{numericOrNA-class}
\alias{numericOrNA-class}
\title{Class Union: numericOrNA}
\description{
This class union allows for flexibility in method signatures and slot
definitions by accepting either a numeric value, NULL, or a missing value.
It is particularly useful when a slot or function parameter might contain
a numeric value but could also be empty, unspecified, or explicitly set to NULL.
}
\details{
The numericOrNA class union includes:
\itemize{
  \item numeric: A standard R numeric value or vector
  \item NULL: Representing an empty or unset value
  \item missing: Allowing for unspecified parameters in function calls
}

This union is useful in scenarios where:
\itemize{
  \item A function might return a numeric result or NULL if no result is available
  \item A slot in an S4 object could contain a numeric value or be empty
  \item A function parameter could accept a numeric input, but also work with default settings if nothing is provided
}
}
\seealso{
\code{\link{setClassUnion}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{summary_clusters}
\alias{summary_clusters}
\alias{summary_clusters,ClustAllObject-method}
\title{Retrieve Summary of Clustering Results from ClustAllObject}
\usage{
summary_clusters(Object)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this method.}
}
\value{
A list where each element represents a stratification. Each stratification
is a vector of cluster assignments for each sample in the dataset. Returns NULL
if \code{\link{runClustAll}} has not been executed on the object.
}
\description{
This method extracts and returns a comprehensive summary of all clustering
results (stratifications) generated by the ClustALL algorithm. It provides
access to the complete set of clustering solutions, including both robust
and non-robust stratifications.
}
\details{
The summary_clusters method provides access to all clustering results generated
during the ClustALL analysis:

\enumerate{
  \item Comprehensive Results:
  \itemize{
    \item Includes all stratifications generated, regardless of their robustness.
    \item Each stratification represents a unique combination of data embedding,
          distance metric, clustering algorithm, and number of clusters.
  }

  \item Stratification Structure:
  \itemize{
    \item Each element in the returned list is named according to the parameters
          used to generate it (e.g., "cuts_a_1" for the first cut using method 'a').
    \item Each stratification is a vector of integers, where each integer represents
          a cluster assignment for a sample.
  }

  \item Analysis Possibilities:
  \itemize{
    \item Allows for comparison of different clustering solutions.
    \item Enables examination of how different algorithm parameters affect clustering outcomes.
    \item Facilitates identification of consistent patterns across multiple stratifications.
  }
}

This method is particularly useful for:
\itemize{
  \item Accessing the full range of clustering solutions for in-depth analysis.
  \item Comparing robust stratifications (identified by other methods) with the full set of results.
  \item Extracting specific stratifications for further analysis or visualization.
}
}
\note{
\itemize{
  \item This method returns the data stored in the 'summary_clusters' slot of the ClustAllObject.
  \item It will return NULL if \code{\link{runClustAll}} has not been executed on the object.
  \item The returned list includes all stratifications, not just those deemed robust.
    For accessing only robust stratifications, consider using the \code{\link{resStratification}} function.
  \item The order and naming of stratifications in the returned list correspond to
    the order in which they were generated during the ClustALL process.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = FALSE)
summary_clusters(obj_noNA1)
}
\seealso{
\code{\link{runClustAll}}, \code{\link{resStratification}},
\code{\link{JACCARD_DISTANCE_F}}, \code{\link{ClustAllObject-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Methods.R
\name{cluster2data}
\alias{cluster2data}
\alias{cluster2data,ClustAllObject,character-method}
\title{Export Stratification Results with Original Data}
\usage{
cluster2data(Object, stratificationName)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object.
The object must have been processed by \code{\link{runClustAll}} before using
this function.}

\item{stratificationName}{A character vector specifying the names of one or more
stratifications to be exported. These names should correspond to stratifications
generated by the ClustALL algorithm and stored in the Object.}
}
\value{
A data.frame that includes the original data with additional column(s)
containing the selected stratification(s). Each selected stratification will
be added as a separate column to the original dataset.
}
\description{
This function combines the original input data with one or more selected
stratifications from the ClustALL algorithm results. It allows users to
examine how samples are clustered in the context of their original features,
facilitating further analysis and interpretation of the stratification
results.
}
\details{
The cluster2data function serves some important purposes in the ClustALL workflow:

1. Data Integration: It combines clustering results with the original feature data,
   allowing for comprehensive analysis of how cluster assignments relate to
   input variables.

2. Preparation for External Analysis: The resulting data frame can be easily
   exported for use in other analytical tools or visualization software.

The function is particularly useful for:
\itemize{
  \item Identifying features that distinguish different clusters
  \item Comparing how samples are grouped across different stratifications
  \item Preparing data for cluster-specific statistical analyses
  \item Creating visualizations that incorporate both cluster assignments and original features
}
}
\note{
\itemize{
  \item This function requires a processed ClustAllObject. Ensure \code{\link{runClustAll}}
    has been executed before using cluster2data.
  \item The stratificationName parameter accepts multiple stratification names, allowing
    for simultaneous export of multiple clustering solutions.
  \item Stratification names can be obtained from the results of \code{\link{resStratification}}
    or by examining the names in the summary_clusters slot of the ClustAllObject.
  \item The original data in the returned data frame includes all preprocessing steps
    applied during the creation of the ClustAllObject, such as one-hot encoding
    of categorical variables.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
\donttest{
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
resStratification(Object = obj_noNA1, population = 0.05,
                  stratification_similarity = 0.88, all = FALSE)
df <- cluster2data(Object = obj_noNA1,
                   stratificationName = c("cuts_a_1","cuts_b_5","cuts_a_5"))
}
}
\seealso{
\code{\link{runClustAll}}, \code{\link{resStratification}},
\code{\link{ClustAllObject-class}}, \code{\link{createClustAll}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\name{processed}
\alias{processed}
\alias{processed,ClustAllObject-method}
\title{Check Processing Status of ClustAllObject}
\usage{
processed(Object)
}
\arguments{
\item{Object}{A \code{\link{ClustAllObject-class}} object created by
\code{\link{createClustAll}}.}
}
\value{
A logical value:
\itemize{
  \item TRUE if \code{\link{runClustAll}} has been executed on the object.
  \item FALSE if the object has not yet been processed by \code{\link{runClustAll}}.
}
}
\description{
This method retrieves the processing status of a ClustAllObject, indicating
whether the ClustALL algorithm has been executed on the object. It provides a
quick way to verify if clustering results are available for analysis.
}
\details{
The processed method serves as a crucial indicator in the ClustALL workflow:

\enumerate{
  \item Processing Status:
  \itemize{
    \item Indicates whether the ClustALL algorithm has been applied to the object.
    \item A TRUE value means clustering results are available for analysis.
    \item A FALSE value indicates the object only contains input data and preprocessing.
  }

  \item Workflow Implications:
  \itemize{
    \item Helps determine which methods and analyses can be performed on the object.
    \item Guides users in the correct sequence of operations in the ClustALL pipeline.
  }

  \item Data Availability:
  \itemize{
    \item TRUE status implies availability of:
    \itemize{
      \item Stratification results (\code{\link{summary_clusters}})
      \item Jaccard distance matrix (\code{\link{JACCARD_DISTANCE_F}})
      \item Other clustering-related outputs
    }
    \item FALSE status means only input and preprocessed data are available.
  }
}
}
\note{
\itemize{
  \item This method checks the 'processed' slot of the ClustAllObject.
  \item The processed status is automatically set to TRUE when \code{\link{runClustAll}}
    completes successfully.
  \item Users should not manually modify this status to ensure consistency between
    the status and the actual content of the object.
  \item A FALSE status does not necessarily indicate an error; it simply means
    \code{\link{runClustAll}} needs to be executed before accessing clustering results.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
processed(obj_noNA)
}
\seealso{
\code{\link{runClustAll}}, \code{\link{createClustAll}},
\code{\link{ClustAllObject-class}}, \code{\link{summary_clusters}},
\code{\link{JACCARD_DISTANCE_F}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Methods.R
\name{plotJACCARD}
\alias{plotJACCARD}
\alias{plotJACCARD,ClustAllObject,logicalOrNA,numericOrNA-method}
\title{Visualize Jaccard Distances Between Robust Stratifications}
\usage{
plotJACCARD(Object, paint = TRUE, stratification_similarity = 0.7)
}
\arguments{
\item{Object}{A processed \code{\link{ClustAllObject-class}} object. The object
must have been processed by \code{\link{runClustAll}} before using this function.}

\item{paint}{Logical. If TRUE (default), the function highlights groups of
similar stratifications on the heatmap with red squares. This helps in
visually identifying clusters of similar stratifications.}

\item{stratification_similarity}{Numeric value between 0 and 1. Sets the
threshold Jaccard distance for considering two stratifications as similar.
Default is 0.7. Higher values result in more stringent similarity criteria.}
}
\value{
A plot displaying a correlation matrix heatmap that shows the Jaccard
Distances between population-based robust stratifications. The heatmap
visually distinguishes groups of similar stratifications according to the
specified “stratification_similarity” threshold.
}
\description{
This function generates a heatmap visualization of the Jaccard distances
between robust stratifications identified by the ClustALL algorithm. It
provides a visual representation of the similarity between different
clustering solutions, helping to identify groups of related stratifications.
}
\details{
The plotJACCARD function visualizes the similarity between robust
stratifications using a heatmap of Jaccard distances:

\itemize{
  \item The heatmap color scale represents Jaccard distances, with darker colors
    indicating higher similarity (lower distance).
  \item Stratifications are ordered based on hierarchical clustering of their
    Jaccard distances.
  \item The 'paint' option highlights groups of similar stratifications, making it
    easier to identify clusters of related solutions.
  \item The 'stratification_similarity' parameter allows fine-tuning of what is
    considered "similar" for the purpose of highlighting.
}

The function provides annotations for each stratification, including:
\itemize{
  \item Distance metric used (e.g., Correlation, Gower)
  \item Clustering method employed (e.g., H-Clustering, K-Means, K-Medoids)
  \item Depth of the dendrogram cut used in the Data Complexity Reduction step
}

This visualization is particularly useful for:
\itemize{
  \item Identifying groups of similar stratifications
  \item Assessing the overall diversity of robust solutions
  \item Guiding the selection of representative stratifications for further analysis
}
}
\note{
\itemize{
  \item This function requires a processed ClustAllObject.
    Ensure \code{\link{runClustAll}}
    has been executed before using plotJACCARD.
  \item The 'paint' feature may not be visible if there are no groups of stratifications
    meeting the similarity threshold.
  \item For exploring stratifications, it's recommended to start with a high
    'stratification_similarity' value and gradually decrease it to examine
    various levels of stratification grouping.
}
}
\examples{
data("BreastCancerWisconsin", package = "ClustAll")
wdbc <- subset(wdbc,select=c(-ID, -Diagnosis))
wdbc <- wdbc[1:15,1:8]
obj_noNA <- createClustAll(data = wdbc)
\donttest{
obj_noNA1 <- runClustAll(Object = obj_noNA, threads = 1, simplify = TRUE)
plotJACCARD(obj_noNA1, paint = TRUE, stratification_similarity = 0.9)
}
}
\seealso{
\code{\link{runClustAll}}, \code{\link{resStratification}},
\code{\link{ClustAllObject-class}}, \code{\link{JACCARD_DISTANCE_F}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ClustAll_ClustAllObject_Class.R
\docType{data}
\name{obj_noNAno1Validation}
\alias{obj_noNAno1Validation}
\title{obj_noNAno1Validation: Processed wdbc dataset for testing purposed}
\format{
A processed ClustAllObject
}
\usage{
data("testData", package = "ClustAll")
}
\value{
ClustAllObject Object
}
\description{
The "obj_noNAno1Validation" dataset is a processed version of the Breast
Cancer Wisconsin (Diagnostic) dataset (\code{\link{wdbc}}), prepared for
testing purposes and used in the ClustAll package vignette. It has been
processed using the ClustAll package methods, but with the validation data
removed.
}
\details{
The "obj_noNAno1Validation" dataset can be used as a reference for users who want
to understand the ClustAll package workflow and replicate the analysis presented
in the vignette, focusing on unsupervised learning aspects.

For more information on the original dataset and the processed version with
validation data, please refer to the documentation of the "wdbc"
(\code{\link{wdbc}}).
}
\keyword{datasets}
